import { ethers } from "ethers";
import { CollateralDetails, ProtocolContractAddressMap } from "../config";
import { Collateral, CollateralSymbol, CollateralToken } from "../types/collaterals";
import { SingleCollateralVaultNetwork, SingleCollateralVaultSymbol } from "..";
export type CollateralsConfig = {
    protocolAddresses: ProtocolContractAddressMap;
    collaterals: Partial<CollateralDetails>;
    chainId: number;
    graphEndpoint: string;
};
export default class Collaterals {
    tokens: CollateralToken[];
    private config;
    private graph;
    constructor(c?: CollateralsConfig);
    getCollateral: (collateralSymbol: CollateralSymbol, provider: ethers.providers.Provider) => Promise<Collateral>;
    getCollaterals: (provider: ethers.providers.Provider) => Promise<Collateral[]>;
    getIndexedCollaterals: () => Promise<Collateral[]>;
    getDepositAllowance: (collateralSymbol: CollateralSymbol, account: string, action: "deposit" | "mintAndDeposit", signer: ethers.Signer) => Promise<ethers.BigNumber>;
    getSingleCollateralDepositAllowance: (vaultSymbol: SingleCollateralVaultSymbol, account: string, network: SingleCollateralVaultNetwork, signer: ethers.Signer) => Promise<ethers.BigNumber>;
    setDepositAllowance: (collateralSymbol: CollateralSymbol, amount: ethers.BigNumber, action: "deposit" | "mintAndDeposit", signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    setSingleCollateralDepositAllowance: (vaultSymbol: SingleCollateralVaultSymbol, amount: ethers.BigNumber, network: SingleCollateralVaultNetwork, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    private getCollateralContract;
    private getCollateralMulticall;
    private toCollateral;
    private indexedToCollateral;
    private findAvailable;
}
