import { ethers } from "ethers";
import { FxTokenAddressMap } from "../config";
import { ProtocolContractAddressMap } from "../config";
import { FxKeeperPoolPool } from "../types/fxKeeperPool";
export type FxKeeperPoolConfig = {
    protocolAddresses: ProtocolContractAddressMap;
    fxTokenAddresses: FxTokenAddressMap;
    chainId: number;
};
type FxTokenArg = {
    fxTokenSymbol: string;
};
type StakeArgs = FxTokenArg & {
    amount: ethers.BigNumber;
};
export default class FxKeeperPool {
    config: FxKeeperPoolConfig;
    constructor(c?: FxKeeperPoolConfig);
    getPool: (account: string | undefined, fxTokenSymbol: string, provider?: ethers.providers.Provider) => Promise<FxKeeperPoolPool>;
    getPools: (account: string | undefined, provider?: ethers.providers.Provider) => Promise<FxKeeperPoolPool[]>;
    stake: (args: StakeArgs, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    unstake: (args: StakeArgs, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    claim: (args: FxTokenArg, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    private getFxKeeperPoolMulticall;
    private toFxKeeperPoolPool;
    private getContract;
}
export {};
