import { ethers } from "ethers";
import { FxTokenAddressMap, ProtocolContractAddressMap } from "../config";
import { FxToken } from "../types/fxTokens";
import { SingleCollateralVaultNetwork } from "..";
export type FxTokensConfig = {
    protocolAddresses: ProtocolContractAddressMap;
    fxTokenAddresses: FxTokenAddressMap;
    chainId: number;
    graphEndpoint: string;
};
export default class FxTokens {
    tokens: Omit<FxToken, "price">[];
    private config;
    private graph;
    constructor(c?: FxTokensConfig);
    getFxTokens: (provider: ethers.providers.Provider) => Promise<FxToken[]>;
    getIndexedFxTokens: () => Promise<FxToken[]>;
    getRepayAllowance: (fxToken: string, account: string, signer: ethers.Signer) => Promise<ethers.BigNumber>;
    getSingleCollateralRepayAllowance: (fxToken: string, account: string, network: SingleCollateralVaultNetwork, signer: ethers.Signer) => Promise<ethers.BigNumber>;
    setRepayAllowance: (fxTokenSymbol: string, amount: ethers.BigNumber, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    setSingleCollateralRepayAllowance: (fxTokenSymbol: string, amount: ethers.BigNumber, network: SingleCollateralVaultNetwork, signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
    private getFxTokenMulticall;
    private includeTokenPrice;
    private indexedToFxToken;
    private getFxTokenContract;
}
