import { ethers } from "ethers";
import { ProtocolContractAddressMap } from "../config";
import { TokenInfo } from "@uniswap/token-lists";
export type ProtocolConfig = {
    forexTokenAddress: string;
    protocolAddresses: ProtocolContractAddressMap;
    chainId: number;
};
export type ProtocolParameters = {
    mintFee: ethers.BigNumber;
    burnFee: ethers.BigNumber;
    withdrawFee: ethers.BigNumber;
    depositFee: ethers.BigNumber;
    minimumMintingAmountAsEth: ethers.BigNumber;
};
export default class Vaults {
    private config;
    forexToken: TokenInfo & {
        symbol: "FOREX";
    };
    constructor(c?: ProtocolConfig);
    getProtocolParameters: (provider: ethers.providers.Provider) => Promise<ProtocolParameters>;
}
