import sdkConfig from "../config";
import { callMulticallObject, createMulticallProtocolContracts, } from "../utils/contract";
import { NETWORK_NAME_TO_CHAIN_ID } from "../constants";
import { HandleTokenManagerInstance } from "./token-manager/HandleTokenManager";
import { mustExist } from "../utils/general";
export default class Vaults {
    constructor(c) {
        this.getProtocolParameters = async (provider) => {
            const { provider: multicallProvider, contracts } = createMulticallProtocolContracts(this.config.protocolAddresses, this.config.chainId, provider);
            const multicall = {
                mintFee: contracts.handle.mintFeePerMille(),
                burnFee: contracts.handle.burnFeePerMille(),
                withdrawFee: contracts.handle.withdrawFeePerMille(),
                depositFee: contracts.handle.depositFeePerMille(),
                minimumMintingAmountAsEth: contracts.comptroller.minimumMintingAmount(),
            };
            return callMulticallObject(multicall, multicallProvider);
        };
        this.config = c || {
            forexTokenAddress: sdkConfig.forexAddress,
            protocolAddresses: sdkConfig.protocol.arbitrum.protocol,
            chainId: NETWORK_NAME_TO_CHAIN_ID.arbitrum,
        };
        // Protocol on arbitrum
        this.forexToken = mustExist(HandleTokenManagerInstance.getTokenBySymbol("FOREX", "arbitrum"), "Forex on arbitrum");
    }
}
