import { createSingleCollateralVault } from "../utils/vault";
export default class VaultController {
    constructor(currentVault, fxToken) {
        this.currentVault = currentVault;
        this.fxToken = fxToken;
        this.setDebt = (debt) => {
            this.vault = createSingleCollateralVault({
                ...this.vault,
                debt,
            }, this.fxToken);
        };
        this.addDebt = (amount) => {
            this.setDebt(this.currentVault.debt.add(amount));
        };
        this.removeDebt = (amount) => {
            this.setDebt(this.currentVault.debt.sub(amount));
        };
        this.setCollateralAmount = (amount) => {
            this.vault = createSingleCollateralVault({
                ...this.vault,
                collateral: {
                    ...this.currentVault.collateral,
                    amount,
                },
            }, this.fxToken);
        };
        this.addCollateral = (amount) => {
            this.setCollateralAmount(this.currentVault.collateral.amount.add(amount));
        };
        this.removeCollateral = (amount) => {
            this.setCollateralAmount(this.currentVault.collateral.amount.sub(amount));
        };
        this.resetCollateral = () => {
            this.vault = createSingleCollateralVault({
                ...this.vault,
                collateral: this.currentVault.collateral,
            }, this.fxToken);
        };
        this.vault = createSingleCollateralVault(currentVault, fxToken);
    }
}
