import { TokenInfo } from "@uniswap/token-lists";
import { BigNumber } from "ethers";
import { Network } from "../../../../types/network";
import { BalancerPoolType } from "../../../../types/lp";
import data from "../data.json";
export type BalancerPool = typeof data["balancer"][0];
type BalancerPoolPairBase = {
    id: string;
    poolType: BalancerPoolType;
    address: string;
    swapFee: number;
    tokenIn: string;
    tokenOut: string;
    decimalsIn: number;
    decimalsOut: number;
    balanceIn: number;
    balanceOut: number;
};
type BalancerWeightedPoolPairData = BalancerPoolPairBase & {
    weightIn: number;
    weightOut: number;
};
export declare const getBalancerPoolPairData: (network: Network, poolId: string, tokenIn: string, tokenOut: string) => Promise<BalancerWeightedPoolPairData>;
export declare const calculateBalancerWeightedPoolAmountOut: (sellAmount: BigNumber, poolPairData: BalancerWeightedPoolPairData) => BigNumber;
export declare const getBalancerPools: (token: string) => BalancerPool[];
export type BalancerPath = {
    tokenIn: TokenInfo;
    hlpBalancerToken: TokenInfo;
    tokenOut: TokenInfo;
    pool: BalancerPool;
};
export declare const getHlpToBalancerPath: (from: TokenInfo, to: TokenInfo) => BalancerPath;
export declare const getBalancerToHlpPath: (from: TokenInfo, to: TokenInfo) => BalancerPath;
export declare const doesHlpToBalancerPathExist: (from: TokenInfo, to: TokenInfo) => boolean;
export declare const doesBalancerToHlpPathExist: (from: TokenInfo, to: TokenInfo) => boolean;
export {};
