import { BigNumberish, ethers } from "ethers";
import { Network } from "../../../../types/network";
import data from "../data.json";
export type CurvePool = typeof data["curve"][0];
export declare const isValidCurvePoolSwap: (tokenIn: string, tokenOut: string) => Promise<boolean>;
export declare const getCurvePools: (token: string) => {
    name: string;
    factory: string;
    address: string;
    tokens: string[];
    underlying: string[];
    fee: number;
}[];
export declare const getCurvePoolsWithBothTokens: (token1: string, token2: string) => {
    name: string;
    factory: string;
    address: string;
    tokens: string[];
    underlying: string[];
    fee: number;
}[];
export type PsmToHlpToCurvePath = {
    peggedToken: string;
    fxToken: string;
    hlpToken: string;
    curveToken: string;
    pool: string;
    factory: string;
};
export declare const getPsmToHlpToCurvePath: (from: string, to: string, network: Network) => Promise<PsmToHlpToCurvePath>;
export type HlpToCurvePath = {
    hlpToken: string;
    hlpCurveToken: string;
    curveToken: string;
    pool: string;
    factory: string;
};
export declare const getHlpToCurvePath: (from: string, to: string, network: Network) => Promise<HlpToCurvePath>;
export declare const getCurveAmountOut: (pool: string, signerOrProvider: ethers.Signer | ethers.providers.Provider, tokenIn: string, tokenOut: string, amountIn: BigNumberish) => Promise<{
    amountOut: ethers.BigNumber;
    fees: number;
    amountOutWithoutFees: ethers.BigNumber;
}>;
