import { BigNumber, ContractTransaction, Overrides, Signer } from "ethers";
import { GovernanceLockData } from "../types/governanceLock";
type CreateLockArgs = {
    durationInSeconds: number;
    forexAmount: BigNumber;
};
type IncreaseLockDurationByArgs = {
    increaseDurationByInSeconds: number;
    currentUnlocksAt: BigNumber;
};
export declare const getData: (account: string | undefined, isRetired?: boolean) => Promise<GovernanceLockData>;
export declare const createLock: (args: CreateLockArgs, signer: Signer, options?: Overrides) => Promise<ContractTransaction>;
export declare const increaseLockedAmount: (forexAmount: BigNumber, signer: Signer, options?: Overrides) => Promise<ContractTransaction>;
export declare const increaseLockDurationBy: (args: IncreaseLockDurationByArgs, signer: Signer, options?: Overrides) => Promise<ContractTransaction>;
export declare const withdraw: (signer: Signer, options?: Overrides, isRetired?: boolean) => Promise<ContractTransaction>;
export {};
