import { ethers } from "ethers";
import { GraphQLClient } from "graphql-request/dist";
import { CollateralSymbol } from "../../../types/collaterals";
export type IndexedCollateral = {
    address: string;
    name: string;
    symbol: CollateralSymbol;
    chainId: number;
    mintCollateralRatio: ethers.BigNumber;
    interestRate: ethers.BigNumber;
    liquidationFee: ethers.BigNumber;
    totalBalance: ethers.BigNumber;
    rate: ethers.BigNumber;
    decimals: number;
    isValid: boolean;
};
export default class CollateralGraphClient {
    private client;
    private chainId;
    constructor(client: GraphQLClient, chainId: number);
    query: (filter: any) => Promise<IndexedCollateral[]>;
    private getQueryString;
}
