import { ethers } from "ethers";
import { GraphQLClient } from "graphql-request/dist";
export type IndexedFxKeeperPool = {
    address: string;
    fxToken: string;
    totalDeposits: ethers.BigNumber;
    depositorCount: ethers.BigNumber;
    liquidationsExecuted: ethers.BigNumber;
    collateralTokens: {
        address: string;
        amount: ethers.BigNumber;
    }[];
    collateralAddresses: string[];
};
export default class FxKeeperPoolGraphClient {
    private client;
    constructor(client: GraphQLClient);
    query: (filter: any) => Promise<IndexedFxKeeperPool[]>;
    private getQueryString;
}
