import { GraphQLClient } from "graphql-request/dist";
import FxTokenGraphClient from "./FxTokenGraphClient";
export type IndexedVault = {
    account: string;
    debt: string;
    fxToken: string;
    collateralTokens: {
        address: string;
        amount: string;
    }[];
    redeemableTokens: string;
    collateralAsEther: string;
    collateralRatio: string;
    minimumRatio: string;
    isRedeemable: boolean;
    isLiquidatable: boolean;
};
export default class VaultGraphClient {
    private client;
    private fxTokenGraphClient;
    constructor(client: GraphQLClient, fxTokenGraphClient: FxTokenGraphClient);
    queryOne: (filter: any) => Promise<IndexedVault>;
    query: (filter: any) => Promise<IndexedVault[]>;
    withLowestCRForEachFxToken: () => Promise<IndexedVault[]>;
    private getQueryString;
}
