import config from "../../config";
import { GraphQLClient } from "graphql-request/dist";
import FxTokenGraphClient from "./clients/FxTokenGraphClient";
import VaultGraphClient from "./clients/VaultGraphClient";
import FxKeeperPoolGraphClient from "./clients/FxKeeperPoolGraphClient";
import CollateralGraphClient from "./clients/CollateralGraphClient";
import { NETWORK_NAME_TO_CHAIN_ID } from "../..";
const graphNetwork = "arbitrum";
export default class Graph {
    constructor(endpoint) {
        const url = endpoint || config.theGraphEndpoints[graphNetwork].fx;
        const client = new GraphQLClient(url);
        this.fxTokens = new FxTokenGraphClient(client);
        this.vaults = new VaultGraphClient(client, this.fxTokens);
        this.fxKeeperPools = new FxKeeperPoolGraphClient(client);
        this.collateralGraphClient = new CollateralGraphClient(client, NETWORK_NAME_TO_CHAIN_ID[graphNetwork]);
    }
}
