import { Pair, PairStringified, WebsocketPrice } from "../../types/trade";
import { BigNumber } from "ethers";
import { SubscriptionId } from "../../types/general";
export type Options = {
    callback: (data: WebsocketPrice) => void;
    connect?: boolean;
    websocketUrl?: string;
    autoReconnect?: boolean;
    reconnectDelayMillis?: number;
    connectMaxAttempts?: number;
};
export type SubscriptionCallback = (pair: Pair, price: BigNumber) => any;
export type SubscriptionResponse = {
    subscriberId: SubscriptionId;
    prices: Promise<Record<PairStringified, BigNumber | undefined>>;
};
export declare const fetchPrices: (pairs: Pair[], forceSocketReconnection?: boolean) => Promise<Record<PairStringified, BigNumber | undefined>>;
export declare const fetchPrice: (pair: Pair) => Promise<BigNumber>;
export declare const subscribe: (pairs: Pair[], callback: SubscriptionCallback, forceSocketReconnection?: boolean) => SubscriptionResponse;
export declare const unsubscribe: (id: SubscriptionId) => void;
export declare const getLatestPrice: (pair: Pair) => BigNumber;
