import { Pair, SignedQuote } from "../../types/trade";
import { BytesLike } from "ethers";
import { Provider } from "@ethersproject/providers";
export type EncodedSignedQuote = {
    encoded: BytesLike;
    decoded: SignedQuote[];
};
type QuoteApiResponse = {
    data: {
        result: number;
        signed: null;
    };
};
type QuoteApiResponseSigned = {
    data: {
        result: number;
        signed: {
            signatureParams: {
                signedTimestamp: number;
                chainId: number;
                validFromTimestamp: number;
                durationSeconds: number;
            };
            signature: string;
            message: string;
        };
    };
};
export declare const fetchEncodedSignedQuotes: (pairs: Pair[]) => Promise<EncodedSignedQuote>;
export declare const fetchUnsignedQuote: (pair: Pair) => Promise<number>;
export declare const fetchApiQuote: (pair: Pair, sign?: boolean) => Promise<QuoteApiResponse | QuoteApiResponseSigned>;
export declare const encodeQuotes: (quotes: SignedQuote[]) => BytesLike;
export declare const fetchTimedEncodedSignedQuotes: (pairs: Pair[], provider: Provider) => Promise<EncodedSignedQuote>;
export {};
