import { Pair } from "../../types/trade";
/**
 * Parses a pair, in the context of hLP trade pair (quoted in USD), into an
 * H2SO pair by converting fxTokens into their respective fiat currency symbols
 * and WETH into ETH.
 * @example toParsedDatafeedPair("fxAUD") === "AUD/USD"
 * @example toParsedDatafeedPair("WETH") === "ETH/USD"
 * @param baseSymbol The base token symbol to get a parsed data feed pair for
 * @param quoteSymbol The quote token symbol to get a parsed data feed pair for
 * @returns The parsed pair string for the data feed server
 */
export declare const toParsedDatafeedPair: ({ quoteSymbol, baseSymbol, }: Pair) => Pair;
export declare const toParsedDataFeedSymbol: (symbol: string) => string;
export declare const fromParsedDataFeedPair: (pair: Pair) => Pair;
export declare const fromParsedDataFeedSymbol: (symbol: string) => string;
