import { fetchHlpStaking } from "./hlpStaking";
import { getKeeperStaking } from "./keeperStaking";
import { fetchGovernance } from "./governance";
import { getCdpCollateral } from "./cdpCollateral";
export const fetchPortfolioAssets = async (account, vaults, rewardPool) => {
    const [hlp, governance] = await Promise.all([
        fetchHlpStaking(account),
        fetchGovernance(account),
    ]);
    return {
        staking: {
            hlp,
            keeper: getKeeperStaking(rewardPool),
        },
        governance,
        collateral: {
            cdp: getCdpCollateral(vaults),
        },
        // TODO
        tradeProfits: [],
    };
};
