/// A Portfolio object containing an overview of an address' protocol stats.
import { fetchPortfolioAssets } from "./assets";
import { fetchPortfolioLiabilities } from "./liabilities";
import { fetchPortfolioIncome } from "./income";
import { fetchPortfolioExpenses } from "./expenses";
import Vaults from "../Vaults";
import { getData } from "../rewards";
export const fetchPortfolio = async (account) => {
    const vaultsSdk = new Vaults();
    const [vaults, rewardPoolData, expenses] = await Promise.all([
        vaultsSdk.getVaults(account),
        getData(account),
        fetchPortfolioExpenses(account),
    ]);
    const [assets, liabilities, income] = await Promise.all([
        fetchPortfolioAssets(account, vaults, rewardPoolData),
        fetchPortfolioLiabilities(account, vaults),
        fetchPortfolioIncome(account, rewardPoolData),
    ]);
    return {
        assets,
        liabilities,
        income,
        expenses,
    };
};
