import { BigNumber, ethers } from "ethers";
import * as coingecko from "../prices/sources/coingecko";
import { FxTokenSymbol } from "../../types/fxTokens";
import { TokenInfo } from "@uniswap/token-lists";
type PricePoint = {
    date: number;
    price: number;
};
declare const fetchEthUsdPrice: (signer?: ethers.Signer) => Promise<{
    bn: BigNumber;
    number: number;
}>;
export type FxTokenPriceMap = Record<FxTokenSymbol, {
    bn: BigNumber;
    number: number;
}>;
/**
 * Returns the prices for all fxTokens in USD, using the
 * official Chainlink feed.
 * These prices are used for the CDP vaults.
 */
declare const fetchFxTokenTargetChainlinkUsdPrices: () => Promise<FxTokenPriceMap>;
export declare const fetchTokenPriceUsd: (symbol: string, token?: TokenInfo) => Promise<BigNumber | null>;
export declare const isHlpToken: (symbol: string, token?: TokenInfo) => boolean;
export { coingecko, fetchEthUsdPrice, fetchFxTokenTargetChainlinkUsdPrices };
export type { PricePoint };
