import { TokenInfo } from "@uniswap/token-lists";
import { Network, NetworkMap } from "../../../types/network";
import { PricePoint } from "../index";
type CoinGeckoPricesData = {
    [address: string]: {
        usd: number;
    };
};
export type TokenBasics = {
    symbol: string;
    id: string;
    name: string;
};
export type TokenDetails = TokenBasics & {
    image?: {
        large?: string;
    };
    market_data: {
        current_price: {
            usd: number;
        };
    };
};
export declare const fetchTokenBasics: (address: string, network: Network) => Promise<TokenBasics>;
export declare const fetchTokenDetails: (address: string, network: Network) => Promise<TokenDetails>;
export declare const fetchTokenPrice: (address: string, network: Network) => Promise<number>;
export declare const fetchNativeUsdPrices: () => Promise<NetworkMap<number>>;
export declare const fetchCoinGeckoTokenPriceData: (network: Network, address: string, fiat: string, days: number) => Promise<PricePoint[]>;
export declare const fetchCoinGeckoNativeTokenPriceData: (network: Network, fiat: string, days: number) => Promise<PricePoint[]>;
export declare const fetchCoinGeckoTokenPricesData: (network: Network, tokenAddresses: string[]) => Promise<CoinGeckoPricesData>;
export declare const fetchTokenDetailsFromAddress: (address: string, network: Network) => Promise<TokenInfo>;
export declare const fetchCoinGeckoTokenPrice: (network: Network, token: TokenInfo, fiat: string) => Promise<PricePoint>;
export {};
