import { BigNumber, ContractReceipt, Signer } from "ethers";
export type ReferrerId = number;
export type ReferrerAccountOpenResponse = {
    receipt: ContractReceipt;
    referrerId: ReferrerId;
};
export type ChildReferrerAccountOpenResponse = ReferrerAccountOpenResponse;
export declare const openReferrerAccount: (recipientAddress: string, signer: Signer) => Promise<ReferrerAccountOpenResponse>;
export declare const openChildReferrerAccount: (recipientAddress: string, parentReferrerId: ReferrerId, weight: BigNumber, signer: Signer) => Promise<ChildReferrerAccountOpenResponse>;
export declare const closeReferrerAccount: (referrerId: ReferrerId, signer: Signer) => Promise<ContractReceipt>;
export type ReferrerWeightArg = {
    referrerId: ReferrerId;
    weight: BigNumber;
};
export declare const setChildWeights: (parentReferrerId: ReferrerId, args: ReferrerWeightArg[], signer: Signer) => Promise<ContractReceipt>;
export type ReferralCodeArg = {
    code: string;
    userRebate: BigNumber;
};
export declare const configureReferralCodes: (referrerId: ReferrerId, args: ReferralCodeArg[], signer: Signer) => Promise<ContractReceipt>;
export declare const deleteReferralCodes: (referrerId: ReferrerId, codes: string[], signer: Signer) => Promise<ContractReceipt>;
export declare const obtainChildReferrerOwnership: (childReferrerId: ReferrerId, parentReferrerId: ReferrerId, signer: Signer) => Promise<ContractReceipt>;
