import { BigNumber, BigNumberish, ethers } from "ethers";
import { DepositStructOutput } from "../contracts/RewardPool";
import { Network } from "../types/network";
import { RewardPoolData, RewardPoolRaw } from "../types/rewardPool";
export declare const SHLP_POOL_ID = 9;
export declare const getData: (account: string | undefined) => Promise<RewardPoolData>;
export declare const getPool: (poolName: string) => Promise<RewardPoolRaw>;
export declare const getPools: () => Promise<Record<string, RewardPoolRaw>>;
export declare const getClaimableBalance: (account: string, pool: BigNumber) => Promise<BigNumber>;
export declare const getDeposit: (account: string, pool: BigNumber) => Promise<DepositStructOutput>;
export declare const claim: (signer: ethers.Signer, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
export declare const claimFromPool: (signer: ethers.Signer, poolId: BigNumber, options?: ethers.Overrides) => Promise<ethers.ContractTransaction>;
/**
 * Returns pool IDs (even if not enabled) using the known aliases
 * for the governance pool and keeper pools.
 * Does not return pool IDs for aliases not set.
 */
export declare const fetchRewardPoolIds: () => Promise<Record<string, number>>;
export declare const calculateBoost: (totalRealDeposits: BigNumber, totalSupply: BigNumber, amount: BigNumber, boostWeight: BigNumber) => number | undefined;
export declare const fetchAveragePoolBoost: (poolId: BigNumberish, provider: ethers.providers.Provider, network: Network) => Promise<number>;
