import axios from "axios";
import { INSTRUMENTS_LIST_URL_BASE } from "../../config";
import { InstrumentSchema } from ".";
import { z } from "zod";
const constructInstrumentFromSchema = (parsedSchema) => ({
    ...parsedSchema,
    getDisplayDecimals(useExtendedDecimals) {
        return useExtendedDecimals && this.shouldUseExtendedDecimals
            ? this.displayDecimals + 1
            : this.displayDecimals;
    },
    getDescription() {
        return this.description ?? this.unitName;
    },
    getUnitName(useShortUnitName) {
        return useShortUnitName
            ? this.unitNameShort ?? this.unitName
            : this.unitName;
    },
    getHideQuoteSymbolLogo() {
        return this.hideQuoteSymbolLogo || !this.quoteSymbolLogoUri;
    },
    getChartSymbol() {
        return this.chartSymbol ?? this.pair;
    },
});
export const fetchInstruments = async (network) => {
    const instrumentsListUrl = `${INSTRUMENTS_LIST_URL_BASE}/${network}.json`;
    const result = await axios.get(instrumentsListUrl);
    const rawInstruments = z.array(InstrumentSchema).parse(result.data);
    return rawInstruments.map((instrument) => constructInstrumentFromSchema(instrument));
};
