import { BigNumber } from "ethers";
import { OpenInterest, TradePair } from "./interface";
import { SerializedPairState } from "./adapter";
export declare class PairState {
    readonly tradePair: TradePair;
    openInterest: OpenInterest;
    private readonly sumFractionFunding;
    private readonly sumFractionBorrow;
    private constructor();
    static fromSerialized(serialized: SerializedPairState, tradePair: TradePair): PairState;
    static zero(tradePair: TradePair): PairState;
    getCurrentSumFractionFunding(indexPrice: BigNumber): MarketSide<BigNumber>;
    getLpFundingRate(indexPrice: BigNumber): BigNumber;
    getCurrentSumFractionBorrow(indexPrice: BigNumber): MarketSide<BigNumber>;
}
export type TimestampedBigNumberMarketSide = TimestampedValue<MarketSide<BigNumber>>;
export type TimestampedValue<T> = {
    value: T;
    timestamp: number;
};
export type MarketSide<T> = {
    long: T;
    short: T;
};
