import { Network } from "../../../../index";
import { GlpManager, GlpOrderBook, GlpOrderBookReader, GlpPositionRouter, GlpReader, GlpRouter, GlpVault, GlpVaultReader } from "../../../../contracts";
import { BigNumber } from "ethers";
export type GlpContracts = {
    vault: GlpVault;
    router: GlpRouter;
    reader: GlpReader;
    glpManager: GlpManager;
    orderBook: GlpOrderBook;
    orderBookReader: GlpOrderBookReader;
    positionRouter: GlpPositionRouter;
    vaultReader: GlpVaultReader;
};
export declare const FUNDING_RATE_PRECISION = 1000000;
export declare const GMX_REFERRAL_CODE = "0x68616e646c655f66690000000000000000000000000000000000000000000000";
export declare const REFERRAL_DISCOUNT_BPS = 500;
export declare const MAX_LEVERAGE_BPS: BigNumber;
export declare const MIN_PROFIT_TIME = 0;
export declare const MIN_PROFIT_BPS = 0;
export declare const STABLE_SWAP_FEE_BPS = 1;
export declare const SWAP_FEE_BPS: number;
export declare const MARGIN_FEE_BPS: number;
export declare const LIQUIDATION_FEE_USD: BigNumber;
export declare const MIN_PURCHASE_AMOUNT_USD: BigNumber;
export declare const GLP_PLATFORM_NAME: "glp";
export declare const GLP_NETWORK: Network;
export declare const GMX_CALLBACK_TARGET = "0x0000000000000000000000000000000000000000";
export declare const READER_POSITIONS_PROPS_LENGTH = 9;
export declare const WS_RPC_URL = "wss://arb-mainnet.g.alchemy.com/v2/99Hh6JHEUNRsykEEhz27LVVI-lFlaV1C";
