import { pairFromString } from "../../../../../../utils/general";
export const getAllPositionIds = (tradableTokens, stableTokens) => {
    const longs = tradableTokens.map((token) => ({
        pair: pairFromString(`${token.symbol}/USD`),
        isLong: true,
        collateralAddress: token.address,
        indexToken: token,
        collateralToken: token,
    }));
    const shorts = tradableTokens
        .map((token) => stableTokens.map((stableToken) => ({
        pair: pairFromString(`${token.symbol}/USD`),
        isLong: false,
        collateralAddress: stableToken.address,
        indexToken: token,
        collateralToken: stableToken,
    })))
        .flat();
    return [...longs, ...shorts];
};
