import { BigNumber } from "ethers";
import { GlpToken } from "../tokens";
import { PositionGlp } from "./index";
import { Pair } from "../../../../../../types/trade";
import { MarketPrice } from "../../../legacyInterface";
export type PositionQuery = {
    collateralTokens: GlpToken[];
    indexTokens: GlpToken[];
    isLong: boolean[];
};
export declare const parseContractPositionsData: (positionQuery: PositionQuery, positionData: BigNumber[], includeDelta: boolean, account: string, propsLength: number, platformName: string, getMarketPrice: (pair: Pair) => MarketPrice, includeZeroPositions?: boolean) => PositionGlp[];
export declare const getPositionKey: (account: string, collateralTokenAddress: string, indexTokenAddress: string, isLong: boolean, nativeTokenAddress?: string) => string;
type GetLeverageArgs = {
    size: BigNumber;
    sizeDelta: BigNumber;
    isIncreasingSize: boolean;
    collateral: BigNumber;
    collateralDelta: BigNumber;
    isIncreasingCollateral: boolean;
    entryFundingRate: BigNumber;
    cumulativeFundingRate: BigNumber;
    hasProfit: boolean;
    delta: BigNumber;
    shouldIncludeDelta: boolean;
};
export declare const getLeverage: ({ size, sizeDelta, isIncreasingSize, collateral, collateralDelta, isIncreasingCollateral, entryFundingRate, cumulativeFundingRate, hasProfit, delta, shouldIncludeDelta, }: GetLeverageArgs) => BigNumber;
export {};
