import { TokenInfo } from "@uniswap/token-lists";
import { BigNumber } from "ethers";
import TokenManager from "../../../../token-manager";
import { GetCollateralTokensArgs, TradePairInternal } from "../../legacyInterface";
export type TokenInfoGlp = TokenInfo & {
    extensions: {
        isUsdg?: boolean;
        isNative?: boolean;
        isWrappedNative?: boolean;
        isShortable?: boolean;
        isStable?: boolean;
    };
};
export type GlpToken = TokenInfoGlp & {
    hasMaxAvailableLong?: boolean;
    hasMaxAvailableShort?: boolean;
    usdgAmount?: BigNumber;
    maxUsdgAmount?: BigNumber;
    poolAmount?: BigNumber;
    bufferAmount?: BigNumber;
    managedAmount?: BigNumber;
    managedUsd?: BigNumber;
    availableAmount?: BigNumber;
    availableUsd?: BigNumber;
    guaranteedUsd?: BigNumber;
    redemptionAmount?: BigNumber;
    reservedAmount?: BigNumber;
    balance?: BigNumber;
    weight?: BigNumber;
    maxPrice?: BigNumber;
    maxPrimaryPrice?: BigNumber;
    minPrice?: BigNumber;
    minPrimaryPrice?: BigNumber;
    contractMaxPrice?: BigNumber;
    contractMinPrice?: BigNumber;
    cumulativeFundingRate?: BigNumber;
    fundingRate?: BigNumber;
    globalShortSize?: BigNumber;
    maxAvailableLong?: BigNumber;
    maxAvailableShort?: BigNumber;
    maxGlobalLongSize?: BigNumber;
    maxGlobalShortSize?: BigNumber;
    maxLongCapacity?: BigNumber;
};
export type TradePairGlpInternals = {
    glpToken: GlpToken;
};
export type TradePairGlp = TradePairInternal<TradePairGlpInternals>;
export declare const glpTokenManager: TokenManager;
export declare const getStableToken: () => TokenInfoGlp;
export declare const getTokens: (includeEth?: boolean) => TokenInfoGlp[];
export declare const getCollateralTokens: (_: GetCollateralTokensArgs) => TokenInfoGlp[];
export declare const getTokenInfoGlpBySymbol: (symbol: string) => TokenInfoGlp;
export declare const getTokenInfoGlpByAddress: (address: string) => {
    token: TokenInfoGlp;
    isInputNative: boolean;
};
