import * as config from "./config";
import { HLP_PLATFORM_NAME } from "./config";
import * as internals from "./internals";
import { fetchTradePairsHlp, getCollateralTokens, getHlpPrice, getLatestMarketPrice, getTradePair, subscribeToMarketPrice, unsubscribeFromMarketPrice, } from "./internals";
import { getMinimumPositionCollateralHlp } from "./internals/getMinimumPositionCollateral";
import { approveCreateIncreasePositionOrder, approveIncreasePosition, createDecreasePositionOrder, createIncreasePositionOrder, decreasePosition, getAllPositions, getPosition, getTradeHistory, getUpdatedPosition, increasePosition, simulateDecreasePosition, simulateIncreasePosition, updateDecreasePositionOrder, updateIncreasePositionOrder, } from "./internals/position";
import { getAvailabilityHlp, getAvailableLiquidity, getPlatformTokens, } from "./internals/tokens";
import { getActiveOrders } from "./orders";
export const trade = {
    name: HLP_PLATFORM_NAME,
    initialise: config.initialise,
    approveIncreasePosition,
    increasePosition,
    decreasePosition,
    approveCreateIncreasePositionOrder,
    createIncreasePositionOrder,
    createDecreasePositionOrder,
    updateIncreasePositionOrder,
    updateDecreasePositionOrder,
    getPosition,
    getAllPositions,
    getUpdatedPosition,
    getPrice: ({ pair }) => getLatestMarketPrice(pair),
    getLpTokenPrice: () => getHlpPrice().then((price) => price.maximum),
    subscribeToMarketPrice: (args) => subscribeToMarketPrice(args),
    unsubscribeFromMarketPrice: (id) => unsubscribeFromMarketPrice(id),
    getTradePairs: () => fetchTradePairsHlp(),
    simulateIncreasePosition,
    simulateDecreasePosition,
    getTokens: getPlatformTokens,
    getCollateralTokens,
    getTradePair,
    getTradeHistory,
    getAvailableLiquidity,
    getPairAvailability: ({ pair }) => getAvailabilityHlp(pair),
    getActiveOrders,
    getMinimumPositionCollateral: getMinimumPositionCollateralHlp,
};
export { internals, config };
