import { getAum } from "./getAum";
import { DEFAULT_HLP_NETWORK, getHlpContracts } from "../config";
import { ethers } from "ethers";
/// Returns the hLP price with 30 decimals.
export const getHlpPrice = async () => {
    const { maximum, minimum } = await getAum(DEFAULT_HLP_NETWORK);
    const { hlp } = getHlpContracts(DEFAULT_HLP_NETWORK);
    const totalHlpSupply = await hlp.totalSupply();
    return {
        maximum: calculateHlpPrice(maximum, totalHlpSupply),
        minimum: calculateHlpPrice(minimum, totalHlpSupply),
    };
};
const calculateHlpPrice = (aum, totalHlpSupply) => aum.mul(ethers.constants.WeiPerEther).div(totalHlpSupply);
