import { getActualPositionHlp, isPositionHlpReversed, } from "./position/parseContractPosition";
import { getTradePair } from "./tokens";
import { getReversedPrice } from "../../../../../utils/general";
import { getPositionLiquidationPrice } from "../../../utils";
export const getLiquidationPrice = (position, positionDelta) => {
    const actualPosition = getActualPositionHlp(position);
    const tradePair = getTradePair({ pair: position.pair });
    let price = getPositionLiquidationPrice(actualPosition, tradePair, positionDelta);
    if (isPositionHlpReversed(position)) {
        price = getReversedPrice(price);
    }
    return price;
};
