import { BigNumber } from "ethers";
import { Network } from "../../../../../types/network";
import { HlpConfig } from "../config";
export type RequiredConfig = "stableSwapFeeBasisPoints" | "swapFeeBasisPoints" | "stableTaxBasisPoints" | "taxBasisPoints";
export type SwapFeeBasisPointsArgs = {
    tokenIn: string;
    tokenOut: string;
    usdHlpDelta: BigNumber;
    usdHlpSupplyTokenIn: BigNumber;
    usdHlpSupplyTokenOut: BigNumber;
    totalTokenWeights: BigNumber;
    targetUsdHlpAmountTokenIn: BigNumber;
    targetUsdHlpAmountTokenOut: BigNumber;
    config: Pick<HlpConfig, RequiredConfig>;
};
export declare const getSwapFeeBasisPoints: (args: SwapFeeBasisPointsArgs, network?: Network) => BigNumber;
