import { BASIS_POINTS_DIVISOR } from "../../../../../constants";
export const getTradeFee = (isSwap, isStableSwap, collateralSize, positionSize, config) => {
    const marginFee = positionSize
        .mul(config.marginFeeBasisPoints)
        .div(BASIS_POINTS_DIVISOR);
    if (isStableSwap) {
        return marginFee.add(collateralSize
            .mul(config.stableSwapFeeBasisPoints)
            .div(BASIS_POINTS_DIVISOR));
    }
    if (isSwap) {
        return marginFee.add(collateralSize.mul(config.swapFeeBasisPoints).div(BASIS_POINTS_DIVISOR));
    }
    return marginFee;
};
