import { ethers } from "ethers";
export const getMinimumPositionCollateral = ({ isTriggerOrder, existingCollateral }, liquidationFee, minimumTriggerOrder) => {
    const minForLiquidationFee = liquidationFee
        .sub(existingCollateral)
        .isNegative()
        ? ethers.constants.Zero
        : liquidationFee.sub(existingCollateral);
    if (isTriggerOrder) {
        return minimumTriggerOrder.gt(minForLiquidationFee)
            ? minimumTriggerOrder
            : minForLiquidationFee;
    }
    return minForLiquidationFee;
};
