import { Position, TradePair } from "../platforms/legacyInterface";
import { BigNumber } from "ethers";
export declare const ETH_ADDRESS = "0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee";
export declare const applyDiscount: (grossAmount: BigNumber, discountBps: number) => BigNumber;
export declare const calculateFee: (grossAmount: BigNumber, basisPoints: number) => BigNumber;
export declare const getMarginFee: (sizeDelta: BigNumber, marginFeeBps: BigNumber) => BigNumber;
export type PositionDelta = {
    collateralDelta: BigNumber;
    sizeDelta: BigNumber;
    isIncrease: boolean;
};
export declare const getPositionLiquidationPrice: ({ isLong, size, collateral, averagePrice, fundingFee }: Position, { maxLeverageBps, marginFeeBps, liquidationFeeUsd }: TradePair, { collateralDelta, sizeDelta, isIncrease }?: PositionDelta) => BigNumber;
export declare const createOrderId: (platform: string, account: string, index: number) => string;
export declare const parseOrderId: (id: string, targetPlatform?: string) => {
    platform: string;
    account: string;
    index: number;
};
export declare const isEtherAddress: (address: string) => boolean;
