import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface GlpOrderBookReaderInterface extends utils.Interface {
    functions: {
        "getDecreaseOrders(address,address,uint256[])": FunctionFragment;
        "getIncreaseOrders(address,address,uint256[])": FunctionFragment;
        "getSwapOrders(address,address,uint256[])": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "getDecreaseOrders", values: [string, string, BigNumberish[]]): string;
    encodeFunctionData(functionFragment: "getIncreaseOrders", values: [string, string, BigNumberish[]]): string;
    encodeFunctionData(functionFragment: "getSwapOrders", values: [string, string, BigNumberish[]]): string;
    decodeFunctionResult(functionFragment: "getDecreaseOrders", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getIncreaseOrders", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getSwapOrders", data: BytesLike): Result;
    events: {};
}
export interface GlpOrderBookReader extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: GlpOrderBookReaderInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        getDecreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
        getIncreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
        getSwapOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
    };
    getDecreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
    getIncreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
    getSwapOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
    callStatic: {
        getDecreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
        getIncreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
        getSwapOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<[BigNumber[], string[]]>;
    };
    filters: {};
    estimateGas: {
        getDecreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<BigNumber>;
        getIncreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<BigNumber>;
        getSwapOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        getDecreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getIncreaseOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getSwapOrders(_orderBookAddress: string, _account: string, _indices: BigNumberish[], overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
