import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface GlpVaultReaderInterface extends utils.Interface {
    functions: {
        "getVaultTokenInfoV3(address,address,address,uint256,address[])": FunctionFragment;
        "getVaultTokenInfoV4(address,address,address,uint256,address[])": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "getVaultTokenInfoV3", values: [string, string, string, BigNumberish, string[]]): string;
    encodeFunctionData(functionFragment: "getVaultTokenInfoV4", values: [string, string, string, BigNumberish, string[]]): string;
    decodeFunctionResult(functionFragment: "getVaultTokenInfoV3", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getVaultTokenInfoV4", data: BytesLike): Result;
    events: {};
}
export interface GlpVaultReader extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: GlpVaultReaderInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        getVaultTokenInfoV3(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<[BigNumber[]]>;
        getVaultTokenInfoV4(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<[BigNumber[]]>;
    };
    getVaultTokenInfoV3(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber[]>;
    getVaultTokenInfoV4(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber[]>;
    callStatic: {
        getVaultTokenInfoV3(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber[]>;
        getVaultTokenInfoV4(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber[]>;
    };
    filters: {};
    estimateGas: {
        getVaultTokenInfoV3(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber>;
        getVaultTokenInfoV4(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        getVaultTokenInfoV3(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getVaultTokenInfoV4(_vault: string, _positionManager: string, _weth: string, _usdgAmount: BigNumberish, _tokens: string[], overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
