import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface GovernanceLockInterface extends utils.Interface {
    functions: {
        "MAX_TIME()": FunctionFragment;
        "REWARD_POOL_ALIAS()": FunctionFragment;
        "balanceOf(address)": FunctionFragment;
        "checkpoint()": FunctionFragment;
        "createLock(uint256,uint256)": FunctionFragment;
        "depositFor(address,uint256)": FunctionFragment;
        "epoch()": FunctionFragment;
        "getLastUserSlope(address)": FunctionFragment;
        "increaseAmount(uint256)": FunctionFragment;
        "increaseUnlockTime(uint256)": FunctionFragment;
        "initialize(address,address)": FunctionFragment;
        "isWhitelistEnabled()": FunctionFragment;
        "locked(address)": FunctionFragment;
        "lockedEnd(address)": FunctionFragment;
        "owner()": FunctionFragment;
        "pointHistory(uint256)": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "rewardPool()": FunctionFragment;
        "setContractWhitelist(address,bool)": FunctionFragment;
        "setWhitelistEnabled(bool)": FunctionFragment;
        "slopeChanges(uint256)": FunctionFragment;
        "supply()": FunctionFragment;
        "token()": FunctionFragment;
        "totalSupply()": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "upgradeTo(address)": FunctionFragment;
        "upgradeToAndCall(address,bytes)": FunctionFragment;
        "userPointEpoch(address)": FunctionFragment;
        "userPointHistory(address,uint256)": FunctionFragment;
        "userPointHistoryTs(address,uint256)": FunctionFragment;
        "whitelistedContracts(address)": FunctionFragment;
        "withdraw()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "MAX_TIME", values?: undefined): string;
    encodeFunctionData(functionFragment: "REWARD_POOL_ALIAS", values?: undefined): string;
    encodeFunctionData(functionFragment: "balanceOf", values: [string]): string;
    encodeFunctionData(functionFragment: "checkpoint", values?: undefined): string;
    encodeFunctionData(functionFragment: "createLock", values: [BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "depositFor", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "epoch", values?: undefined): string;
    encodeFunctionData(functionFragment: "getLastUserSlope", values: [string]): string;
    encodeFunctionData(functionFragment: "increaseAmount", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "increaseUnlockTime", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "initialize", values: [string, string]): string;
    encodeFunctionData(functionFragment: "isWhitelistEnabled", values?: undefined): string;
    encodeFunctionData(functionFragment: "locked", values: [string]): string;
    encodeFunctionData(functionFragment: "lockedEnd", values: [string]): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pointHistory", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "rewardPool", values?: undefined): string;
    encodeFunctionData(functionFragment: "setContractWhitelist", values: [string, boolean]): string;
    encodeFunctionData(functionFragment: "setWhitelistEnabled", values: [boolean]): string;
    encodeFunctionData(functionFragment: "slopeChanges", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "supply", values?: undefined): string;
    encodeFunctionData(functionFragment: "token", values?: undefined): string;
    encodeFunctionData(functionFragment: "totalSupply", values?: undefined): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeTo", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeToAndCall", values: [string, BytesLike]): string;
    encodeFunctionData(functionFragment: "userPointEpoch", values: [string]): string;
    encodeFunctionData(functionFragment: "userPointHistory", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "userPointHistoryTs", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "whitelistedContracts", values: [string]): string;
    encodeFunctionData(functionFragment: "withdraw", values?: undefined): string;
    decodeFunctionResult(functionFragment: "MAX_TIME", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "REWARD_POOL_ALIAS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "checkpoint", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "createLock", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "depositFor", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "epoch", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLastUserSlope", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "increaseAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "increaseUnlockTime", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isWhitelistEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "locked", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lockedEnd", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pointHistory", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "rewardPool", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setContractWhitelist", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setWhitelistEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "slopeChanges", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "supply", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "token", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalSupply", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeToAndCall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "userPointEpoch", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "userPointHistory", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "userPointHistoryTs", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "whitelistedContracts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;
    events: {
        "AdminChanged(address,address)": EventFragment;
        "BeaconUpgraded(address)": EventFragment;
        "Deposit(address,uint256,uint256,uint8,uint256)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "Supply(uint256,uint256)": EventFragment;
        "Upgraded(address)": EventFragment;
        "Withdraw(address,uint256,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "AdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "BeaconUpgraded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Supply"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Upgraded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Withdraw"): EventFragment;
}
export type AdminChangedEvent = TypedEvent<[
    string,
    string
], {
    previousAdmin: string;
    newAdmin: string;
}>;
export type AdminChangedEventFilter = TypedEventFilter<AdminChangedEvent>;
export type BeaconUpgradedEvent = TypedEvent<[string], {
    beacon: string;
}>;
export type BeaconUpgradedEventFilter = TypedEventFilter<BeaconUpgradedEvent>;
export type DepositEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber,
    number,
    BigNumber
], {
    depositor: string;
    value: BigNumber;
    locktime: BigNumber;
    depositType: number;
    ts: BigNumber;
}>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], {
    previousOwner: string;
    newOwner: string;
}>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export type SupplyEvent = TypedEvent<[
    BigNumber,
    BigNumber
], {
    previousSupply: BigNumber;
    supply: BigNumber;
}>;
export type SupplyEventFilter = TypedEventFilter<SupplyEvent>;
export type UpgradedEvent = TypedEvent<[string], {
    implementation: string;
}>;
export type UpgradedEventFilter = TypedEventFilter<UpgradedEvent>;
export type WithdrawEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber
], {
    depositor: string;
    value: BigNumber;
    ts: BigNumber;
}>;
export type WithdrawEventFilter = TypedEventFilter<WithdrawEvent>;
export interface GovernanceLock extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: GovernanceLockInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        MAX_TIME(overrides?: CallOverrides): Promise<[BigNumber]>;
        REWARD_POOL_ALIAS(overrides?: CallOverrides): Promise<[string]>;
        balanceOf(account: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        checkpoint(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        createLock(value: BigNumberish, unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        depositFor(account: string, value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        epoch(overrides?: CallOverrides): Promise<[BigNumber]>;
        getLastUserSlope(account: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        increaseAmount(value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        increaseUnlockTime(unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        initialize(tokenAddress: string, rewardPoolAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        isWhitelistEnabled(overrides?: CallOverrides): Promise<[boolean]>;
        locked(arg0: string, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
            amount: BigNumber;
            end: BigNumber;
        }>;
        lockedEnd(account: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        pointHistory(arg0: BigNumberish, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            bias: BigNumber;
            slope: BigNumber;
            ts: BigNumber;
            blk: BigNumber;
        }>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        rewardPool(overrides?: CallOverrides): Promise<[string]>;
        setContractWhitelist(contractAddress: string, isWhitelisted: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setWhitelistEnabled(isEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        slopeChanges(arg0: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        supply(overrides?: CallOverrides): Promise<[BigNumber]>;
        token(overrides?: CallOverrides): Promise<[string]>;
        totalSupply(overrides?: CallOverrides): Promise<[BigNumber]>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        userPointEpoch(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        userPointHistory(arg0: string, arg1: BigNumberish, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            bias: BigNumber;
            slope: BigNumber;
            ts: BigNumber;
            blk: BigNumber;
        }>;
        userPointHistoryTs(account: string, idx: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        whitelistedContracts(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        withdraw(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
    };
    MAX_TIME(overrides?: CallOverrides): Promise<BigNumber>;
    REWARD_POOL_ALIAS(overrides?: CallOverrides): Promise<string>;
    balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;
    checkpoint(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    createLock(value: BigNumberish, unlockTime: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    depositFor(account: string, value: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    epoch(overrides?: CallOverrides): Promise<BigNumber>;
    getLastUserSlope(account: string, overrides?: CallOverrides): Promise<BigNumber>;
    increaseAmount(value: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    increaseUnlockTime(unlockTime: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    initialize(tokenAddress: string, rewardPoolAddress: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    isWhitelistEnabled(overrides?: CallOverrides): Promise<boolean>;
    locked(arg0: string, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
        amount: BigNumber;
        end: BigNumber;
    }>;
    lockedEnd(account: string, overrides?: CallOverrides): Promise<BigNumber>;
    owner(overrides?: CallOverrides): Promise<string>;
    pointHistory(arg0: BigNumberish, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        bias: BigNumber;
        slope: BigNumber;
        ts: BigNumber;
        blk: BigNumber;
    }>;
    renounceOwnership(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    rewardPool(overrides?: CallOverrides): Promise<string>;
    setContractWhitelist(contractAddress: string, isWhitelisted: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setWhitelistEnabled(isEnabled: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    slopeChanges(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    supply(overrides?: CallOverrides): Promise<BigNumber>;
    token(overrides?: CallOverrides): Promise<string>;
    totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
    transferOwnership(newOwner: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeTo(newImplementation: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    userPointEpoch(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    userPointHistory(arg0: string, arg1: BigNumberish, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        bias: BigNumber;
        slope: BigNumber;
        ts: BigNumber;
        blk: BigNumber;
    }>;
    userPointHistoryTs(account: string, idx: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    whitelistedContracts(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    withdraw(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        MAX_TIME(overrides?: CallOverrides): Promise<BigNumber>;
        REWARD_POOL_ALIAS(overrides?: CallOverrides): Promise<string>;
        balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        checkpoint(overrides?: CallOverrides): Promise<void>;
        createLock(value: BigNumberish, unlockTime: BigNumberish, overrides?: CallOverrides): Promise<void>;
        depositFor(account: string, value: BigNumberish, overrides?: CallOverrides): Promise<void>;
        epoch(overrides?: CallOverrides): Promise<BigNumber>;
        getLastUserSlope(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        increaseAmount(value: BigNumberish, overrides?: CallOverrides): Promise<void>;
        increaseUnlockTime(unlockTime: BigNumberish, overrides?: CallOverrides): Promise<void>;
        initialize(tokenAddress: string, rewardPoolAddress: string, overrides?: CallOverrides): Promise<void>;
        isWhitelistEnabled(overrides?: CallOverrides): Promise<boolean>;
        locked(arg0: string, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
            amount: BigNumber;
            end: BigNumber;
        }>;
        lockedEnd(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<string>;
        pointHistory(arg0: BigNumberish, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            bias: BigNumber;
            slope: BigNumber;
            ts: BigNumber;
            blk: BigNumber;
        }>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        rewardPool(overrides?: CallOverrides): Promise<string>;
        setContractWhitelist(contractAddress: string, isWhitelisted: boolean, overrides?: CallOverrides): Promise<void>;
        setWhitelistEnabled(isEnabled: boolean, overrides?: CallOverrides): Promise<void>;
        slopeChanges(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        supply(overrides?: CallOverrides): Promise<BigNumber>;
        token(overrides?: CallOverrides): Promise<string>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: CallOverrides): Promise<void>;
        upgradeTo(newImplementation: string, overrides?: CallOverrides): Promise<void>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: CallOverrides): Promise<void>;
        userPointEpoch(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        userPointHistory(arg0: string, arg1: BigNumberish, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            bias: BigNumber;
            slope: BigNumber;
            ts: BigNumber;
            blk: BigNumber;
        }>;
        userPointHistoryTs(account: string, idx: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        whitelistedContracts(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        withdraw(overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "AdminChanged(address,address)"(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        AdminChanged(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        "BeaconUpgraded(address)"(beacon?: string | null): BeaconUpgradedEventFilter;
        BeaconUpgraded(beacon?: string | null): BeaconUpgradedEventFilter;
        "Deposit(address,uint256,uint256,uint8,uint256)"(depositor?: string | null, value?: null, locktime?: BigNumberish | null, depositType?: null, ts?: null): DepositEventFilter;
        Deposit(depositor?: string | null, value?: null, locktime?: BigNumberish | null, depositType?: null, ts?: null): DepositEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        "Supply(uint256,uint256)"(previousSupply?: null, supply?: null): SupplyEventFilter;
        Supply(previousSupply?: null, supply?: null): SupplyEventFilter;
        "Upgraded(address)"(implementation?: string | null): UpgradedEventFilter;
        Upgraded(implementation?: string | null): UpgradedEventFilter;
        "Withdraw(address,uint256,uint256)"(depositor?: string | null, value?: null, ts?: null): WithdrawEventFilter;
        Withdraw(depositor?: string | null, value?: null, ts?: null): WithdrawEventFilter;
    };
    estimateGas: {
        MAX_TIME(overrides?: CallOverrides): Promise<BigNumber>;
        REWARD_POOL_ALIAS(overrides?: CallOverrides): Promise<BigNumber>;
        balanceOf(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        checkpoint(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        createLock(value: BigNumberish, unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        depositFor(account: string, value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        epoch(overrides?: CallOverrides): Promise<BigNumber>;
        getLastUserSlope(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        increaseAmount(value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        increaseUnlockTime(unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        initialize(tokenAddress: string, rewardPoolAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        isWhitelistEnabled(overrides?: CallOverrides): Promise<BigNumber>;
        locked(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        lockedEnd(account: string, overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        pointHistory(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        rewardPool(overrides?: CallOverrides): Promise<BigNumber>;
        setContractWhitelist(contractAddress: string, isWhitelisted: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setWhitelistEnabled(isEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        slopeChanges(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        supply(overrides?: CallOverrides): Promise<BigNumber>;
        token(overrides?: CallOverrides): Promise<BigNumber>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        userPointEpoch(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        userPointHistory(arg0: string, arg1: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        userPointHistoryTs(account: string, idx: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        whitelistedContracts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        withdraw(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        MAX_TIME(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        REWARD_POOL_ALIAS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        balanceOf(account: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        checkpoint(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        createLock(value: BigNumberish, unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        depositFor(account: string, value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        epoch(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLastUserSlope(account: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        increaseAmount(value: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        increaseUnlockTime(unlockTime: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        initialize(tokenAddress: string, rewardPoolAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        isWhitelistEnabled(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        locked(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        lockedEnd(account: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pointHistory(arg0: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        rewardPool(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        setContractWhitelist(contractAddress: string, isWhitelisted: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setWhitelistEnabled(isEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        slopeChanges(arg0: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        supply(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        token(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalSupply(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        userPointEpoch(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        userPointHistory(arg0: string, arg1: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        userPointHistoryTs(account: string, idx: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        whitelistedContracts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdraw(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
    };
}
