import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface HPSM2Interface extends utils.Interface {
    functions: {
        "accruedFees(address)": FunctionFragment;
        "areDepositsPaused()": FunctionFragment;
        "collateralCap(address)": FunctionFragment;
        "collateralDeposits(address,address)": FunctionFragment;
        "collectAccruedFees(address)": FunctionFragment;
        "deposit(address,address,uint256)": FunctionFragment;
        "depositTransactionFees(address)": FunctionFragment;
        "isFxTokenPegged(address,address)": FunctionFragment;
        "owner()": FunctionFragment;
        "pct()": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "requestFundsPct(address,uint256)": FunctionFragment;
        "setCollateralCap(address,uint256)": FunctionFragment;
        "setDepositTransactionFee(address,uint256)": FunctionFragment;
        "setFxTokenPeg(address,address,bool)": FunctionFragment;
        "setPausedDeposits(bool)": FunctionFragment;
        "setPct(address)": FunctionFragment;
        "setWithdrawalTransactionFee(address,uint256)": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "withdraw(address,address,uint256)": FunctionFragment;
        "withdrawalTransactionFees(address)": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "accruedFees", values: [string]): string;
    encodeFunctionData(functionFragment: "areDepositsPaused", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateralCap", values: [string]): string;
    encodeFunctionData(functionFragment: "collateralDeposits", values: [string, string]): string;
    encodeFunctionData(functionFragment: "collectAccruedFees", values: [string]): string;
    encodeFunctionData(functionFragment: "deposit", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "depositTransactionFees", values: [string]): string;
    encodeFunctionData(functionFragment: "isFxTokenPegged", values: [string, string]): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pct", values?: undefined): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "requestFundsPct", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setCollateralCap", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setDepositTransactionFee", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setFxTokenPeg", values: [string, string, boolean]): string;
    encodeFunctionData(functionFragment: "setPausedDeposits", values: [boolean]): string;
    encodeFunctionData(functionFragment: "setPct", values: [string]): string;
    encodeFunctionData(functionFragment: "setWithdrawalTransactionFee", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [string]): string;
    encodeFunctionData(functionFragment: "withdraw", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "withdrawalTransactionFees", values: [string]): string;
    decodeFunctionResult(functionFragment: "accruedFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "areDepositsPaused", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralCap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralDeposits", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collectAccruedFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "depositTransactionFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isFxTokenPegged", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pct", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "requestFundsPct", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setCollateralCap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setDepositTransactionFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFxTokenPeg", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPausedDeposits", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPct", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setWithdrawalTransactionFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawalTransactionFees", data: BytesLike): Result;
    events: {
        "Deposit(address,address,address,uint256,uint256)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "SetDepositTransactionFee(address,uint256)": EventFragment;
        "SetFxTokenPeg(address,address,bool)": EventFragment;
        "SetMaximumTokenDeposit(address,uint256)": EventFragment;
        "SetPauseDeposits(bool)": EventFragment;
        "SetPct(address)": EventFragment;
        "SetWithdrawalTransactionFee(address,uint256)": EventFragment;
        "TransferFundsPct(address,address,uint256)": EventFragment;
        "Withdraw(address,address,address,uint256,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetDepositTransactionFee"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetFxTokenPeg"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetMaximumTokenDeposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetPauseDeposits"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetPct"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetWithdrawalTransactionFee"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "TransferFundsPct"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Withdraw"): EventFragment;
}
export type DepositEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], {
    fxToken: string;
    peggedToken: string;
    account: string;
    amountIn: BigNumber;
    amountOut: BigNumber;
}>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], {
    previousOwner: string;
    newOwner: string;
}>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export type SetDepositTransactionFeeEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    fee: BigNumber;
}>;
export type SetDepositTransactionFeeEventFilter = TypedEventFilter<SetDepositTransactionFeeEvent>;
export type SetFxTokenPegEvent = TypedEvent<[
    string,
    string,
    boolean
], {
    fxToken: string;
    peggedToken: string;
    isPegged: boolean;
}>;
export type SetFxTokenPegEventFilter = TypedEventFilter<SetFxTokenPegEvent>;
export type SetMaximumTokenDepositEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type SetMaximumTokenDepositEventFilter = TypedEventFilter<SetMaximumTokenDepositEvent>;
export type SetPauseDepositsEvent = TypedEvent<[
    boolean
], {
    isPaused: boolean;
}>;
export type SetPauseDepositsEventFilter = TypedEventFilter<SetPauseDepositsEvent>;
export type SetPctEvent = TypedEvent<[string], {
    pct: string;
}>;
export type SetPctEventFilter = TypedEventFilter<SetPctEvent>;
export type SetWithdrawalTransactionFeeEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    fee: BigNumber;
}>;
export type SetWithdrawalTransactionFeeEventFilter = TypedEventFilter<SetWithdrawalTransactionFeeEvent>;
export type TransferFundsPctEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    pct: string;
    token: string;
    amount: BigNumber;
}>;
export type TransferFundsPctEventFilter = TypedEventFilter<TransferFundsPctEvent>;
export type WithdrawEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], {
    fxToken: string;
    peggedToken: string;
    account: string;
    amountIn: BigNumber;
    amountOut: BigNumber;
}>;
export type WithdrawEventFilter = TypedEventFilter<WithdrawEvent>;
export interface HPSM2 extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: HPSM2Interface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        accruedFees(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        areDepositsPaused(overrides?: CallOverrides): Promise<[boolean]>;
        collateralCap(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        collateralDeposits(arg0: string, arg1: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        collectAccruedFees(collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        deposit(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        depositTransactionFees(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        isFxTokenPegged(arg0: string, arg1: string, overrides?: CallOverrides): Promise<[boolean]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        pct(overrides?: CallOverrides): Promise<[string]>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        requestFundsPct(token: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setCollateralCap(peggedToken: string, capWithPeggedTokenDecimals: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setDepositTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setFxTokenPeg(fxTokenAddress: string, peggedTokenAddress: string, isPegged: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setPausedDeposits(isPaused: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setPct(pctAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setWithdrawalTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        withdraw(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        withdrawalTransactionFees(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    accruedFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    areDepositsPaused(overrides?: CallOverrides): Promise<boolean>;
    collateralCap(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    collateralDeposits(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
    collectAccruedFees(collateralToken: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    deposit(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    depositTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    isFxTokenPegged(arg0: string, arg1: string, overrides?: CallOverrides): Promise<boolean>;
    owner(overrides?: CallOverrides): Promise<string>;
    pct(overrides?: CallOverrides): Promise<string>;
    renounceOwnership(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    requestFundsPct(token: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setCollateralCap(peggedToken: string, capWithPeggedTokenDecimals: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setDepositTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setFxTokenPeg(fxTokenAddress: string, peggedTokenAddress: string, isPegged: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setPausedDeposits(isPaused: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setPct(pctAddress: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setWithdrawalTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    withdraw(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    withdrawalTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        accruedFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        areDepositsPaused(overrides?: CallOverrides): Promise<boolean>;
        collateralCap(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        collateralDeposits(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        collectAccruedFees(collateralToken: string, overrides?: CallOverrides): Promise<void>;
        deposit(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        depositTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        isFxTokenPegged(arg0: string, arg1: string, overrides?: CallOverrides): Promise<boolean>;
        owner(overrides?: CallOverrides): Promise<string>;
        pct(overrides?: CallOverrides): Promise<string>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        requestFundsPct(token: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setCollateralCap(peggedToken: string, capWithPeggedTokenDecimals: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setDepositTransactionFee(token: string, fee: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setFxTokenPeg(fxTokenAddress: string, peggedTokenAddress: string, isPegged: boolean, overrides?: CallOverrides): Promise<void>;
        setPausedDeposits(isPaused: boolean, overrides?: CallOverrides): Promise<void>;
        setPct(pctAddress: string, overrides?: CallOverrides): Promise<void>;
        setWithdrawalTransactionFee(token: string, fee: BigNumberish, overrides?: CallOverrides): Promise<void>;
        transferOwnership(newOwner: string, overrides?: CallOverrides): Promise<void>;
        withdraw(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        withdrawalTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {
        "Deposit(address,address,address,uint256,uint256)"(fxToken?: string | null, peggedToken?: string | null, account?: string | null, amountIn?: null, amountOut?: null): DepositEventFilter;
        Deposit(fxToken?: string | null, peggedToken?: string | null, account?: string | null, amountIn?: null, amountOut?: null): DepositEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        "SetDepositTransactionFee(address,uint256)"(token?: string | null, fee?: null): SetDepositTransactionFeeEventFilter;
        SetDepositTransactionFee(token?: string | null, fee?: null): SetDepositTransactionFeeEventFilter;
        "SetFxTokenPeg(address,address,bool)"(fxToken?: string | null, peggedToken?: string | null, isPegged?: null): SetFxTokenPegEventFilter;
        SetFxTokenPeg(fxToken?: string | null, peggedToken?: string | null, isPegged?: null): SetFxTokenPegEventFilter;
        "SetMaximumTokenDeposit(address,uint256)"(token?: string | null, amount?: null): SetMaximumTokenDepositEventFilter;
        SetMaximumTokenDeposit(token?: string | null, amount?: null): SetMaximumTokenDepositEventFilter;
        "SetPauseDeposits(bool)"(isPaused?: null): SetPauseDepositsEventFilter;
        SetPauseDeposits(isPaused?: null): SetPauseDepositsEventFilter;
        "SetPct(address)"(pct?: string | null): SetPctEventFilter;
        SetPct(pct?: string | null): SetPctEventFilter;
        "SetWithdrawalTransactionFee(address,uint256)"(token?: string | null, fee?: null): SetWithdrawalTransactionFeeEventFilter;
        SetWithdrawalTransactionFee(token?: string | null, fee?: null): SetWithdrawalTransactionFeeEventFilter;
        "TransferFundsPct(address,address,uint256)"(pct?: string | null, token?: string | null, amount?: null): TransferFundsPctEventFilter;
        TransferFundsPct(pct?: string | null, token?: string | null, amount?: null): TransferFundsPctEventFilter;
        "Withdraw(address,address,address,uint256,uint256)"(fxToken?: string | null, peggedToken?: string | null, account?: string | null, amountIn?: null, amountOut?: null): WithdrawEventFilter;
        Withdraw(fxToken?: string | null, peggedToken?: string | null, account?: string | null, amountIn?: null, amountOut?: null): WithdrawEventFilter;
    };
    estimateGas: {
        accruedFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        areDepositsPaused(overrides?: CallOverrides): Promise<BigNumber>;
        collateralCap(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        collateralDeposits(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        collectAccruedFees(collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        deposit(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        depositTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        isFxTokenPegged(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        pct(overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        requestFundsPct(token: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setCollateralCap(peggedToken: string, capWithPeggedTokenDecimals: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setDepositTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setFxTokenPeg(fxTokenAddress: string, peggedTokenAddress: string, isPegged: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setPausedDeposits(isPaused: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setPct(pctAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setWithdrawalTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        withdraw(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        withdrawalTransactionFees(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        accruedFees(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        areDepositsPaused(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        collateralCap(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        collateralDeposits(arg0: string, arg1: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        collectAccruedFees(collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        deposit(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        depositTransactionFees(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isFxTokenPegged(arg0: string, arg1: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pct(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        requestFundsPct(token: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setCollateralCap(peggedToken: string, capWithPeggedTokenDecimals: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setDepositTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setFxTokenPeg(fxTokenAddress: string, peggedTokenAddress: string, isPegged: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setPausedDeposits(isPaused: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setPct(pctAddress: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setWithdrawalTransactionFee(token: string, fee: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        withdraw(fxTokenAddress: string, peggedTokenAddress: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        withdrawalTransactionFees(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
