import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface HlpManagerRouterInterface extends utils.Interface {
    functions: {
        "addLiquidityETH(uint256,uint256,bytes)": FunctionFragment;
        "hlpManager()": FunctionFragment;
        "removeLiquidityETH(uint256,uint256,address,bytes)": FunctionFragment;
        "weth()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "addLiquidityETH", values: [BigNumberish, BigNumberish, BytesLike]): string;
    encodeFunctionData(functionFragment: "hlpManager", values?: undefined): string;
    encodeFunctionData(functionFragment: "removeLiquidityETH", values: [BigNumberish, BigNumberish, string, BytesLike]): string;
    encodeFunctionData(functionFragment: "weth", values?: undefined): string;
    decodeFunctionResult(functionFragment: "addLiquidityETH", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hlpManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeLiquidityETH", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "weth", data: BytesLike): Result;
    events: {};
}
export interface HlpManagerRouter extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: HlpManagerRouterInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        addLiquidityETH(_minUsdg: BigNumberish, _minGlp: BigNumberish, signedQuoteData: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        hlpManager(overrides?: CallOverrides): Promise<[string]>;
        removeLiquidityETH(_glpAmount: BigNumberish, _minOut: BigNumberish, _receiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        weth(overrides?: CallOverrides): Promise<[string]>;
    };
    addLiquidityETH(_minUsdg: BigNumberish, _minGlp: BigNumberish, signedQuoteData: BytesLike, overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    hlpManager(overrides?: CallOverrides): Promise<string>;
    removeLiquidityETH(_glpAmount: BigNumberish, _minOut: BigNumberish, _receiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    weth(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        addLiquidityETH(_minUsdg: BigNumberish, _minGlp: BigNumberish, signedQuoteData: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;
        hlpManager(overrides?: CallOverrides): Promise<string>;
        removeLiquidityETH(_glpAmount: BigNumberish, _minOut: BigNumberish, _receiver: string, signedQuoteData: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;
        weth(overrides?: CallOverrides): Promise<string>;
    };
    filters: {};
    estimateGas: {
        addLiquidityETH(_minUsdg: BigNumberish, _minGlp: BigNumberish, signedQuoteData: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        hlpManager(overrides?: CallOverrides): Promise<BigNumber>;
        removeLiquidityETH(_glpAmount: BigNumberish, _minOut: BigNumberish, _receiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        weth(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        addLiquidityETH(_minUsdg: BigNumberish, _minGlp: BigNumberish, signedQuoteData: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        hlpManager(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        removeLiquidityETH(_glpAmount: BigNumberish, _minOut: BigNumberish, _receiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        weth(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
