import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface HpsmTradeInterface extends utils.Interface {
    functions: {
        "hpsm()": FunctionFragment;
        "hpsmDecreasePositionAndSwap(address,address[],address,uint256,uint256,bool,address,uint256,uint256,bytes)": FunctionFragment;
        "hpsmIncreasePositionWithReferrer(address,address[],address,uint256,uint256,uint256,bool,uint256,bytes,address)": FunctionFragment;
        "referral()": FunctionFragment;
        "router()": FunctionFragment;
        "usdg()": FunctionFragment;
        "vault()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "hpsm", values?: undefined): string;
    encodeFunctionData(functionFragment: "hpsmDecreasePositionAndSwap", values: [
        string,
        string[],
        string,
        BigNumberish,
        BigNumberish,
        boolean,
        string,
        BigNumberish,
        BigNumberish,
        BytesLike
    ]): string;
    encodeFunctionData(functionFragment: "hpsmIncreasePositionWithReferrer", values: [
        string,
        string[],
        string,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        boolean,
        BigNumberish,
        BytesLike,
        string
    ]): string;
    encodeFunctionData(functionFragment: "referral", values?: undefined): string;
    encodeFunctionData(functionFragment: "router", values?: undefined): string;
    encodeFunctionData(functionFragment: "usdg", values?: undefined): string;
    encodeFunctionData(functionFragment: "vault", values?: undefined): string;
    decodeFunctionResult(functionFragment: "hpsm", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hpsmDecreasePositionAndSwap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hpsmIncreasePositionWithReferrer", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "referral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "router", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdg", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "vault", data: BytesLike): Result;
    events: {};
}
export interface HpsmTrade extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: HpsmTradeInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        hpsm(overrides?: CallOverrides): Promise<[string]>;
        hpsmDecreasePositionAndSwap(peggedToken: string, _path: string[], _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, _price: BigNumberish, _minOut: BigNumberish, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        hpsmIncreasePositionWithReferrer(peggedToken: string, _path: string[], _indexToken: string, _amountIn: BigNumberish, _minOut: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _price: BigNumberish, signedQuoteData: BytesLike, referrer: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        referral(overrides?: CallOverrides): Promise<[string]>;
        router(overrides?: CallOverrides): Promise<[string]>;
        usdg(overrides?: CallOverrides): Promise<[string]>;
        vault(overrides?: CallOverrides): Promise<[string]>;
    };
    hpsm(overrides?: CallOverrides): Promise<string>;
    hpsmDecreasePositionAndSwap(peggedToken: string, _path: string[], _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, _price: BigNumberish, _minOut: BigNumberish, signedQuoteData: BytesLike, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    hpsmIncreasePositionWithReferrer(peggedToken: string, _path: string[], _indexToken: string, _amountIn: BigNumberish, _minOut: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _price: BigNumberish, signedQuoteData: BytesLike, referrer: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    referral(overrides?: CallOverrides): Promise<string>;
    router(overrides?: CallOverrides): Promise<string>;
    usdg(overrides?: CallOverrides): Promise<string>;
    vault(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        hpsm(overrides?: CallOverrides): Promise<string>;
        hpsmDecreasePositionAndSwap(peggedToken: string, _path: string[], _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, _price: BigNumberish, _minOut: BigNumberish, signedQuoteData: BytesLike, overrides?: CallOverrides): Promise<void>;
        hpsmIncreasePositionWithReferrer(peggedToken: string, _path: string[], _indexToken: string, _amountIn: BigNumberish, _minOut: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _price: BigNumberish, signedQuoteData: BytesLike, referrer: string, overrides?: CallOverrides): Promise<void>;
        referral(overrides?: CallOverrides): Promise<string>;
        router(overrides?: CallOverrides): Promise<string>;
        usdg(overrides?: CallOverrides): Promise<string>;
        vault(overrides?: CallOverrides): Promise<string>;
    };
    filters: {};
    estimateGas: {
        hpsm(overrides?: CallOverrides): Promise<BigNumber>;
        hpsmDecreasePositionAndSwap(peggedToken: string, _path: string[], _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, _price: BigNumberish, _minOut: BigNumberish, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        hpsmIncreasePositionWithReferrer(peggedToken: string, _path: string[], _indexToken: string, _amountIn: BigNumberish, _minOut: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _price: BigNumberish, signedQuoteData: BytesLike, referrer: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        referral(overrides?: CallOverrides): Promise<BigNumber>;
        router(overrides?: CallOverrides): Promise<BigNumber>;
        usdg(overrides?: CallOverrides): Promise<BigNumber>;
        vault(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        hpsm(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        hpsmDecreasePositionAndSwap(peggedToken: string, _path: string[], _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, _price: BigNumberish, _minOut: BigNumberish, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        hpsmIncreasePositionWithReferrer(peggedToken: string, _path: string[], _indexToken: string, _amountIn: BigNumberish, _minOut: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _price: BigNumberish, signedQuoteData: BytesLike, referrer: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        referral(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        router(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usdg(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        vault(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
