import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface PCTInterface extends utils.Interface {
    functions: {
        "balanceOfClaimableInterest(address,address,address)": FunctionFragment;
        "balanceOfStake(address,address,address)": FunctionFragment;
        "claimInterest(address,address)": FunctionFragment;
        "claimProtocolInterest(address,address)": FunctionFragment;
        "depositProtocolFunds(address,address,uint256)": FunctionFragment;
        "getProtocolInvestments(address,address)": FunctionFragment;
        "getTotalAccruedInterest(address)": FunctionFragment;
        "getTotalDeposits(address)": FunctionFragment;
        "getTotalInvestments(address)": FunctionFragment;
        "handleAddress()": FunctionFragment;
        "initialize()": FunctionFragment;
        "owner()": FunctionFragment;
        "protocolFee()": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "requestTreasuryFunds(address,address,uint256)": FunctionFragment;
        "returnTreasuryFunds(address,address,uint256)": FunctionFragment;
        "setHandleContract(address)": FunctionFragment;
        "setProtocolFee(uint256)": FunctionFragment;
        "setProtocolInterface(address,address)": FunctionFragment;
        "stake(address,uint256,address,address)": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "unsetProtocolInterface(address,address)": FunctionFragment;
        "unstake(address,uint256,address,address)": FunctionFragment;
        "upgradeTo(address)": FunctionFragment;
        "upgradeToAndCall(address,bytes)": FunctionFragment;
        "withdrawProtocolFunds(address,address,uint256)": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "balanceOfClaimableInterest", values: [string, string, string]): string;
    encodeFunctionData(functionFragment: "balanceOfStake", values: [string, string, string]): string;
    encodeFunctionData(functionFragment: "claimInterest", values: [string, string]): string;
    encodeFunctionData(functionFragment: "claimProtocolInterest", values: [string, string]): string;
    encodeFunctionData(functionFragment: "depositProtocolFunds", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getProtocolInvestments", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getTotalAccruedInterest", values: [string]): string;
    encodeFunctionData(functionFragment: "getTotalDeposits", values: [string]): string;
    encodeFunctionData(functionFragment: "getTotalInvestments", values: [string]): string;
    encodeFunctionData(functionFragment: "handleAddress", values?: undefined): string;
    encodeFunctionData(functionFragment: "initialize", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "protocolFee", values?: undefined): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "requestTreasuryFunds", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "returnTreasuryFunds", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setHandleContract", values: [string]): string;
    encodeFunctionData(functionFragment: "setProtocolFee", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "setProtocolInterface", values: [string, string]): string;
    encodeFunctionData(functionFragment: "stake", values: [string, BigNumberish, string, string]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [string]): string;
    encodeFunctionData(functionFragment: "unsetProtocolInterface", values: [string, string]): string;
    encodeFunctionData(functionFragment: "unstake", values: [string, BigNumberish, string, string]): string;
    encodeFunctionData(functionFragment: "upgradeTo", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeToAndCall", values: [string, BytesLike]): string;
    encodeFunctionData(functionFragment: "withdrawProtocolFunds", values: [string, string, BigNumberish]): string;
    decodeFunctionResult(functionFragment: "balanceOfClaimableInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "balanceOfStake", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimProtocolInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "depositProtocolFunds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getProtocolInvestments", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalAccruedInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalDeposits", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalInvestments", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "handleAddress", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "protocolFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "requestTreasuryFunds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "returnTreasuryFunds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setHandleContract", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setProtocolFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setProtocolInterface", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "stake", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "unsetProtocolInterface", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "unstake", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeToAndCall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawProtocolFunds", data: BytesLike): Result;
    events: {
        "AdminChanged(address,address)": EventFragment;
        "BeaconUpgraded(address)": EventFragment;
        "ClaimInterest(address,address,uint256)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "ProtocolClaimInterest(address,address,uint256)": EventFragment;
        "ProtocolDepositFunds(address,address,uint256)": EventFragment;
        "ProtocolReturnFunds(address,address,uint256)": EventFragment;
        "SetProtocolInterface(address,address)": EventFragment;
        "Stake(address,address,address,uint256)": EventFragment;
        "UnsetProtocolInterface(address,address)": EventFragment;
        "Unstake(address,address,address,uint256)": EventFragment;
        "Upgraded(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "AdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "BeaconUpgraded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ClaimInterest"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ProtocolClaimInterest"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ProtocolDepositFunds"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ProtocolReturnFunds"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetProtocolInterface"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Stake"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UnsetProtocolInterface"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Unstake"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Upgraded"): EventFragment;
}
export type AdminChangedEvent = TypedEvent<[
    string,
    string
], {
    previousAdmin: string;
    newAdmin: string;
}>;
export type AdminChangedEventFilter = TypedEventFilter<AdminChangedEvent>;
export type BeaconUpgradedEvent = TypedEvent<[string], {
    beacon: string;
}>;
export type BeaconUpgradedEventFilter = TypedEventFilter<BeaconUpgradedEvent>;
export type ClaimInterestEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    acount: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type ClaimInterestEventFilter = TypedEventFilter<ClaimInterestEvent>;
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], {
    previousOwner: string;
    newOwner: string;
}>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export type ProtocolClaimInterestEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    protocolInterfaceAddress: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type ProtocolClaimInterestEventFilter = TypedEventFilter<ProtocolClaimInterestEvent>;
export type ProtocolDepositFundsEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    protocolInterfaceAddress: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type ProtocolDepositFundsEventFilter = TypedEventFilter<ProtocolDepositFundsEvent>;
export type ProtocolReturnFundsEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    protocolInterfaceAddress: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type ProtocolReturnFundsEventFilter = TypedEventFilter<ProtocolReturnFundsEvent>;
export type SetProtocolInterfaceEvent = TypedEvent<[
    string,
    string
], {
    protocolInterfaceAddress: string;
    collateralToken: string;
}>;
export type SetProtocolInterfaceEventFilter = TypedEventFilter<SetProtocolInterfaceEvent>;
export type StakeEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber
], {
    account: string;
    fxToken: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type StakeEventFilter = TypedEventFilter<StakeEvent>;
export type UnsetProtocolInterfaceEvent = TypedEvent<[
    string,
    string
], {
    protocolInterfaceAddress: string;
    collateralToken: string;
}>;
export type UnsetProtocolInterfaceEventFilter = TypedEventFilter<UnsetProtocolInterfaceEvent>;
export type UnstakeEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber
], {
    account: string;
    fxToken: string;
    collateralToken: string;
    amount: BigNumber;
}>;
export type UnstakeEventFilter = TypedEventFilter<UnstakeEvent>;
export type UpgradedEvent = TypedEvent<[string], {
    implementation: string;
}>;
export type UpgradedEventFilter = TypedEventFilter<UpgradedEvent>;
export interface PCT extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: PCTInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        balanceOfClaimableInterest(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        balanceOfStake(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        claimInterest(fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        claimProtocolInterest(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        depositProtocolFunds(collateralToken: string, pia: string, ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        getProtocolInvestments(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        getTotalAccruedInterest(collateralToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        getTotalDeposits(collateralToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        getTotalInvestments(collateralToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            amount: BigNumber;
        }>;
        handleAddress(overrides?: CallOverrides): Promise<[string]>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        protocolFee(overrides?: CallOverrides): Promise<[BigNumber]>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        requestTreasuryFunds(collateralToken: string, requestedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        returnTreasuryFunds(collateralToken: string, returnedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setProtocolFee(ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        stake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        unsetProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        unstake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        withdrawProtocolFunds(collateralToken: string, pia: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
    };
    balanceOfClaimableInterest(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    balanceOfStake(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    claimInterest(fxToken: string, collateralToken: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    claimProtocolInterest(collateralToken: string, pia: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    depositProtocolFunds(collateralToken: string, pia: string, ratio: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    getProtocolInvestments(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<BigNumber>;
    getTotalAccruedInterest(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getTotalDeposits(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getTotalInvestments(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    handleAddress(overrides?: CallOverrides): Promise<string>;
    initialize(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    owner(overrides?: CallOverrides): Promise<string>;
    protocolFee(overrides?: CallOverrides): Promise<BigNumber>;
    renounceOwnership(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    requestTreasuryFunds(collateralToken: string, requestedToken: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    returnTreasuryFunds(collateralToken: string, returnedToken: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setHandleContract(_handle: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setProtocolFee(ratio: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    stake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    unsetProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    unstake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeTo(newImplementation: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    withdrawProtocolFunds(collateralToken: string, pia: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        balanceOfClaimableInterest(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        balanceOfStake(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        claimInterest(fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<void>;
        claimProtocolInterest(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<void>;
        depositProtocolFunds(collateralToken: string, pia: string, ratio: BigNumberish, overrides?: CallOverrides): Promise<void>;
        getProtocolInvestments(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalAccruedInterest(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalDeposits(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalInvestments(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        handleAddress(overrides?: CallOverrides): Promise<string>;
        initialize(overrides?: CallOverrides): Promise<void>;
        owner(overrides?: CallOverrides): Promise<string>;
        protocolFee(overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        requestTreasuryFunds(collateralToken: string, requestedToken: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        returnTreasuryFunds(collateralToken: string, returnedToken: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setHandleContract(_handle: string, overrides?: CallOverrides): Promise<void>;
        setProtocolFee(ratio: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setProtocolInterface(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<void>;
        stake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: CallOverrides): Promise<void>;
        unsetProtocolInterface(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<void>;
        unstake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        upgradeTo(newImplementation: string, overrides?: CallOverrides): Promise<void>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: CallOverrides): Promise<void>;
        withdrawProtocolFunds(collateralToken: string, pia: string, amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "AdminChanged(address,address)"(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        AdminChanged(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        "BeaconUpgraded(address)"(beacon?: string | null): BeaconUpgradedEventFilter;
        BeaconUpgraded(beacon?: string | null): BeaconUpgradedEventFilter;
        "ClaimInterest(address,address,uint256)"(acount?: string | null, collateralToken?: string | null, amount?: null): ClaimInterestEventFilter;
        ClaimInterest(acount?: string | null, collateralToken?: string | null, amount?: null): ClaimInterestEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        "ProtocolClaimInterest(address,address,uint256)"(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolClaimInterestEventFilter;
        ProtocolClaimInterest(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolClaimInterestEventFilter;
        "ProtocolDepositFunds(address,address,uint256)"(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolDepositFundsEventFilter;
        ProtocolDepositFunds(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolDepositFundsEventFilter;
        "ProtocolReturnFunds(address,address,uint256)"(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolReturnFundsEventFilter;
        ProtocolReturnFunds(protocolInterfaceAddress?: string | null, collateralToken?: string | null, amount?: null): ProtocolReturnFundsEventFilter;
        "SetProtocolInterface(address,address)"(protocolInterfaceAddress?: string | null, collateralToken?: string | null): SetProtocolInterfaceEventFilter;
        SetProtocolInterface(protocolInterfaceAddress?: string | null, collateralToken?: string | null): SetProtocolInterfaceEventFilter;
        "Stake(address,address,address,uint256)"(account?: string | null, fxToken?: string | null, collateralToken?: string | null, amount?: null): StakeEventFilter;
        Stake(account?: string | null, fxToken?: string | null, collateralToken?: string | null, amount?: null): StakeEventFilter;
        "UnsetProtocolInterface(address,address)"(protocolInterfaceAddress?: string | null, collateralToken?: string | null): UnsetProtocolInterfaceEventFilter;
        UnsetProtocolInterface(protocolInterfaceAddress?: string | null, collateralToken?: string | null): UnsetProtocolInterfaceEventFilter;
        "Unstake(address,address,address,uint256)"(account?: string | null, fxToken?: string | null, collateralToken?: string | null, amount?: null): UnstakeEventFilter;
        Unstake(account?: string | null, fxToken?: string | null, collateralToken?: string | null, amount?: null): UnstakeEventFilter;
        "Upgraded(address)"(implementation?: string | null): UpgradedEventFilter;
        Upgraded(implementation?: string | null): UpgradedEventFilter;
    };
    estimateGas: {
        balanceOfClaimableInterest(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        balanceOfStake(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        claimInterest(fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        claimProtocolInterest(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        depositProtocolFunds(collateralToken: string, pia: string, ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        getProtocolInvestments(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalAccruedInterest(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalDeposits(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalInvestments(collateralToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        handleAddress(overrides?: CallOverrides): Promise<BigNumber>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        protocolFee(overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        requestTreasuryFunds(collateralToken: string, requestedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        returnTreasuryFunds(collateralToken: string, returnedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setProtocolFee(ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        stake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        unsetProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        unstake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        withdrawProtocolFunds(collateralToken: string, pia: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        balanceOfClaimableInterest(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        balanceOfStake(account: string, fxToken: string, collateralToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        claimInterest(fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        claimProtocolInterest(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        depositProtocolFunds(collateralToken: string, pia: string, ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        getProtocolInvestments(collateralToken: string, pia: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalAccruedInterest(collateralToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalDeposits(collateralToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalInvestments(collateralToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        handleAddress(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        protocolFee(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        requestTreasuryFunds(collateralToken: string, requestedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        returnTreasuryFunds(collateralToken: string, returnedToken: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setProtocolFee(ratio: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        stake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        unsetProtocolInterface(collateralToken: string, pia: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        unstake(account: string, amount: BigNumberish, fxToken: string, collateralToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        withdrawProtocolFunds(collateralToken: string, pia: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
    };
}
