import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface SushiKashiInterface extends utils.Interface {
    functions: {
        "DOMAIN_SEPARATOR()": FunctionFragment;
        "accrue()": FunctionFragment;
        "accrueInfo()": FunctionFragment;
        "addAsset(address,bool,uint256)": FunctionFragment;
        "addCollateral(address,bool,uint256)": FunctionFragment;
        "allowance(address,address)": FunctionFragment;
        "approve(address,uint256)": FunctionFragment;
        "asset()": FunctionFragment;
        "balanceOf(address)": FunctionFragment;
        "bentoBox()": FunctionFragment;
        "borrow(address,uint256)": FunctionFragment;
        "claimOwnership()": FunctionFragment;
        "collateral()": FunctionFragment;
        "cook(uint8[],uint256[],bytes[])": FunctionFragment;
        "decimals()": FunctionFragment;
        "exchangeRate()": FunctionFragment;
        "feeTo()": FunctionFragment;
        "init(bytes)": FunctionFragment;
        "liquidate(address[],uint256[],address,address,bool)": FunctionFragment;
        "masterContract()": FunctionFragment;
        "name()": FunctionFragment;
        "nonces(address)": FunctionFragment;
        "oracle()": FunctionFragment;
        "oracleData()": FunctionFragment;
        "owner()": FunctionFragment;
        "pendingOwner()": FunctionFragment;
        "permit(address,address,uint256,uint256,uint8,bytes32,bytes32)": FunctionFragment;
        "removeAsset(address,uint256)": FunctionFragment;
        "removeCollateral(address,uint256)": FunctionFragment;
        "repay(address,bool,uint256)": FunctionFragment;
        "setFeeTo(address)": FunctionFragment;
        "setSwapper(address,bool)": FunctionFragment;
        "swappers(address)": FunctionFragment;
        "symbol()": FunctionFragment;
        "totalAsset()": FunctionFragment;
        "totalBorrow()": FunctionFragment;
        "totalCollateralShare()": FunctionFragment;
        "totalSupply()": FunctionFragment;
        "transfer(address,uint256)": FunctionFragment;
        "transferFrom(address,address,uint256)": FunctionFragment;
        "transferOwnership(address,bool,bool)": FunctionFragment;
        "updateExchangeRate()": FunctionFragment;
        "userBorrowPart(address)": FunctionFragment;
        "userCollateralShare(address)": FunctionFragment;
        "withdrawFees()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "DOMAIN_SEPARATOR", values?: undefined): string;
    encodeFunctionData(functionFragment: "accrue", values?: undefined): string;
    encodeFunctionData(functionFragment: "accrueInfo", values?: undefined): string;
    encodeFunctionData(functionFragment: "addAsset", values: [string, boolean, BigNumberish]): string;
    encodeFunctionData(functionFragment: "addCollateral", values: [string, boolean, BigNumberish]): string;
    encodeFunctionData(functionFragment: "allowance", values: [string, string]): string;
    encodeFunctionData(functionFragment: "approve", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "asset", values?: undefined): string;
    encodeFunctionData(functionFragment: "balanceOf", values: [string]): string;
    encodeFunctionData(functionFragment: "bentoBox", values?: undefined): string;
    encodeFunctionData(functionFragment: "borrow", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "claimOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateral", values?: undefined): string;
    encodeFunctionData(functionFragment: "cook", values: [BigNumberish[], BigNumberish[], BytesLike[]]): string;
    encodeFunctionData(functionFragment: "decimals", values?: undefined): string;
    encodeFunctionData(functionFragment: "exchangeRate", values?: undefined): string;
    encodeFunctionData(functionFragment: "feeTo", values?: undefined): string;
    encodeFunctionData(functionFragment: "init", values: [BytesLike]): string;
    encodeFunctionData(functionFragment: "liquidate", values: [string[], BigNumberish[], string, string, boolean]): string;
    encodeFunctionData(functionFragment: "masterContract", values?: undefined): string;
    encodeFunctionData(functionFragment: "name", values?: undefined): string;
    encodeFunctionData(functionFragment: "nonces", values: [string]): string;
    encodeFunctionData(functionFragment: "oracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "oracleData", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingOwner", values?: undefined): string;
    encodeFunctionData(functionFragment: "permit", values: [
        string,
        string,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BytesLike,
        BytesLike
    ]): string;
    encodeFunctionData(functionFragment: "removeAsset", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "removeCollateral", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "repay", values: [string, boolean, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setFeeTo", values: [string]): string;
    encodeFunctionData(functionFragment: "setSwapper", values: [string, boolean]): string;
    encodeFunctionData(functionFragment: "swappers", values: [string]): string;
    encodeFunctionData(functionFragment: "symbol", values?: undefined): string;
    encodeFunctionData(functionFragment: "totalAsset", values?: undefined): string;
    encodeFunctionData(functionFragment: "totalBorrow", values?: undefined): string;
    encodeFunctionData(functionFragment: "totalCollateralShare", values?: undefined): string;
    encodeFunctionData(functionFragment: "totalSupply", values?: undefined): string;
    encodeFunctionData(functionFragment: "transfer", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "transferFrom", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [string, boolean, boolean]): string;
    encodeFunctionData(functionFragment: "updateExchangeRate", values?: undefined): string;
    encodeFunctionData(functionFragment: "userBorrowPart", values: [string]): string;
    encodeFunctionData(functionFragment: "userCollateralShare", values: [string]): string;
    encodeFunctionData(functionFragment: "withdrawFees", values?: undefined): string;
    decodeFunctionResult(functionFragment: "DOMAIN_SEPARATOR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "accrue", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "accrueInfo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "addAsset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "addCollateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allowance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approve", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "asset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "bentoBox", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "borrow", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "cook", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "feeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "init", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "masterContract", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "name", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "nonces", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "oracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "oracleData", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "permit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeAsset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeCollateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "repay", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFeeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setSwapper", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "swappers", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "symbol", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalAsset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalBorrow", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalCollateralShare", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalSupply", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transfer", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferFrom", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateExchangeRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "userBorrowPart", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "userCollateralShare", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawFees", data: BytesLike): Result;
    events: {
        "Approval(address,address,uint256)": EventFragment;
        "LogAccrue(uint256,uint256,uint64,uint256)": EventFragment;
        "LogAddAsset(address,address,uint256,uint256)": EventFragment;
        "LogAddCollateral(address,address,uint256)": EventFragment;
        "LogBorrow(address,address,uint256,uint256,uint256)": EventFragment;
        "LogExchangeRate(uint256)": EventFragment;
        "LogFeeTo(address)": EventFragment;
        "LogRemoveAsset(address,address,uint256,uint256)": EventFragment;
        "LogRemoveCollateral(address,address,uint256)": EventFragment;
        "LogRepay(address,address,uint256,uint256)": EventFragment;
        "LogWithdrawFees(address,uint256)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "Transfer(address,address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Approval"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogAccrue"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogAddAsset"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogAddCollateral"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogBorrow"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogExchangeRate"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogFeeTo"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogRemoveAsset"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogRemoveCollateral"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogRepay"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogWithdrawFees"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Transfer"): EventFragment;
}
export type ApprovalEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    _owner: string;
    _spender: string;
    _value: BigNumber;
}>;
export type ApprovalEventFilter = TypedEventFilter<ApprovalEvent>;
export type LogAccrueEvent = TypedEvent<[
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
], {
    accruedAmount: BigNumber;
    feeFraction: BigNumber;
    rate: BigNumber;
    utilization: BigNumber;
}>;
export type LogAccrueEventFilter = TypedEventFilter<LogAccrueEvent>;
export type LogAddAssetEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber
], {
    from: string;
    to: string;
    share: BigNumber;
    fraction: BigNumber;
}>;
export type LogAddAssetEventFilter = TypedEventFilter<LogAddAssetEvent>;
export type LogAddCollateralEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    from: string;
    to: string;
    share: BigNumber;
}>;
export type LogAddCollateralEventFilter = TypedEventFilter<LogAddCollateralEvent>;
export type LogBorrowEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber,
    BigNumber
], {
    from: string;
    to: string;
    amount: BigNumber;
    feeAmount: BigNumber;
    part: BigNumber;
}>;
export type LogBorrowEventFilter = TypedEventFilter<LogBorrowEvent>;
export type LogExchangeRateEvent = TypedEvent<[BigNumber], {
    rate: BigNumber;
}>;
export type LogExchangeRateEventFilter = TypedEventFilter<LogExchangeRateEvent>;
export type LogFeeToEvent = TypedEvent<[string], {
    newFeeTo: string;
}>;
export type LogFeeToEventFilter = TypedEventFilter<LogFeeToEvent>;
export type LogRemoveAssetEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber
], {
    from: string;
    to: string;
    share: BigNumber;
    fraction: BigNumber;
}>;
export type LogRemoveAssetEventFilter = TypedEventFilter<LogRemoveAssetEvent>;
export type LogRemoveCollateralEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    from: string;
    to: string;
    share: BigNumber;
}>;
export type LogRemoveCollateralEventFilter = TypedEventFilter<LogRemoveCollateralEvent>;
export type LogRepayEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber
], {
    from: string;
    to: string;
    amount: BigNumber;
    part: BigNumber;
}>;
export type LogRepayEventFilter = TypedEventFilter<LogRepayEvent>;
export type LogWithdrawFeesEvent = TypedEvent<[
    string,
    BigNumber
], {
    feeTo: string;
    feesEarnedFraction: BigNumber;
}>;
export type LogWithdrawFeesEventFilter = TypedEventFilter<LogWithdrawFeesEvent>;
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], {
    previousOwner: string;
    newOwner: string;
}>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export type TransferEvent = TypedEvent<[
    string,
    string,
    BigNumber
], {
    _from: string;
    _to: string;
    _value: BigNumber;
}>;
export type TransferEventFilter = TypedEventFilter<TransferEvent>;
export interface SushiKashi extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: SushiKashiInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        DOMAIN_SEPARATOR(overrides?: CallOverrides): Promise<[string]>;
        accrue(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        accrueInfo(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            interestPerSecond: BigNumber;
            lastAccrued: BigNumber;
            feesEarnedFraction: BigNumber;
        }>;
        addAsset(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        addCollateral(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        allowance(arg0: string, arg1: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        approve(spender: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        asset(overrides?: CallOverrides): Promise<[string]>;
        balanceOf(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        bentoBox(overrides?: CallOverrides): Promise<[string]>;
        borrow(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        claimOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        collateral(overrides?: CallOverrides): Promise<[string]>;
        cook(actions: BigNumberish[], values: BigNumberish[], datas: BytesLike[], overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        decimals(overrides?: CallOverrides): Promise<[number]>;
        exchangeRate(overrides?: CallOverrides): Promise<[BigNumber]>;
        feeTo(overrides?: CallOverrides): Promise<[string]>;
        init(data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        liquidate(users: string[], maxBorrowParts: BigNumberish[], to: string, swapper: string, open: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        masterContract(overrides?: CallOverrides): Promise<[string]>;
        name(overrides?: CallOverrides): Promise<[string]>;
        nonces(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        oracle(overrides?: CallOverrides): Promise<[string]>;
        oracleData(overrides?: CallOverrides): Promise<[string]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        pendingOwner(overrides?: CallOverrides): Promise<[string]>;
        permit(owner_: string, spender: string, value: BigNumberish, deadline: BigNumberish, v: BigNumberish, r: BytesLike, s: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        removeAsset(to: string, fraction: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        removeCollateral(to: string, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        repay(to: string, skim: boolean, part: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setFeeTo(newFeeTo: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setSwapper(swapper: string, enable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        swappers(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        symbol(overrides?: CallOverrides): Promise<[string]>;
        totalAsset(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            elastic: BigNumber;
            base: BigNumber;
        }>;
        totalBorrow(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            elastic: BigNumber;
            base: BigNumber;
        }>;
        totalCollateralShare(overrides?: CallOverrides): Promise<[BigNumber]>;
        totalSupply(overrides?: CallOverrides): Promise<[BigNumber]>;
        transfer(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        transferFrom(from: string, to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: string, direct: boolean, renounce: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        updateExchangeRate(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        userBorrowPart(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        userCollateralShare(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        withdrawFees(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
    };
    DOMAIN_SEPARATOR(overrides?: CallOverrides): Promise<string>;
    accrue(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    accrueInfo(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        interestPerSecond: BigNumber;
        lastAccrued: BigNumber;
        feesEarnedFraction: BigNumber;
    }>;
    addAsset(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    addCollateral(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    allowance(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
    approve(spender: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    asset(overrides?: CallOverrides): Promise<string>;
    balanceOf(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    bentoBox(overrides?: CallOverrides): Promise<string>;
    borrow(to: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    claimOwnership(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    collateral(overrides?: CallOverrides): Promise<string>;
    cook(actions: BigNumberish[], values: BigNumberish[], datas: BytesLike[], overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    decimals(overrides?: CallOverrides): Promise<number>;
    exchangeRate(overrides?: CallOverrides): Promise<BigNumber>;
    feeTo(overrides?: CallOverrides): Promise<string>;
    init(data: BytesLike, overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    liquidate(users: string[], maxBorrowParts: BigNumberish[], to: string, swapper: string, open: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    masterContract(overrides?: CallOverrides): Promise<string>;
    name(overrides?: CallOverrides): Promise<string>;
    nonces(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    oracle(overrides?: CallOverrides): Promise<string>;
    oracleData(overrides?: CallOverrides): Promise<string>;
    owner(overrides?: CallOverrides): Promise<string>;
    pendingOwner(overrides?: CallOverrides): Promise<string>;
    permit(owner_: string, spender: string, value: BigNumberish, deadline: BigNumberish, v: BigNumberish, r: BytesLike, s: BytesLike, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    removeAsset(to: string, fraction: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    removeCollateral(to: string, share: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    repay(to: string, skim: boolean, part: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setFeeTo(newFeeTo: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setSwapper(swapper: string, enable: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    swappers(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    symbol(overrides?: CallOverrides): Promise<string>;
    totalAsset(overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
        elastic: BigNumber;
        base: BigNumber;
    }>;
    totalBorrow(overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
        elastic: BigNumber;
        base: BigNumber;
    }>;
    totalCollateralShare(overrides?: CallOverrides): Promise<BigNumber>;
    totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
    transfer(to: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    transferFrom(from: string, to: string, amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: string, direct: boolean, renounce: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    updateExchangeRate(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    userBorrowPart(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    userCollateralShare(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    withdrawFees(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        DOMAIN_SEPARATOR(overrides?: CallOverrides): Promise<string>;
        accrue(overrides?: CallOverrides): Promise<void>;
        accrueInfo(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            interestPerSecond: BigNumber;
            lastAccrued: BigNumber;
            feesEarnedFraction: BigNumber;
        }>;
        addAsset(to: string, skim: boolean, share: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        addCollateral(to: string, skim: boolean, share: BigNumberish, overrides?: CallOverrides): Promise<void>;
        allowance(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        approve(spender: string, amount: BigNumberish, overrides?: CallOverrides): Promise<boolean>;
        asset(overrides?: CallOverrides): Promise<string>;
        balanceOf(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        bentoBox(overrides?: CallOverrides): Promise<string>;
        borrow(to: string, amount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
            part: BigNumber;
            share: BigNumber;
        }>;
        claimOwnership(overrides?: CallOverrides): Promise<void>;
        collateral(overrides?: CallOverrides): Promise<string>;
        cook(actions: BigNumberish[], values: BigNumberish[], datas: BytesLike[], overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            value1: BigNumber;
            value2: BigNumber;
        }>;
        decimals(overrides?: CallOverrides): Promise<number>;
        exchangeRate(overrides?: CallOverrides): Promise<BigNumber>;
        feeTo(overrides?: CallOverrides): Promise<string>;
        init(data: BytesLike, overrides?: CallOverrides): Promise<void>;
        liquidate(users: string[], maxBorrowParts: BigNumberish[], to: string, swapper: string, open: boolean, overrides?: CallOverrides): Promise<void>;
        masterContract(overrides?: CallOverrides): Promise<string>;
        name(overrides?: CallOverrides): Promise<string>;
        nonces(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        oracle(overrides?: CallOverrides): Promise<string>;
        oracleData(overrides?: CallOverrides): Promise<string>;
        owner(overrides?: CallOverrides): Promise<string>;
        pendingOwner(overrides?: CallOverrides): Promise<string>;
        permit(owner_: string, spender: string, value: BigNumberish, deadline: BigNumberish, v: BigNumberish, r: BytesLike, s: BytesLike, overrides?: CallOverrides): Promise<void>;
        removeAsset(to: string, fraction: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        removeCollateral(to: string, share: BigNumberish, overrides?: CallOverrides): Promise<void>;
        repay(to: string, skim: boolean, part: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        setFeeTo(newFeeTo: string, overrides?: CallOverrides): Promise<void>;
        setSwapper(swapper: string, enable: boolean, overrides?: CallOverrides): Promise<void>;
        swappers(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        symbol(overrides?: CallOverrides): Promise<string>;
        totalAsset(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            elastic: BigNumber;
            base: BigNumber;
        }>;
        totalBorrow(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            elastic: BigNumber;
            base: BigNumber;
        }>;
        totalCollateralShare(overrides?: CallOverrides): Promise<BigNumber>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transfer(to: string, amount: BigNumberish, overrides?: CallOverrides): Promise<boolean>;
        transferFrom(from: string, to: string, amount: BigNumberish, overrides?: CallOverrides): Promise<boolean>;
        transferOwnership(newOwner: string, direct: boolean, renounce: boolean, overrides?: CallOverrides): Promise<void>;
        updateExchangeRate(overrides?: CallOverrides): Promise<[boolean, BigNumber] & {
            updated: boolean;
            rate: BigNumber;
        }>;
        userBorrowPart(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        userCollateralShare(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        withdrawFees(overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "Approval(address,address,uint256)"(_owner?: string | null, _spender?: string | null, _value?: null): ApprovalEventFilter;
        Approval(_owner?: string | null, _spender?: string | null, _value?: null): ApprovalEventFilter;
        "LogAccrue(uint256,uint256,uint64,uint256)"(accruedAmount?: null, feeFraction?: null, rate?: null, utilization?: null): LogAccrueEventFilter;
        LogAccrue(accruedAmount?: null, feeFraction?: null, rate?: null, utilization?: null): LogAccrueEventFilter;
        "LogAddAsset(address,address,uint256,uint256)"(from?: string | null, to?: string | null, share?: null, fraction?: null): LogAddAssetEventFilter;
        LogAddAsset(from?: string | null, to?: string | null, share?: null, fraction?: null): LogAddAssetEventFilter;
        "LogAddCollateral(address,address,uint256)"(from?: string | null, to?: string | null, share?: null): LogAddCollateralEventFilter;
        LogAddCollateral(from?: string | null, to?: string | null, share?: null): LogAddCollateralEventFilter;
        "LogBorrow(address,address,uint256,uint256,uint256)"(from?: string | null, to?: string | null, amount?: null, feeAmount?: null, part?: null): LogBorrowEventFilter;
        LogBorrow(from?: string | null, to?: string | null, amount?: null, feeAmount?: null, part?: null): LogBorrowEventFilter;
        "LogExchangeRate(uint256)"(rate?: null): LogExchangeRateEventFilter;
        LogExchangeRate(rate?: null): LogExchangeRateEventFilter;
        "LogFeeTo(address)"(newFeeTo?: string | null): LogFeeToEventFilter;
        LogFeeTo(newFeeTo?: string | null): LogFeeToEventFilter;
        "LogRemoveAsset(address,address,uint256,uint256)"(from?: string | null, to?: string | null, share?: null, fraction?: null): LogRemoveAssetEventFilter;
        LogRemoveAsset(from?: string | null, to?: string | null, share?: null, fraction?: null): LogRemoveAssetEventFilter;
        "LogRemoveCollateral(address,address,uint256)"(from?: string | null, to?: string | null, share?: null): LogRemoveCollateralEventFilter;
        LogRemoveCollateral(from?: string | null, to?: string | null, share?: null): LogRemoveCollateralEventFilter;
        "LogRepay(address,address,uint256,uint256)"(from?: string | null, to?: string | null, amount?: null, part?: null): LogRepayEventFilter;
        LogRepay(from?: string | null, to?: string | null, amount?: null, part?: null): LogRepayEventFilter;
        "LogWithdrawFees(address,uint256)"(feeTo?: string | null, feesEarnedFraction?: null): LogWithdrawFeesEventFilter;
        LogWithdrawFees(feeTo?: string | null, feesEarnedFraction?: null): LogWithdrawFeesEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        "Transfer(address,address,uint256)"(_from?: string | null, _to?: string | null, _value?: null): TransferEventFilter;
        Transfer(_from?: string | null, _to?: string | null, _value?: null): TransferEventFilter;
    };
    estimateGas: {
        DOMAIN_SEPARATOR(overrides?: CallOverrides): Promise<BigNumber>;
        accrue(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        accrueInfo(overrides?: CallOverrides): Promise<BigNumber>;
        addAsset(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        addCollateral(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        allowance(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        approve(spender: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        asset(overrides?: CallOverrides): Promise<BigNumber>;
        balanceOf(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        bentoBox(overrides?: CallOverrides): Promise<BigNumber>;
        borrow(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        claimOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        collateral(overrides?: CallOverrides): Promise<BigNumber>;
        cook(actions: BigNumberish[], values: BigNumberish[], datas: BytesLike[], overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        decimals(overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRate(overrides?: CallOverrides): Promise<BigNumber>;
        feeTo(overrides?: CallOverrides): Promise<BigNumber>;
        init(data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        liquidate(users: string[], maxBorrowParts: BigNumberish[], to: string, swapper: string, open: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        masterContract(overrides?: CallOverrides): Promise<BigNumber>;
        name(overrides?: CallOverrides): Promise<BigNumber>;
        nonces(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        oracle(overrides?: CallOverrides): Promise<BigNumber>;
        oracleData(overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        pendingOwner(overrides?: CallOverrides): Promise<BigNumber>;
        permit(owner_: string, spender: string, value: BigNumberish, deadline: BigNumberish, v: BigNumberish, r: BytesLike, s: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        removeAsset(to: string, fraction: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        removeCollateral(to: string, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        repay(to: string, skim: boolean, part: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setFeeTo(newFeeTo: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setSwapper(swapper: string, enable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        swappers(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        symbol(overrides?: CallOverrides): Promise<BigNumber>;
        totalAsset(overrides?: CallOverrides): Promise<BigNumber>;
        totalBorrow(overrides?: CallOverrides): Promise<BigNumber>;
        totalCollateralShare(overrides?: CallOverrides): Promise<BigNumber>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transfer(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        transferFrom(from: string, to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: string, direct: boolean, renounce: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        updateExchangeRate(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        userBorrowPart(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        userCollateralShare(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        withdrawFees(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        DOMAIN_SEPARATOR(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        accrue(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        accrueInfo(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        addAsset(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        addCollateral(to: string, skim: boolean, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        allowance(arg0: string, arg1: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        approve(spender: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        asset(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        balanceOf(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        bentoBox(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        borrow(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        claimOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        collateral(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        cook(actions: BigNumberish[], values: BigNumberish[], datas: BytesLike[], overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        decimals(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        exchangeRate(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        feeTo(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        init(data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        liquidate(users: string[], maxBorrowParts: BigNumberish[], to: string, swapper: string, open: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        masterContract(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        name(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        nonces(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        oracle(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        oracleData(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingOwner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        permit(owner_: string, spender: string, value: BigNumberish, deadline: BigNumberish, v: BigNumberish, r: BytesLike, s: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        removeAsset(to: string, fraction: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        removeCollateral(to: string, share: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        repay(to: string, skim: boolean, part: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setFeeTo(newFeeTo: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setSwapper(swapper: string, enable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        swappers(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        symbol(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalAsset(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalBorrow(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalCollateralShare(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalSupply(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        transfer(to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        transferFrom(from: string, to: string, amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: string, direct: boolean, renounce: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        updateExchangeRate(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        userBorrowPart(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        userCollateralShare(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdrawFees(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
    };
}
