import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface VaultInterface extends utils.Interface {
    functions: {
        "addRouter(address)": FunctionFragment;
        "adjustForDecimals(uint256,address,address)": FunctionFragment;
        "allWhitelistedTokens(uint256)": FunctionFragment;
        "allWhitelistedTokensLength()": FunctionFragment;
        "approvedRouters(address,address)": FunctionFragment;
        "bufferAmounts(address)": FunctionFragment;
        "buyUSDG(address,address)": FunctionFragment;
        "clearTokenConfig(address)": FunctionFragment;
        "cumulativeFundingRates(address)": FunctionFragment;
        "decreasePosition(address,address,address,uint256,uint256,bool,address)": FunctionFragment;
        "directPoolDeposit(address)": FunctionFragment;
        "errorController()": FunctionFragment;
        "feeReserves(address)": FunctionFragment;
        "fundingInterval()": FunctionFragment;
        "fundingRateFactor()": FunctionFragment;
        "getMaxPrice(address)": FunctionFragment;
        "getMinPrice(address)": FunctionFragment;
        "getNextAveragePrice(address,uint256,uint256,bool,uint256,uint256,uint256)": FunctionFragment;
        "getNextFundingRate(address)": FunctionFragment;
        "getNextGlobalShortAveragePrice(address,uint256,uint256)": FunctionFragment;
        "getPosition(address,address,address,bool)": FunctionFragment;
        "getPositionKey(address,address,address,bool)": FunctionFragment;
        "getRedemptionAmount(address,uint256)": FunctionFragment;
        "globalShortAveragePrices(address)": FunctionFragment;
        "globalShortSizes(address)": FunctionFragment;
        "gov()": FunctionFragment;
        "guaranteedUsd(address)": FunctionFragment;
        "hasDynamicFees()": FunctionFragment;
        "inManagerMode()": FunctionFragment;
        "inPrivateLiquidationMode()": FunctionFragment;
        "increasePosition(address,address,address,uint256,bool)": FunctionFragment;
        "initialize()": FunctionFragment;
        "initializeConfig(address,address,address,uint256,uint256,uint256)": FunctionFragment;
        "isInitialized()": FunctionFragment;
        "isLeverageEnabled()": FunctionFragment;
        "isLiquidator(address)": FunctionFragment;
        "isManager(address)": FunctionFragment;
        "isSwapEnabled()": FunctionFragment;
        "lastFundingTimes(address)": FunctionFragment;
        "liquidatePosition(address,address,address,bool,address,bytes)": FunctionFragment;
        "liquidationFeeUsd()": FunctionFragment;
        "marginFeeBasisPoints()": FunctionFragment;
        "maxGasPrice()": FunctionFragment;
        "maxGlobalShortSizes(address)": FunctionFragment;
        "maxLeverage()": FunctionFragment;
        "maxUsdgAmounts(address)": FunctionFragment;
        "minProfitBasisPoints(address)": FunctionFragment;
        "minProfitTime()": FunctionFragment;
        "mintBurnFeeBasisPoints()": FunctionFragment;
        "poolAmounts(address)": FunctionFragment;
        "positions(bytes32)": FunctionFragment;
        "priceFeed()": FunctionFragment;
        "removeRouter(address)": FunctionFragment;
        "reservedAmounts(address)": FunctionFragment;
        "router()": FunctionFragment;
        "sellUSDG(address,address)": FunctionFragment;
        "setBufferAmount(address,uint256)": FunctionFragment;
        "setError(uint256,string)": FunctionFragment;
        "setErrorController(address)": FunctionFragment;
        "setFees(uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256,bool)": FunctionFragment;
        "setFundingRate(uint256,uint256,uint256)": FunctionFragment;
        "setGov(address)": FunctionFragment;
        "setInManagerMode(bool)": FunctionFragment;
        "setInPrivateLiquidationMode(bool)": FunctionFragment;
        "setIsLeverageEnabled(bool)": FunctionFragment;
        "setIsSwapEnabled(bool)": FunctionFragment;
        "setLiquidator(address,bool)": FunctionFragment;
        "setManager(address,bool)": FunctionFragment;
        "setMaxGasPrice(uint256)": FunctionFragment;
        "setMaxGlobalShortSize(address,uint256)": FunctionFragment;
        "setMaxLeverage(uint256)": FunctionFragment;
        "setPriceFeed(address)": FunctionFragment;
        "setRebates(address)": FunctionFragment;
        "setRouter(address)": FunctionFragment;
        "setTokenConfig(address,uint256,uint256,uint256,uint256,bool,bool)": FunctionFragment;
        "setUsdgAmount(address,uint256)": FunctionFragment;
        "setVaultUtils(address)": FunctionFragment;
        "shortableTokens(address)": FunctionFragment;
        "stableFundingRateFactor()": FunctionFragment;
        "stableSwapFeeBasisPoints()": FunctionFragment;
        "stableTaxBasisPoints()": FunctionFragment;
        "stableTokens(address)": FunctionFragment;
        "swap(address,address,address)": FunctionFragment;
        "swapFeeBasisPoints()": FunctionFragment;
        "swapWithRebateReceiver(address,address,address,address)": FunctionFragment;
        "taxBasisPoints()": FunctionFragment;
        "tokenBalances(address)": FunctionFragment;
        "tokenDecimals(address)": FunctionFragment;
        "tokenToUsdMin(address,uint256)": FunctionFragment;
        "tokenWeights(address)": FunctionFragment;
        "totalTokenWeights()": FunctionFragment;
        "updateCumulativeFundingRate(address,address)": FunctionFragment;
        "upgradeVault(address,address,uint256)": FunctionFragment;
        "usdToToken(address,uint256,uint256)": FunctionFragment;
        "usdToTokenMax(address,uint256)": FunctionFragment;
        "usdToTokenMin(address,uint256)": FunctionFragment;
        "usdg()": FunctionFragment;
        "usdgAmounts(address)": FunctionFragment;
        "vaultUtils()": FunctionFragment;
        "whitelistedTokenCount()": FunctionFragment;
        "whitelistedTokens(address)": FunctionFragment;
        "withdrawFees(address,address)": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "addRouter", values: [string]): string;
    encodeFunctionData(functionFragment: "adjustForDecimals", values: [BigNumberish, string, string]): string;
    encodeFunctionData(functionFragment: "allWhitelistedTokens", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "allWhitelistedTokensLength", values?: undefined): string;
    encodeFunctionData(functionFragment: "approvedRouters", values: [string, string]): string;
    encodeFunctionData(functionFragment: "bufferAmounts", values: [string]): string;
    encodeFunctionData(functionFragment: "buyUSDG", values: [string, string]): string;
    encodeFunctionData(functionFragment: "clearTokenConfig", values: [string]): string;
    encodeFunctionData(functionFragment: "cumulativeFundingRates", values: [string]): string;
    encodeFunctionData(functionFragment: "decreasePosition", values: [
        string,
        string,
        string,
        BigNumberish,
        BigNumberish,
        boolean,
        string
    ]): string;
    encodeFunctionData(functionFragment: "directPoolDeposit", values: [string]): string;
    encodeFunctionData(functionFragment: "errorController", values?: undefined): string;
    encodeFunctionData(functionFragment: "feeReserves", values: [string]): string;
    encodeFunctionData(functionFragment: "fundingInterval", values?: undefined): string;
    encodeFunctionData(functionFragment: "fundingRateFactor", values?: undefined): string;
    encodeFunctionData(functionFragment: "getMaxPrice", values: [string]): string;
    encodeFunctionData(functionFragment: "getMinPrice", values: [string]): string;
    encodeFunctionData(functionFragment: "getNextAveragePrice", values: [
        string,
        BigNumberish,
        BigNumberish,
        boolean,
        BigNumberish,
        BigNumberish,
        BigNumberish
    ]): string;
    encodeFunctionData(functionFragment: "getNextFundingRate", values: [string]): string;
    encodeFunctionData(functionFragment: "getNextGlobalShortAveragePrice", values: [string, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getPosition", values: [string, string, string, boolean]): string;
    encodeFunctionData(functionFragment: "getPositionKey", values: [string, string, string, boolean]): string;
    encodeFunctionData(functionFragment: "getRedemptionAmount", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "globalShortAveragePrices", values: [string]): string;
    encodeFunctionData(functionFragment: "globalShortSizes", values: [string]): string;
    encodeFunctionData(functionFragment: "gov", values?: undefined): string;
    encodeFunctionData(functionFragment: "guaranteedUsd", values: [string]): string;
    encodeFunctionData(functionFragment: "hasDynamicFees", values?: undefined): string;
    encodeFunctionData(functionFragment: "inManagerMode", values?: undefined): string;
    encodeFunctionData(functionFragment: "inPrivateLiquidationMode", values?: undefined): string;
    encodeFunctionData(functionFragment: "increasePosition", values: [string, string, string, BigNumberish, boolean]): string;
    encodeFunctionData(functionFragment: "initialize", values?: undefined): string;
    encodeFunctionData(functionFragment: "initializeConfig", values: [string, string, string, BigNumberish, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "isInitialized", values?: undefined): string;
    encodeFunctionData(functionFragment: "isLeverageEnabled", values?: undefined): string;
    encodeFunctionData(functionFragment: "isLiquidator", values: [string]): string;
    encodeFunctionData(functionFragment: "isManager", values: [string]): string;
    encodeFunctionData(functionFragment: "isSwapEnabled", values?: undefined): string;
    encodeFunctionData(functionFragment: "lastFundingTimes", values: [string]): string;
    encodeFunctionData(functionFragment: "liquidatePosition", values: [string, string, string, boolean, string, BytesLike]): string;
    encodeFunctionData(functionFragment: "liquidationFeeUsd", values?: undefined): string;
    encodeFunctionData(functionFragment: "marginFeeBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "maxGasPrice", values?: undefined): string;
    encodeFunctionData(functionFragment: "maxGlobalShortSizes", values: [string]): string;
    encodeFunctionData(functionFragment: "maxLeverage", values?: undefined): string;
    encodeFunctionData(functionFragment: "maxUsdgAmounts", values: [string]): string;
    encodeFunctionData(functionFragment: "minProfitBasisPoints", values: [string]): string;
    encodeFunctionData(functionFragment: "minProfitTime", values?: undefined): string;
    encodeFunctionData(functionFragment: "mintBurnFeeBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "poolAmounts", values: [string]): string;
    encodeFunctionData(functionFragment: "positions", values: [BytesLike]): string;
    encodeFunctionData(functionFragment: "priceFeed", values?: undefined): string;
    encodeFunctionData(functionFragment: "removeRouter", values: [string]): string;
    encodeFunctionData(functionFragment: "reservedAmounts", values: [string]): string;
    encodeFunctionData(functionFragment: "router", values?: undefined): string;
    encodeFunctionData(functionFragment: "sellUSDG", values: [string, string]): string;
    encodeFunctionData(functionFragment: "setBufferAmount", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setError", values: [BigNumberish, string]): string;
    encodeFunctionData(functionFragment: "setErrorController", values: [string]): string;
    encodeFunctionData(functionFragment: "setFees", values: [
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        boolean
    ]): string;
    encodeFunctionData(functionFragment: "setFundingRate", values: [BigNumberish, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setGov", values: [string]): string;
    encodeFunctionData(functionFragment: "setInManagerMode", values: [boolean]): string;
    encodeFunctionData(functionFragment: "setInPrivateLiquidationMode", values: [boolean]): string;
    encodeFunctionData(functionFragment: "setIsLeverageEnabled", values: [boolean]): string;
    encodeFunctionData(functionFragment: "setIsSwapEnabled", values: [boolean]): string;
    encodeFunctionData(functionFragment: "setLiquidator", values: [string, boolean]): string;
    encodeFunctionData(functionFragment: "setManager", values: [string, boolean]): string;
    encodeFunctionData(functionFragment: "setMaxGasPrice", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "setMaxGlobalShortSize", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setMaxLeverage", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "setPriceFeed", values: [string]): string;
    encodeFunctionData(functionFragment: "setRebates", values: [string]): string;
    encodeFunctionData(functionFragment: "setRouter", values: [string]): string;
    encodeFunctionData(functionFragment: "setTokenConfig", values: [
        string,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        boolean,
        boolean
    ]): string;
    encodeFunctionData(functionFragment: "setUsdgAmount", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setVaultUtils", values: [string]): string;
    encodeFunctionData(functionFragment: "shortableTokens", values: [string]): string;
    encodeFunctionData(functionFragment: "stableFundingRateFactor", values?: undefined): string;
    encodeFunctionData(functionFragment: "stableSwapFeeBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "stableTaxBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "stableTokens", values: [string]): string;
    encodeFunctionData(functionFragment: "swap", values: [string, string, string]): string;
    encodeFunctionData(functionFragment: "swapFeeBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "swapWithRebateReceiver", values: [string, string, string, string]): string;
    encodeFunctionData(functionFragment: "taxBasisPoints", values?: undefined): string;
    encodeFunctionData(functionFragment: "tokenBalances", values: [string]): string;
    encodeFunctionData(functionFragment: "tokenDecimals", values: [string]): string;
    encodeFunctionData(functionFragment: "tokenToUsdMin", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "tokenWeights", values: [string]): string;
    encodeFunctionData(functionFragment: "totalTokenWeights", values?: undefined): string;
    encodeFunctionData(functionFragment: "updateCumulativeFundingRate", values: [string, string]): string;
    encodeFunctionData(functionFragment: "upgradeVault", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "usdToToken", values: [string, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "usdToTokenMax", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "usdToTokenMin", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "usdg", values?: undefined): string;
    encodeFunctionData(functionFragment: "usdgAmounts", values: [string]): string;
    encodeFunctionData(functionFragment: "vaultUtils", values?: undefined): string;
    encodeFunctionData(functionFragment: "whitelistedTokenCount", values?: undefined): string;
    encodeFunctionData(functionFragment: "whitelistedTokens", values: [string]): string;
    encodeFunctionData(functionFragment: "withdrawFees", values: [string, string]): string;
    decodeFunctionResult(functionFragment: "addRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "adjustForDecimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allWhitelistedTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allWhitelistedTokensLength", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approvedRouters", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "bufferAmounts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "buyUSDG", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "clearTokenConfig", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "cumulativeFundingRates", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decreasePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "directPoolDeposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "errorController", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "feeReserves", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "fundingInterval", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "fundingRateFactor", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMaxPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMinPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getNextAveragePrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getNextFundingRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getNextGlobalShortAveragePrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPositionKey", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRedemptionAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "globalShortAveragePrices", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "globalShortSizes", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "gov", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "guaranteedUsd", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hasDynamicFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "inManagerMode", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "inPrivateLiquidationMode", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "increasePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initializeConfig", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isInitialized", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isLeverageEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isLiquidator", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isSwapEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "lastFundingTimes", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidatePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidationFeeUsd", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "marginFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxGasPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxGlobalShortSizes", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxLeverage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxUsdgAmounts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "minProfitBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "minProfitTime", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "mintBurnFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "poolAmounts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "positions", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "priceFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "reservedAmounts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "router", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sellUSDG", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setBufferAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setError", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setErrorController", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFundingRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setGov", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setInManagerMode", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setInPrivateLiquidationMode", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setIsLeverageEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setIsSwapEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setLiquidator", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxGasPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxGlobalShortSize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxLeverage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPriceFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRebates", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setTokenConfig", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setUsdgAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setVaultUtils", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "shortableTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "stableFundingRateFactor", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "stableSwapFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "stableTaxBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "stableTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "swap", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "swapFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "swapWithRebateReceiver", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "taxBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tokenBalances", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tokenDecimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tokenToUsdMin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tokenWeights", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalTokenWeights", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateCumulativeFundingRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeVault", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdToToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdToTokenMax", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdToTokenMin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdg", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usdgAmounts", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "vaultUtils", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "whitelistedTokenCount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "whitelistedTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawFees", data: BytesLike): Result;
    events: {
        "BuyUSDG(address,address,uint256,uint256,uint256)": EventFragment;
        "ClosePosition(bytes32,uint256,uint256,uint256,uint256,uint256,int256)": EventFragment;
        "CollectMarginFees(address,uint256,uint256)": EventFragment;
        "CollectSwapFees(address,uint256,uint256)": EventFragment;
        "DecreaseGuaranteedUsd(address,uint256)": EventFragment;
        "DecreasePoolAmount(address,uint256)": EventFragment;
        "DecreasePosition(bytes32,address,address,address,uint256,uint256,bool,uint256,uint256)": EventFragment;
        "DecreaseReservedAmount(address,uint256)": EventFragment;
        "DecreaseUsdgAmount(address,uint256)": EventFragment;
        "DirectPoolDeposit(address,uint256)": EventFragment;
        "IncreaseGuaranteedUsd(address,uint256)": EventFragment;
        "IncreasePoolAmount(address,uint256)": EventFragment;
        "IncreasePosition(bytes32,address,address,address,uint256,uint256,bool,uint256,uint256)": EventFragment;
        "IncreaseReservedAmount(address,uint256)": EventFragment;
        "IncreaseUsdgAmount(address,uint256)": EventFragment;
        "LiquidatePosition(bytes32,address,address,address,bool,uint256,uint256,uint256,int256,uint256)": EventFragment;
        "SellUSDG(address,address,uint256,uint256,uint256)": EventFragment;
        "Swap(address,address,address,uint256,uint256,uint256,uint256)": EventFragment;
        "UpdateFees(uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256,bool)": EventFragment;
        "UpdateFundingRate(address,uint256)": EventFragment;
        "UpdateMaxLeverage(uint256)": EventFragment;
        "UpdatePnl(bytes32,bool,uint256)": EventFragment;
        "UpdatePosition(bytes32,uint256,uint256,uint256,uint256,uint256,int256,uint256)": EventFragment;
        "UpdateTokenConfig(address,bool,uint256,uint256,uint256,uint256,bool,bool)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "BuyUSDG"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ClosePosition"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "CollectMarginFees"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "CollectSwapFees"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DecreaseGuaranteedUsd"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DecreasePoolAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DecreasePosition"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DecreaseReservedAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DecreaseUsdgAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "DirectPoolDeposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "IncreaseGuaranteedUsd"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "IncreasePoolAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "IncreasePosition"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "IncreaseReservedAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "IncreaseUsdgAmount"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LiquidatePosition"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SellUSDG"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Swap"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdateFees"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdateFundingRate"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdateMaxLeverage"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdatePnl"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdatePosition"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "UpdateTokenConfig"): EventFragment;
}
export type BuyUSDGEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber,
    BigNumber
], {
    account: string;
    token: string;
    tokenAmount: BigNumber;
    usdgAmount: BigNumber;
    feeBasisPoints: BigNumber;
}>;
export type BuyUSDGEventFilter = TypedEventFilter<BuyUSDGEvent>;
export type ClosePositionEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
], {
    key: string;
    size: BigNumber;
    collateral: BigNumber;
    averagePrice: BigNumber;
    entryFundingRate: BigNumber;
    reserveAmount: BigNumber;
    realisedPnl: BigNumber;
}>;
export type ClosePositionEventFilter = TypedEventFilter<ClosePositionEvent>;
export type CollectMarginFeesEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber
], {
    token: string;
    feeUsd: BigNumber;
    feeTokens: BigNumber;
}>;
export type CollectMarginFeesEventFilter = TypedEventFilter<CollectMarginFeesEvent>;
export type CollectSwapFeesEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber
], {
    token: string;
    feeUsd: BigNumber;
    feeTokens: BigNumber;
}>;
export type CollectSwapFeesEventFilter = TypedEventFilter<CollectSwapFeesEvent>;
export type DecreaseGuaranteedUsdEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type DecreaseGuaranteedUsdEventFilter = TypedEventFilter<DecreaseGuaranteedUsdEvent>;
export type DecreasePoolAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type DecreasePoolAmountEventFilter = TypedEventFilter<DecreasePoolAmountEvent>;
export type DecreasePositionEvent = TypedEvent<[
    string,
    string,
    string,
    string,
    BigNumber,
    BigNumber,
    boolean,
    BigNumber,
    BigNumber
], {
    key: string;
    account: string;
    collateralToken: string;
    indexToken: string;
    collateralDelta: BigNumber;
    sizeDelta: BigNumber;
    isLong: boolean;
    price: BigNumber;
    fee: BigNumber;
}>;
export type DecreasePositionEventFilter = TypedEventFilter<DecreasePositionEvent>;
export type DecreaseReservedAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type DecreaseReservedAmountEventFilter = TypedEventFilter<DecreaseReservedAmountEvent>;
export type DecreaseUsdgAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type DecreaseUsdgAmountEventFilter = TypedEventFilter<DecreaseUsdgAmountEvent>;
export type DirectPoolDepositEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type DirectPoolDepositEventFilter = TypedEventFilter<DirectPoolDepositEvent>;
export type IncreaseGuaranteedUsdEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type IncreaseGuaranteedUsdEventFilter = TypedEventFilter<IncreaseGuaranteedUsdEvent>;
export type IncreasePoolAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type IncreasePoolAmountEventFilter = TypedEventFilter<IncreasePoolAmountEvent>;
export type IncreasePositionEvent = TypedEvent<[
    string,
    string,
    string,
    string,
    BigNumber,
    BigNumber,
    boolean,
    BigNumber,
    BigNumber
], {
    key: string;
    account: string;
    collateralToken: string;
    indexToken: string;
    collateralDelta: BigNumber;
    sizeDelta: BigNumber;
    isLong: boolean;
    price: BigNumber;
    fee: BigNumber;
}>;
export type IncreasePositionEventFilter = TypedEventFilter<IncreasePositionEvent>;
export type IncreaseReservedAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type IncreaseReservedAmountEventFilter = TypedEventFilter<IncreaseReservedAmountEvent>;
export type IncreaseUsdgAmountEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    amount: BigNumber;
}>;
export type IncreaseUsdgAmountEventFilter = TypedEventFilter<IncreaseUsdgAmountEvent>;
export type LiquidatePositionEvent = TypedEvent<[
    string,
    string,
    string,
    string,
    boolean,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
], {
    key: string;
    account: string;
    collateralToken: string;
    indexToken: string;
    isLong: boolean;
    size: BigNumber;
    collateral: BigNumber;
    reserveAmount: BigNumber;
    realisedPnl: BigNumber;
    markPrice: BigNumber;
}>;
export type LiquidatePositionEventFilter = TypedEventFilter<LiquidatePositionEvent>;
export type SellUSDGEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    BigNumber,
    BigNumber
], {
    account: string;
    token: string;
    usdgAmount: BigNumber;
    tokenAmount: BigNumber;
    feeBasisPoints: BigNumber;
}>;
export type SellUSDGEventFilter = TypedEventFilter<SellUSDGEvent>;
export type SwapEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
], {
    account: string;
    tokenIn: string;
    tokenOut: string;
    amountIn: BigNumber;
    amountOut: BigNumber;
    amountOutAfterFees: BigNumber;
    feeBasisPoints: BigNumber;
}>;
export type SwapEventFilter = TypedEventFilter<SwapEvent>;
export type UpdateFeesEvent = TypedEvent<[
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    boolean
], {
    taxBasisPoints: BigNumber;
    stableTaxBasisPoints: BigNumber;
    mintBurnFeeBasisPoints: BigNumber;
    swapFeeBasisPoints: BigNumber;
    stableSwapFeeBasisPoints: BigNumber;
    marginFeeBasisPoints: BigNumber;
    liquidationFeeUsd: BigNumber;
    minProfitTime: BigNumber;
    hasDynamicFees: boolean;
}>;
export type UpdateFeesEventFilter = TypedEventFilter<UpdateFeesEvent>;
export type UpdateFundingRateEvent = TypedEvent<[
    string,
    BigNumber
], {
    token: string;
    fundingRate: BigNumber;
}>;
export type UpdateFundingRateEventFilter = TypedEventFilter<UpdateFundingRateEvent>;
export type UpdateMaxLeverageEvent = TypedEvent<[
    BigNumber
], {
    maxLeverage: BigNumber;
}>;
export type UpdateMaxLeverageEventFilter = TypedEventFilter<UpdateMaxLeverageEvent>;
export type UpdatePnlEvent = TypedEvent<[
    string,
    boolean,
    BigNumber
], {
    key: string;
    hasProfit: boolean;
    delta: BigNumber;
}>;
export type UpdatePnlEventFilter = TypedEventFilter<UpdatePnlEvent>;
export type UpdatePositionEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
], {
    key: string;
    size: BigNumber;
    collateral: BigNumber;
    averagePrice: BigNumber;
    entryFundingRate: BigNumber;
    reserveAmount: BigNumber;
    realisedPnl: BigNumber;
    markPrice: BigNumber;
}>;
export type UpdatePositionEventFilter = TypedEventFilter<UpdatePositionEvent>;
export type UpdateTokenConfigEvent = TypedEvent<[
    string,
    boolean,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    boolean,
    boolean
], {
    token: string;
    isWhitelisted: boolean;
    tokenDecimals: BigNumber;
    tokenWeight: BigNumber;
    minProfitBasisPoints: BigNumber;
    maxUsdgAmount: BigNumber;
    isStable: boolean;
    isShortable: boolean;
}>;
export type UpdateTokenConfigEventFilter = TypedEventFilter<UpdateTokenConfigEvent>;
export interface Vault extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: VaultInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        addRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        adjustForDecimals(_amount: BigNumberish, _tokenDiv: string, _tokenMul: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        allWhitelistedTokens(arg0: BigNumberish, overrides?: CallOverrides): Promise<[string]>;
        allWhitelistedTokensLength(overrides?: CallOverrides): Promise<[BigNumber]>;
        approvedRouters(arg0: string, arg1: string, overrides?: CallOverrides): Promise<[boolean]>;
        bufferAmounts(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        buyUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        clearTokenConfig(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        cumulativeFundingRates(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        decreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        directPoolDeposit(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        errorController(overrides?: CallOverrides): Promise<[string]>;
        feeReserves(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        fundingInterval(overrides?: CallOverrides): Promise<[BigNumber]>;
        fundingRateFactor(overrides?: CallOverrides): Promise<[BigNumber]>;
        getMaxPrice(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getMinPrice(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getNextAveragePrice(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getNextFundingRate(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getNextGlobalShortAveragePrice(_indexToken: string, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getPosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            boolean,
            BigNumber
        ]>;
        getPositionKey(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[string]>;
        getRedemptionAmount(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        globalShortAveragePrices(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        globalShortSizes(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        gov(overrides?: CallOverrides): Promise<[string]>;
        guaranteedUsd(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        hasDynamicFees(overrides?: CallOverrides): Promise<[boolean]>;
        inManagerMode(overrides?: CallOverrides): Promise<[boolean]>;
        inPrivateLiquidationMode(overrides?: CallOverrides): Promise<[boolean]>;
        increasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        initializeConfig(_router: string, _usdg: string, _priceFeed: string, _liquidationFeeUsd: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        isInitialized(overrides?: CallOverrides): Promise<[boolean]>;
        isLeverageEnabled(overrides?: CallOverrides): Promise<[boolean]>;
        isLiquidator(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        isManager(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        isSwapEnabled(overrides?: CallOverrides): Promise<[boolean]>;
        lastFundingTimes(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        liquidatePosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _feeReceiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        liquidationFeeUsd(overrides?: CallOverrides): Promise<[BigNumber]>;
        marginFeeBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        maxGasPrice(overrides?: CallOverrides): Promise<[BigNumber]>;
        maxGlobalShortSizes(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        maxLeverage(overrides?: CallOverrides): Promise<[BigNumber]>;
        maxUsdgAmounts(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        minProfitBasisPoints(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        minProfitTime(overrides?: CallOverrides): Promise<[BigNumber]>;
        mintBurnFeeBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        poolAmounts(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        positions(arg0: BytesLike, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            size: BigNumber;
            collateral: BigNumber;
            averagePrice: BigNumber;
            entryFundingRate: BigNumber;
            reserveAmount: BigNumber;
            realisedPnl: BigNumber;
            lastIncreasedTime: BigNumber;
        }>;
        priceFeed(overrides?: CallOverrides): Promise<[string]>;
        removeRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        reservedAmounts(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        router(overrides?: CallOverrides): Promise<[string]>;
        sellUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setBufferAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setError(_errorCode: BigNumberish, _error: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setErrorController(_errorController: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setFees(_taxBasisPoints: BigNumberish, _stableTaxBasisPoints: BigNumberish, _mintBurnFeeBasisPoints: BigNumberish, _swapFeeBasisPoints: BigNumberish, _stableSwapFeeBasisPoints: BigNumberish, _marginFeeBasisPoints: BigNumberish, _liquidationFeeUsd: BigNumberish, _minProfitTime: BigNumberish, _hasDynamicFees: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setFundingRate(_fundingInterval: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setInManagerMode(_inManagerMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setInPrivateLiquidationMode(_inPrivateLiquidationMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setIsLeverageEnabled(_isLeverageEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setIsSwapEnabled(_isSwapEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setLiquidator(_liquidator: string, _isActive: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setManager(_manager: string, _isManager: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setMaxGasPrice(_maxGasPrice: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setMaxGlobalShortSize(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setMaxLeverage(_maxLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setPriceFeed(_priceFeed: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setRebates(_rebates: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setTokenConfig(_token: string, _tokenDecimals: BigNumberish, _tokenWeight: BigNumberish, _minProfitBps: BigNumberish, _maxUsdgAmount: BigNumberish, _isStable: boolean, _isShortable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setUsdgAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setVaultUtils(_vaultUtils: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        shortableTokens(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        stableFundingRateFactor(overrides?: CallOverrides): Promise<[BigNumber]>;
        stableSwapFeeBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        stableTaxBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        stableTokens(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        swap(_tokenIn: string, _tokenOut: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        swapFeeBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        swapWithRebateReceiver(_tokenIn: string, _tokenOut: string, _receiver: string, _rebateReceiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        taxBasisPoints(overrides?: CallOverrides): Promise<[BigNumber]>;
        tokenBalances(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        tokenDecimals(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        tokenToUsdMin(_token: string, _tokenAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        tokenWeights(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        totalTokenWeights(overrides?: CallOverrides): Promise<[BigNumber]>;
        updateCumulativeFundingRate(_collateralToken: string, _indexToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeVault(_newVault: string, _token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        usdToToken(_token: string, _usdAmount: BigNumberish, _price: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        usdToTokenMax(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        usdToTokenMin(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        usdg(overrides?: CallOverrides): Promise<[string]>;
        usdgAmounts(arg0: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        vaultUtils(overrides?: CallOverrides): Promise<[string]>;
        whitelistedTokenCount(overrides?: CallOverrides): Promise<[BigNumber]>;
        whitelistedTokens(arg0: string, overrides?: CallOverrides): Promise<[boolean]>;
        withdrawFees(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
    };
    addRouter(_router: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    adjustForDecimals(_amount: BigNumberish, _tokenDiv: string, _tokenMul: string, overrides?: CallOverrides): Promise<BigNumber>;
    allWhitelistedTokens(arg0: BigNumberish, overrides?: CallOverrides): Promise<string>;
    allWhitelistedTokensLength(overrides?: CallOverrides): Promise<BigNumber>;
    approvedRouters(arg0: string, arg1: string, overrides?: CallOverrides): Promise<boolean>;
    bufferAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    buyUSDG(_token: string, _receiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    clearTokenConfig(_token: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    cumulativeFundingRates(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    decreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    directPoolDeposit(_token: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    errorController(overrides?: CallOverrides): Promise<string>;
    feeReserves(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    fundingInterval(overrides?: CallOverrides): Promise<BigNumber>;
    fundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
    getMaxPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getMinPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getNextAveragePrice(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getNextFundingRate(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getNextGlobalShortAveragePrice(_indexToken: string, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getPosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        boolean,
        BigNumber
    ]>;
    getPositionKey(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<string>;
    getRedemptionAmount(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    globalShortAveragePrices(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    globalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    gov(overrides?: CallOverrides): Promise<string>;
    guaranteedUsd(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    hasDynamicFees(overrides?: CallOverrides): Promise<boolean>;
    inManagerMode(overrides?: CallOverrides): Promise<boolean>;
    inPrivateLiquidationMode(overrides?: CallOverrides): Promise<boolean>;
    increasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    initialize(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    initializeConfig(_router: string, _usdg: string, _priceFeed: string, _liquidationFeeUsd: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    isInitialized(overrides?: CallOverrides): Promise<boolean>;
    isLeverageEnabled(overrides?: CallOverrides): Promise<boolean>;
    isLiquidator(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    isManager(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    isSwapEnabled(overrides?: CallOverrides): Promise<boolean>;
    lastFundingTimes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    liquidatePosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _feeReceiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    liquidationFeeUsd(overrides?: CallOverrides): Promise<BigNumber>;
    marginFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    maxGasPrice(overrides?: CallOverrides): Promise<BigNumber>;
    maxGlobalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    maxLeverage(overrides?: CallOverrides): Promise<BigNumber>;
    maxUsdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    minProfitBasisPoints(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    minProfitTime(overrides?: CallOverrides): Promise<BigNumber>;
    mintBurnFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    poolAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    positions(arg0: BytesLike, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        size: BigNumber;
        collateral: BigNumber;
        averagePrice: BigNumber;
        entryFundingRate: BigNumber;
        reserveAmount: BigNumber;
        realisedPnl: BigNumber;
        lastIncreasedTime: BigNumber;
    }>;
    priceFeed(overrides?: CallOverrides): Promise<string>;
    removeRouter(_router: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    reservedAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    router(overrides?: CallOverrides): Promise<string>;
    sellUSDG(_token: string, _receiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setBufferAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setError(_errorCode: BigNumberish, _error: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setErrorController(_errorController: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setFees(_taxBasisPoints: BigNumberish, _stableTaxBasisPoints: BigNumberish, _mintBurnFeeBasisPoints: BigNumberish, _swapFeeBasisPoints: BigNumberish, _stableSwapFeeBasisPoints: BigNumberish, _marginFeeBasisPoints: BigNumberish, _liquidationFeeUsd: BigNumberish, _minProfitTime: BigNumberish, _hasDynamicFees: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setFundingRate(_fundingInterval: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setGov(_gov: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setInManagerMode(_inManagerMode: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setInPrivateLiquidationMode(_inPrivateLiquidationMode: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setIsLeverageEnabled(_isLeverageEnabled: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setIsSwapEnabled(_isSwapEnabled: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setLiquidator(_liquidator: string, _isActive: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setManager(_manager: string, _isManager: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setMaxGasPrice(_maxGasPrice: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setMaxGlobalShortSize(_token: string, _amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setMaxLeverage(_maxLeverage: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setPriceFeed(_priceFeed: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setRebates(_rebates: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setRouter(_router: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setTokenConfig(_token: string, _tokenDecimals: BigNumberish, _tokenWeight: BigNumberish, _minProfitBps: BigNumberish, _maxUsdgAmount: BigNumberish, _isStable: boolean, _isShortable: boolean, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setUsdgAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setVaultUtils(_vaultUtils: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    shortableTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    stableFundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
    stableSwapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    stableTaxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    stableTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    swap(_tokenIn: string, _tokenOut: string, _receiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    swapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    swapWithRebateReceiver(_tokenIn: string, _tokenOut: string, _receiver: string, _rebateReceiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    taxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
    tokenBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    tokenDecimals(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    tokenToUsdMin(_token: string, _tokenAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    tokenWeights(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    totalTokenWeights(overrides?: CallOverrides): Promise<BigNumber>;
    updateCumulativeFundingRate(_collateralToken: string, _indexToken: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeVault(_newVault: string, _token: string, _amount: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    usdToToken(_token: string, _usdAmount: BigNumberish, _price: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    usdToTokenMax(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    usdToTokenMin(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    usdg(overrides?: CallOverrides): Promise<string>;
    usdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
    vaultUtils(overrides?: CallOverrides): Promise<string>;
    whitelistedTokenCount(overrides?: CallOverrides): Promise<BigNumber>;
    whitelistedTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
    withdrawFees(_token: string, _receiver: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        addRouter(_router: string, overrides?: CallOverrides): Promise<void>;
        adjustForDecimals(_amount: BigNumberish, _tokenDiv: string, _tokenMul: string, overrides?: CallOverrides): Promise<BigNumber>;
        allWhitelistedTokens(arg0: BigNumberish, overrides?: CallOverrides): Promise<string>;
        allWhitelistedTokensLength(overrides?: CallOverrides): Promise<BigNumber>;
        approvedRouters(arg0: string, arg1: string, overrides?: CallOverrides): Promise<boolean>;
        bufferAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        buyUSDG(_token: string, _receiver: string, overrides?: CallOverrides): Promise<BigNumber>;
        clearTokenConfig(_token: string, overrides?: CallOverrides): Promise<void>;
        cumulativeFundingRates(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        decreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, overrides?: CallOverrides): Promise<BigNumber>;
        directPoolDeposit(_token: string, overrides?: CallOverrides): Promise<void>;
        errorController(overrides?: CallOverrides): Promise<string>;
        feeReserves(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        fundingInterval(overrides?: CallOverrides): Promise<BigNumber>;
        fundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
        getMaxPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getMinPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNextAveragePrice(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getNextFundingRate(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNextGlobalShortAveragePrice(_indexToken: string, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getPosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            boolean,
            BigNumber
        ]>;
        getPositionKey(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<string>;
        getRedemptionAmount(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        globalShortAveragePrices(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        globalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        gov(overrides?: CallOverrides): Promise<string>;
        guaranteedUsd(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        hasDynamicFees(overrides?: CallOverrides): Promise<boolean>;
        inManagerMode(overrides?: CallOverrides): Promise<boolean>;
        inPrivateLiquidationMode(overrides?: CallOverrides): Promise<boolean>;
        increasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<void>;
        initialize(overrides?: CallOverrides): Promise<void>;
        initializeConfig(_router: string, _usdg: string, _priceFeed: string, _liquidationFeeUsd: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: CallOverrides): Promise<void>;
        isInitialized(overrides?: CallOverrides): Promise<boolean>;
        isLeverageEnabled(overrides?: CallOverrides): Promise<boolean>;
        isLiquidator(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        isManager(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        isSwapEnabled(overrides?: CallOverrides): Promise<boolean>;
        lastFundingTimes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        liquidatePosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _feeReceiver: string, signedQuoteData: BytesLike, overrides?: CallOverrides): Promise<void>;
        liquidationFeeUsd(overrides?: CallOverrides): Promise<BigNumber>;
        marginFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        maxGasPrice(overrides?: CallOverrides): Promise<BigNumber>;
        maxGlobalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        maxLeverage(overrides?: CallOverrides): Promise<BigNumber>;
        maxUsdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        minProfitBasisPoints(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        minProfitTime(overrides?: CallOverrides): Promise<BigNumber>;
        mintBurnFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        poolAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        positions(arg0: BytesLike, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            size: BigNumber;
            collateral: BigNumber;
            averagePrice: BigNumber;
            entryFundingRate: BigNumber;
            reserveAmount: BigNumber;
            realisedPnl: BigNumber;
            lastIncreasedTime: BigNumber;
        }>;
        priceFeed(overrides?: CallOverrides): Promise<string>;
        removeRouter(_router: string, overrides?: CallOverrides): Promise<void>;
        reservedAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        router(overrides?: CallOverrides): Promise<string>;
        sellUSDG(_token: string, _receiver: string, overrides?: CallOverrides): Promise<BigNumber>;
        setBufferAmount(_token: string, _amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setError(_errorCode: BigNumberish, _error: string, overrides?: CallOverrides): Promise<void>;
        setErrorController(_errorController: string, overrides?: CallOverrides): Promise<void>;
        setFees(_taxBasisPoints: BigNumberish, _stableTaxBasisPoints: BigNumberish, _mintBurnFeeBasisPoints: BigNumberish, _swapFeeBasisPoints: BigNumberish, _stableSwapFeeBasisPoints: BigNumberish, _marginFeeBasisPoints: BigNumberish, _liquidationFeeUsd: BigNumberish, _minProfitTime: BigNumberish, _hasDynamicFees: boolean, overrides?: CallOverrides): Promise<void>;
        setFundingRate(_fundingInterval: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setGov(_gov: string, overrides?: CallOverrides): Promise<void>;
        setInManagerMode(_inManagerMode: boolean, overrides?: CallOverrides): Promise<void>;
        setInPrivateLiquidationMode(_inPrivateLiquidationMode: boolean, overrides?: CallOverrides): Promise<void>;
        setIsLeverageEnabled(_isLeverageEnabled: boolean, overrides?: CallOverrides): Promise<void>;
        setIsSwapEnabled(_isSwapEnabled: boolean, overrides?: CallOverrides): Promise<void>;
        setLiquidator(_liquidator: string, _isActive: boolean, overrides?: CallOverrides): Promise<void>;
        setManager(_manager: string, _isManager: boolean, overrides?: CallOverrides): Promise<void>;
        setMaxGasPrice(_maxGasPrice: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setMaxGlobalShortSize(_token: string, _amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setMaxLeverage(_maxLeverage: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setPriceFeed(_priceFeed: string, overrides?: CallOverrides): Promise<void>;
        setRebates(_rebates: string, overrides?: CallOverrides): Promise<void>;
        setRouter(_router: string, overrides?: CallOverrides): Promise<void>;
        setTokenConfig(_token: string, _tokenDecimals: BigNumberish, _tokenWeight: BigNumberish, _minProfitBps: BigNumberish, _maxUsdgAmount: BigNumberish, _isStable: boolean, _isShortable: boolean, overrides?: CallOverrides): Promise<void>;
        setUsdgAmount(_token: string, _amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setVaultUtils(_vaultUtils: string, overrides?: CallOverrides): Promise<void>;
        shortableTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        stableFundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
        stableSwapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        stableTaxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        stableTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        swap(_tokenIn: string, _tokenOut: string, _receiver: string, overrides?: CallOverrides): Promise<BigNumber>;
        swapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        swapWithRebateReceiver(_tokenIn: string, _tokenOut: string, _receiver: string, _rebateReceiver: string, overrides?: CallOverrides): Promise<BigNumber>;
        taxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        tokenBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        tokenDecimals(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        tokenToUsdMin(_token: string, _tokenAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        tokenWeights(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        totalTokenWeights(overrides?: CallOverrides): Promise<BigNumber>;
        updateCumulativeFundingRate(_collateralToken: string, _indexToken: string, overrides?: CallOverrides): Promise<void>;
        upgradeVault(_newVault: string, _token: string, _amount: BigNumberish, overrides?: CallOverrides): Promise<void>;
        usdToToken(_token: string, _usdAmount: BigNumberish, _price: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdToTokenMax(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdToTokenMin(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdg(overrides?: CallOverrides): Promise<string>;
        usdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        vaultUtils(overrides?: CallOverrides): Promise<string>;
        whitelistedTokenCount(overrides?: CallOverrides): Promise<BigNumber>;
        whitelistedTokens(arg0: string, overrides?: CallOverrides): Promise<boolean>;
        withdrawFees(_token: string, _receiver: string, overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {
        "BuyUSDG(address,address,uint256,uint256,uint256)"(account?: null, token?: null, tokenAmount?: null, usdgAmount?: null, feeBasisPoints?: null): BuyUSDGEventFilter;
        BuyUSDG(account?: null, token?: null, tokenAmount?: null, usdgAmount?: null, feeBasisPoints?: null): BuyUSDGEventFilter;
        "ClosePosition(bytes32,uint256,uint256,uint256,uint256,uint256,int256)"(key?: null, size?: null, collateral?: null, averagePrice?: null, entryFundingRate?: null, reserveAmount?: null, realisedPnl?: null): ClosePositionEventFilter;
        ClosePosition(key?: null, size?: null, collateral?: null, averagePrice?: null, entryFundingRate?: null, reserveAmount?: null, realisedPnl?: null): ClosePositionEventFilter;
        "CollectMarginFees(address,uint256,uint256)"(token?: null, feeUsd?: null, feeTokens?: null): CollectMarginFeesEventFilter;
        CollectMarginFees(token?: null, feeUsd?: null, feeTokens?: null): CollectMarginFeesEventFilter;
        "CollectSwapFees(address,uint256,uint256)"(token?: null, feeUsd?: null, feeTokens?: null): CollectSwapFeesEventFilter;
        CollectSwapFees(token?: null, feeUsd?: null, feeTokens?: null): CollectSwapFeesEventFilter;
        "DecreaseGuaranteedUsd(address,uint256)"(token?: null, amount?: null): DecreaseGuaranteedUsdEventFilter;
        DecreaseGuaranteedUsd(token?: null, amount?: null): DecreaseGuaranteedUsdEventFilter;
        "DecreasePoolAmount(address,uint256)"(token?: null, amount?: null): DecreasePoolAmountEventFilter;
        DecreasePoolAmount(token?: null, amount?: null): DecreasePoolAmountEventFilter;
        "DecreasePosition(bytes32,address,address,address,uint256,uint256,bool,uint256,uint256)"(key?: null, account?: null, collateralToken?: null, indexToken?: null, collateralDelta?: null, sizeDelta?: null, isLong?: null, price?: null, fee?: null): DecreasePositionEventFilter;
        DecreasePosition(key?: null, account?: null, collateralToken?: null, indexToken?: null, collateralDelta?: null, sizeDelta?: null, isLong?: null, price?: null, fee?: null): DecreasePositionEventFilter;
        "DecreaseReservedAmount(address,uint256)"(token?: null, amount?: null): DecreaseReservedAmountEventFilter;
        DecreaseReservedAmount(token?: null, amount?: null): DecreaseReservedAmountEventFilter;
        "DecreaseUsdgAmount(address,uint256)"(token?: null, amount?: null): DecreaseUsdgAmountEventFilter;
        DecreaseUsdgAmount(token?: null, amount?: null): DecreaseUsdgAmountEventFilter;
        "DirectPoolDeposit(address,uint256)"(token?: null, amount?: null): DirectPoolDepositEventFilter;
        DirectPoolDeposit(token?: null, amount?: null): DirectPoolDepositEventFilter;
        "IncreaseGuaranteedUsd(address,uint256)"(token?: null, amount?: null): IncreaseGuaranteedUsdEventFilter;
        IncreaseGuaranteedUsd(token?: null, amount?: null): IncreaseGuaranteedUsdEventFilter;
        "IncreasePoolAmount(address,uint256)"(token?: null, amount?: null): IncreasePoolAmountEventFilter;
        IncreasePoolAmount(token?: null, amount?: null): IncreasePoolAmountEventFilter;
        "IncreasePosition(bytes32,address,address,address,uint256,uint256,bool,uint256,uint256)"(key?: null, account?: null, collateralToken?: null, indexToken?: null, collateralDelta?: null, sizeDelta?: null, isLong?: null, price?: null, fee?: null): IncreasePositionEventFilter;
        IncreasePosition(key?: null, account?: null, collateralToken?: null, indexToken?: null, collateralDelta?: null, sizeDelta?: null, isLong?: null, price?: null, fee?: null): IncreasePositionEventFilter;
        "IncreaseReservedAmount(address,uint256)"(token?: null, amount?: null): IncreaseReservedAmountEventFilter;
        IncreaseReservedAmount(token?: null, amount?: null): IncreaseReservedAmountEventFilter;
        "IncreaseUsdgAmount(address,uint256)"(token?: null, amount?: null): IncreaseUsdgAmountEventFilter;
        IncreaseUsdgAmount(token?: null, amount?: null): IncreaseUsdgAmountEventFilter;
        "LiquidatePosition(bytes32,address,address,address,bool,uint256,uint256,uint256,int256,uint256)"(key?: null, account?: null, collateralToken?: null, indexToken?: null, isLong?: null, size?: null, collateral?: null, reserveAmount?: null, realisedPnl?: null, markPrice?: null): LiquidatePositionEventFilter;
        LiquidatePosition(key?: null, account?: null, collateralToken?: null, indexToken?: null, isLong?: null, size?: null, collateral?: null, reserveAmount?: null, realisedPnl?: null, markPrice?: null): LiquidatePositionEventFilter;
        "SellUSDG(address,address,uint256,uint256,uint256)"(account?: null, token?: null, usdgAmount?: null, tokenAmount?: null, feeBasisPoints?: null): SellUSDGEventFilter;
        SellUSDG(account?: null, token?: null, usdgAmount?: null, tokenAmount?: null, feeBasisPoints?: null): SellUSDGEventFilter;
        "Swap(address,address,address,uint256,uint256,uint256,uint256)"(account?: null, tokenIn?: null, tokenOut?: null, amountIn?: null, amountOut?: null, amountOutAfterFees?: null, feeBasisPoints?: null): SwapEventFilter;
        Swap(account?: null, tokenIn?: null, tokenOut?: null, amountIn?: null, amountOut?: null, amountOutAfterFees?: null, feeBasisPoints?: null): SwapEventFilter;
        "UpdateFees(uint256,uint256,uint256,uint256,uint256,uint256,uint256,uint256,bool)"(taxBasisPoints?: null, stableTaxBasisPoints?: null, mintBurnFeeBasisPoints?: null, swapFeeBasisPoints?: null, stableSwapFeeBasisPoints?: null, marginFeeBasisPoints?: null, liquidationFeeUsd?: null, minProfitTime?: null, hasDynamicFees?: null): UpdateFeesEventFilter;
        UpdateFees(taxBasisPoints?: null, stableTaxBasisPoints?: null, mintBurnFeeBasisPoints?: null, swapFeeBasisPoints?: null, stableSwapFeeBasisPoints?: null, marginFeeBasisPoints?: null, liquidationFeeUsd?: null, minProfitTime?: null, hasDynamicFees?: null): UpdateFeesEventFilter;
        "UpdateFundingRate(address,uint256)"(token?: null, fundingRate?: null): UpdateFundingRateEventFilter;
        UpdateFundingRate(token?: null, fundingRate?: null): UpdateFundingRateEventFilter;
        "UpdateMaxLeverage(uint256)"(maxLeverage?: null): UpdateMaxLeverageEventFilter;
        UpdateMaxLeverage(maxLeverage?: null): UpdateMaxLeverageEventFilter;
        "UpdatePnl(bytes32,bool,uint256)"(key?: null, hasProfit?: null, delta?: null): UpdatePnlEventFilter;
        UpdatePnl(key?: null, hasProfit?: null, delta?: null): UpdatePnlEventFilter;
        "UpdatePosition(bytes32,uint256,uint256,uint256,uint256,uint256,int256,uint256)"(key?: null, size?: null, collateral?: null, averagePrice?: null, entryFundingRate?: null, reserveAmount?: null, realisedPnl?: null, markPrice?: null): UpdatePositionEventFilter;
        UpdatePosition(key?: null, size?: null, collateral?: null, averagePrice?: null, entryFundingRate?: null, reserveAmount?: null, realisedPnl?: null, markPrice?: null): UpdatePositionEventFilter;
        "UpdateTokenConfig(address,bool,uint256,uint256,uint256,uint256,bool,bool)"(token?: string | null, isWhitelisted?: null, tokenDecimals?: null, tokenWeight?: null, minProfitBasisPoints?: null, maxUsdgAmount?: null, isStable?: null, isShortable?: null): UpdateTokenConfigEventFilter;
        UpdateTokenConfig(token?: string | null, isWhitelisted?: null, tokenDecimals?: null, tokenWeight?: null, minProfitBasisPoints?: null, maxUsdgAmount?: null, isStable?: null, isShortable?: null): UpdateTokenConfigEventFilter;
    };
    estimateGas: {
        addRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        adjustForDecimals(_amount: BigNumberish, _tokenDiv: string, _tokenMul: string, overrides?: CallOverrides): Promise<BigNumber>;
        allWhitelistedTokens(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        allWhitelistedTokensLength(overrides?: CallOverrides): Promise<BigNumber>;
        approvedRouters(arg0: string, arg1: string, overrides?: CallOverrides): Promise<BigNumber>;
        bufferAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        buyUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        clearTokenConfig(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        cumulativeFundingRates(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        decreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        directPoolDeposit(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        errorController(overrides?: CallOverrides): Promise<BigNumber>;
        feeReserves(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        fundingInterval(overrides?: CallOverrides): Promise<BigNumber>;
        fundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
        getMaxPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getMinPrice(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNextAveragePrice(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getNextFundingRate(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNextGlobalShortAveragePrice(_indexToken: string, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getPosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getPositionKey(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getRedemptionAmount(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        globalShortAveragePrices(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        globalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        gov(overrides?: CallOverrides): Promise<BigNumber>;
        guaranteedUsd(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        hasDynamicFees(overrides?: CallOverrides): Promise<BigNumber>;
        inManagerMode(overrides?: CallOverrides): Promise<BigNumber>;
        inPrivateLiquidationMode(overrides?: CallOverrides): Promise<BigNumber>;
        increasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        initializeConfig(_router: string, _usdg: string, _priceFeed: string, _liquidationFeeUsd: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        isInitialized(overrides?: CallOverrides): Promise<BigNumber>;
        isLeverageEnabled(overrides?: CallOverrides): Promise<BigNumber>;
        isLiquidator(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        isManager(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        isSwapEnabled(overrides?: CallOverrides): Promise<BigNumber>;
        lastFundingTimes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        liquidatePosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _feeReceiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        liquidationFeeUsd(overrides?: CallOverrides): Promise<BigNumber>;
        marginFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        maxGasPrice(overrides?: CallOverrides): Promise<BigNumber>;
        maxGlobalShortSizes(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        maxLeverage(overrides?: CallOverrides): Promise<BigNumber>;
        maxUsdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        minProfitBasisPoints(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        minProfitTime(overrides?: CallOverrides): Promise<BigNumber>;
        mintBurnFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        poolAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        positions(arg0: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;
        priceFeed(overrides?: CallOverrides): Promise<BigNumber>;
        removeRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        reservedAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        router(overrides?: CallOverrides): Promise<BigNumber>;
        sellUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setBufferAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setError(_errorCode: BigNumberish, _error: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setErrorController(_errorController: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setFees(_taxBasisPoints: BigNumberish, _stableTaxBasisPoints: BigNumberish, _mintBurnFeeBasisPoints: BigNumberish, _swapFeeBasisPoints: BigNumberish, _stableSwapFeeBasisPoints: BigNumberish, _marginFeeBasisPoints: BigNumberish, _liquidationFeeUsd: BigNumberish, _minProfitTime: BigNumberish, _hasDynamicFees: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setFundingRate(_fundingInterval: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setInManagerMode(_inManagerMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setInPrivateLiquidationMode(_inPrivateLiquidationMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setIsLeverageEnabled(_isLeverageEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setIsSwapEnabled(_isSwapEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setLiquidator(_liquidator: string, _isActive: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setManager(_manager: string, _isManager: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setMaxGasPrice(_maxGasPrice: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setMaxGlobalShortSize(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setMaxLeverage(_maxLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setPriceFeed(_priceFeed: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setRebates(_rebates: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setTokenConfig(_token: string, _tokenDecimals: BigNumberish, _tokenWeight: BigNumberish, _minProfitBps: BigNumberish, _maxUsdgAmount: BigNumberish, _isStable: boolean, _isShortable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setUsdgAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setVaultUtils(_vaultUtils: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        shortableTokens(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        stableFundingRateFactor(overrides?: CallOverrides): Promise<BigNumber>;
        stableSwapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        stableTaxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        stableTokens(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        swap(_tokenIn: string, _tokenOut: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        swapFeeBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        swapWithRebateReceiver(_tokenIn: string, _tokenOut: string, _receiver: string, _rebateReceiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        taxBasisPoints(overrides?: CallOverrides): Promise<BigNumber>;
        tokenBalances(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        tokenDecimals(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        tokenToUsdMin(_token: string, _tokenAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        tokenWeights(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        totalTokenWeights(overrides?: CallOverrides): Promise<BigNumber>;
        updateCumulativeFundingRate(_collateralToken: string, _indexToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeVault(_newVault: string, _token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        usdToToken(_token: string, _usdAmount: BigNumberish, _price: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdToTokenMax(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdToTokenMin(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        usdg(overrides?: CallOverrides): Promise<BigNumber>;
        usdgAmounts(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        vaultUtils(overrides?: CallOverrides): Promise<BigNumber>;
        whitelistedTokenCount(overrides?: CallOverrides): Promise<BigNumber>;
        whitelistedTokens(arg0: string, overrides?: CallOverrides): Promise<BigNumber>;
        withdrawFees(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        addRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        adjustForDecimals(_amount: BigNumberish, _tokenDiv: string, _tokenMul: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        allWhitelistedTokens(arg0: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        allWhitelistedTokensLength(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        approvedRouters(arg0: string, arg1: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        bufferAmounts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        buyUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        clearTokenConfig(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        cumulativeFundingRates(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        decreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        directPoolDeposit(_token: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        errorController(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        feeReserves(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        fundingInterval(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        fundingRateFactor(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMaxPrice(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMinPrice(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getNextAveragePrice(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getNextFundingRate(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getNextGlobalShortAveragePrice(_indexToken: string, _nextPrice: BigNumberish, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPositionKey(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRedemptionAmount(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        globalShortAveragePrices(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        globalShortSizes(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        gov(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        guaranteedUsd(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        hasDynamicFees(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        inManagerMode(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        inPrivateLiquidationMode(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        increasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        initializeConfig(_router: string, _usdg: string, _priceFeed: string, _liquidationFeeUsd: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        isInitialized(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isLeverageEnabled(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isLiquidator(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isManager(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isSwapEnabled(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        lastFundingTimes(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        liquidatePosition(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _feeReceiver: string, signedQuoteData: BytesLike, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        liquidationFeeUsd(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        marginFeeBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxGasPrice(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxGlobalShortSizes(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxLeverage(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxUsdgAmounts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        minProfitBasisPoints(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        minProfitTime(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        mintBurnFeeBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        poolAmounts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        positions(arg0: BytesLike, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        priceFeed(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        removeRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        reservedAmounts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        router(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        sellUSDG(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setBufferAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setError(_errorCode: BigNumberish, _error: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setErrorController(_errorController: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setFees(_taxBasisPoints: BigNumberish, _stableTaxBasisPoints: BigNumberish, _mintBurnFeeBasisPoints: BigNumberish, _swapFeeBasisPoints: BigNumberish, _stableSwapFeeBasisPoints: BigNumberish, _marginFeeBasisPoints: BigNumberish, _liquidationFeeUsd: BigNumberish, _minProfitTime: BigNumberish, _hasDynamicFees: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setFundingRate(_fundingInterval: BigNumberish, _fundingRateFactor: BigNumberish, _stableFundingRateFactor: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setInManagerMode(_inManagerMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setInPrivateLiquidationMode(_inPrivateLiquidationMode: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setIsLeverageEnabled(_isLeverageEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setIsSwapEnabled(_isSwapEnabled: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setLiquidator(_liquidator: string, _isActive: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setManager(_manager: string, _isManager: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setMaxGasPrice(_maxGasPrice: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setMaxGlobalShortSize(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setMaxLeverage(_maxLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setPriceFeed(_priceFeed: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setRebates(_rebates: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setRouter(_router: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setTokenConfig(_token: string, _tokenDecimals: BigNumberish, _tokenWeight: BigNumberish, _minProfitBps: BigNumberish, _maxUsdgAmount: BigNumberish, _isStable: boolean, _isShortable: boolean, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setUsdgAmount(_token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setVaultUtils(_vaultUtils: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        shortableTokens(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        stableFundingRateFactor(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        stableSwapFeeBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        stableTaxBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        stableTokens(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        swap(_tokenIn: string, _tokenOut: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        swapFeeBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        swapWithRebateReceiver(_tokenIn: string, _tokenOut: string, _receiver: string, _rebateReceiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        taxBasisPoints(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        tokenBalances(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        tokenDecimals(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        tokenToUsdMin(_token: string, _tokenAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        tokenWeights(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalTokenWeights(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        updateCumulativeFundingRate(_collateralToken: string, _indexToken: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeVault(_newVault: string, _token: string, _amount: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        usdToToken(_token: string, _usdAmount: BigNumberish, _price: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usdToTokenMax(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usdToTokenMin(_token: string, _usdAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usdg(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usdgAmounts(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        vaultUtils(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        whitelistedTokenCount(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        whitelistedTokens(arg0: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdrawFees(_token: string, _receiver: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
    };
}
