import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface VaultLibraryInterface extends utils.Interface {
    functions: {
        "calculateInterest(address,address)": FunctionFragment;
        "canMint(address,address,address,uint256,uint256,uint256,uint256)": FunctionFragment;
        "doesMeetRatio(address,address)": FunctionFragment;
        "getCollateralForAmount(address,address,uint256)": FunctionFragment;
        "getCollateralShares(address,address)": FunctionFragment;
        "getCollateralTypesSortedByLiquidationRank()": FunctionFragment;
        "getCurrentRatio(address,address)": FunctionFragment;
        "getDebtAsEth(address,address)": FunctionFragment;
        "getDecimalsAmount(uint256,uint8,uint8)": FunctionFragment;
        "getFreeCollateralAsEth(address,address)": FunctionFragment;
        "getFreeCollateralAsEthFromMinimumRatio(address,address,uint256)": FunctionFragment;
        "getInterestDeltaR(address,address)": FunctionFragment;
        "getInterestRate(address,address)": FunctionFragment;
        "getLiquidationFee(address,address)": FunctionFragment;
        "getMinimumCollateral(uint256,uint256,uint256)": FunctionFragment;
        "getMinimumRatio(address,address)": FunctionFragment;
        "getNewMinimumRatio(address,address,address,uint256,uint256,bool)": FunctionFragment;
        "getTokenUnit(address)": FunctionFragment;
        "getTotalCollateralBalanceAsEth(address,address)": FunctionFragment;
        "handleAddress()": FunctionFragment;
        "initialize()": FunctionFragment;
        "owner()": FunctionFragment;
        "quickSort(uint256[],int256,int256)": FunctionFragment;
        "renounceOwnership()": FunctionFragment;
        "setHandleContract(address)": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "upgradeTo(address)": FunctionFragment;
        "upgradeToAndCall(address,bytes)": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "calculateInterest", values: [string, string]): string;
    encodeFunctionData(functionFragment: "canMint", values: [
        string,
        string,
        string,
        BigNumberish,
        BigNumberish,
        BigNumberish,
        BigNumberish
    ]): string;
    encodeFunctionData(functionFragment: "doesMeetRatio", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getCollateralForAmount", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getCollateralShares", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getCollateralTypesSortedByLiquidationRank", values?: undefined): string;
    encodeFunctionData(functionFragment: "getCurrentRatio", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getDebtAsEth", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getDecimalsAmount", values: [BigNumberish, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getFreeCollateralAsEth", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getFreeCollateralAsEthFromMinimumRatio", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getInterestDeltaR", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getInterestRate", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getLiquidationFee", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getMinimumCollateral", values: [BigNumberish, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getMinimumRatio", values: [string, string]): string;
    encodeFunctionData(functionFragment: "getNewMinimumRatio", values: [string, string, string, BigNumberish, BigNumberish, boolean]): string;
    encodeFunctionData(functionFragment: "getTokenUnit", values: [string]): string;
    encodeFunctionData(functionFragment: "getTotalCollateralBalanceAsEth", values: [string, string]): string;
    encodeFunctionData(functionFragment: "handleAddress", values?: undefined): string;
    encodeFunctionData(functionFragment: "initialize", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "quickSort", values: [BigNumberish[], BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "setHandleContract", values: [string]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeTo", values: [string]): string;
    encodeFunctionData(functionFragment: "upgradeToAndCall", values: [string, BytesLike]): string;
    decodeFunctionResult(functionFragment: "calculateInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "canMint", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "doesMeetRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getCollateralForAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getCollateralShares", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getCollateralTypesSortedByLiquidationRank", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getCurrentRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDebtAsEth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDecimalsAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFreeCollateralAsEth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFreeCollateralAsEthFromMinimumRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getInterestDeltaR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getInterestRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLiquidationFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMinimumCollateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMinimumRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getNewMinimumRatio", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTokenUnit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalCollateralBalanceAsEth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "handleAddress", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "quickSort", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setHandleContract", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "upgradeToAndCall", data: BytesLike): Result;
    events: {
        "AdminChanged(address,address)": EventFragment;
        "BeaconUpgraded(address)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "Upgraded(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "AdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "BeaconUpgraded"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Upgraded"): EventFragment;
}
export type AdminChangedEvent = TypedEvent<[
    string,
    string
], {
    previousAdmin: string;
    newAdmin: string;
}>;
export type AdminChangedEventFilter = TypedEventFilter<AdminChangedEvent>;
export type BeaconUpgradedEvent = TypedEvent<[string], {
    beacon: string;
}>;
export type BeaconUpgradedEventFilter = TypedEventFilter<BeaconUpgradedEvent>;
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], {
    previousOwner: string;
    newOwner: string;
}>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export type UpgradedEvent = TypedEvent<[string], {
    implementation: string;
}>;
export type UpgradedEventFilter = TypedEventFilter<UpgradedEvent>;
export interface VaultLibrary extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: VaultLibraryInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        calculateInterest(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        canMint(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, tokenAmount: BigNumberish, fxQuote: BigNumberish, collateralQuote: BigNumberish, overrides?: CallOverrides): Promise<[boolean]>;
        doesMeetRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<[boolean]>;
        getCollateralForAmount(account: string, fxToken: string, amountEth: BigNumberish, overrides?: CallOverrides): Promise<[
            string[],
            BigNumber[],
            boolean
        ] & {
            collateralTypes: string[];
            collateralAmounts: BigNumber[];
            metAmount: boolean;
        }>;
        getCollateralShares(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber[]] & {
            shares: BigNumber[];
        }>;
        getCollateralTypesSortedByLiquidationRank(overrides?: CallOverrides): Promise<[string[]] & {
            sortedCollateralTypes: string[];
        }>;
        getCurrentRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            ratio: BigNumber;
        }>;
        getDebtAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            debt: BigNumber;
        }>;
        getDecimalsAmount(amount: BigNumberish, fromDecimals: BigNumberish, toDecimals: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getFreeCollateralAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getFreeCollateralAsEthFromMinimumRatio(account: string, fxToken: string, minimumRatio: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getInterestDeltaR(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            dR: BigNumber;
        }>;
        getInterestRate(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            rate: BigNumber;
        }>;
        getLiquidationFee(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            fee: BigNumber;
        }>;
        getMinimumCollateral(tokenAmount: BigNumberish, ratio: BigNumberish, unitPrice: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber] & {
            minimum: BigNumber;
        }>;
        getMinimumRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            ratio: BigNumber;
        }>;
        getNewMinimumRatio(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, collateralQuote: BigNumberish, isDeposit: boolean, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            ratio: BigNumber;
            newCollateralAsEther: BigNumber;
        }>;
        getTokenUnit(token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getTotalCollateralBalanceAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<[BigNumber] & {
            balance: BigNumber;
        }>;
        handleAddress(overrides?: CallOverrides): Promise<[string]>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        quickSort(array: BigNumberish[], left: BigNumberish, right: BigNumberish, overrides?: CallOverrides): Promise<[void]>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
    };
    calculateInterest(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    canMint(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, tokenAmount: BigNumberish, fxQuote: BigNumberish, collateralQuote: BigNumberish, overrides?: CallOverrides): Promise<boolean>;
    doesMeetRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<boolean>;
    getCollateralForAmount(account: string, fxToken: string, amountEth: BigNumberish, overrides?: CallOverrides): Promise<[
        string[],
        BigNumber[],
        boolean
    ] & {
        collateralTypes: string[];
        collateralAmounts: BigNumber[];
        metAmount: boolean;
    }>;
    getCollateralShares(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber[]>;
    getCollateralTypesSortedByLiquidationRank(overrides?: CallOverrides): Promise<string[]>;
    getCurrentRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getDebtAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getDecimalsAmount(amount: BigNumberish, fromDecimals: BigNumberish, toDecimals: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getFreeCollateralAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getFreeCollateralAsEthFromMinimumRatio(account: string, fxToken: string, minimumRatio: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getInterestDeltaR(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getInterestRate(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getLiquidationFee(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getMinimumCollateral(tokenAmount: BigNumberish, ratio: BigNumberish, unitPrice: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getMinimumRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    getNewMinimumRatio(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, collateralQuote: BigNumberish, isDeposit: boolean, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        ratio: BigNumber;
        newCollateralAsEther: BigNumber;
    }>;
    getTokenUnit(token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getTotalCollateralBalanceAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
    handleAddress(overrides?: CallOverrides): Promise<string>;
    initialize(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    owner(overrides?: CallOverrides): Promise<string>;
    quickSort(array: BigNumberish[], left: BigNumberish, right: BigNumberish, overrides?: CallOverrides): Promise<void>;
    renounceOwnership(overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setHandleContract(_handle: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(newOwner: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeTo(newImplementation: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        calculateInterest(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        canMint(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, tokenAmount: BigNumberish, fxQuote: BigNumberish, collateralQuote: BigNumberish, overrides?: CallOverrides): Promise<boolean>;
        doesMeetRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<boolean>;
        getCollateralForAmount(account: string, fxToken: string, amountEth: BigNumberish, overrides?: CallOverrides): Promise<[
            string[],
            BigNumber[],
            boolean
        ] & {
            collateralTypes: string[];
            collateralAmounts: BigNumber[];
            metAmount: boolean;
        }>;
        getCollateralShares(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber[]>;
        getCollateralTypesSortedByLiquidationRank(overrides?: CallOverrides): Promise<string[]>;
        getCurrentRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getDebtAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getDecimalsAmount(amount: BigNumberish, fromDecimals: BigNumberish, toDecimals: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getFreeCollateralAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getFreeCollateralAsEthFromMinimumRatio(account: string, fxToken: string, minimumRatio: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getInterestDeltaR(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getInterestRate(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getLiquidationFee(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getMinimumCollateral(tokenAmount: BigNumberish, ratio: BigNumberish, unitPrice: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getMinimumRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNewMinimumRatio(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, collateralQuote: BigNumberish, isDeposit: boolean, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            ratio: BigNumber;
            newCollateralAsEther: BigNumber;
        }>;
        getTokenUnit(token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalCollateralBalanceAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        handleAddress(overrides?: CallOverrides): Promise<string>;
        initialize(overrides?: CallOverrides): Promise<void>;
        owner(overrides?: CallOverrides): Promise<string>;
        quickSort(array: BigNumberish[], left: BigNumberish, right: BigNumberish, overrides?: CallOverrides): Promise<void>;
        renounceOwnership(overrides?: CallOverrides): Promise<void>;
        setHandleContract(_handle: string, overrides?: CallOverrides): Promise<void>;
        transferOwnership(newOwner: string, overrides?: CallOverrides): Promise<void>;
        upgradeTo(newImplementation: string, overrides?: CallOverrides): Promise<void>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "AdminChanged(address,address)"(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        AdminChanged(previousAdmin?: null, newAdmin?: null): AdminChangedEventFilter;
        "BeaconUpgraded(address)"(beacon?: string | null): BeaconUpgradedEventFilter;
        BeaconUpgraded(beacon?: string | null): BeaconUpgradedEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: string | null, newOwner?: string | null): OwnershipTransferredEventFilter;
        "Upgraded(address)"(implementation?: string | null): UpgradedEventFilter;
        Upgraded(implementation?: string | null): UpgradedEventFilter;
    };
    estimateGas: {
        calculateInterest(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        canMint(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, tokenAmount: BigNumberish, fxQuote: BigNumberish, collateralQuote: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        doesMeetRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getCollateralForAmount(account: string, fxToken: string, amountEth: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getCollateralShares(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getCollateralTypesSortedByLiquidationRank(overrides?: CallOverrides): Promise<BigNumber>;
        getCurrentRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getDebtAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getDecimalsAmount(amount: BigNumberish, fromDecimals: BigNumberish, toDecimals: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getFreeCollateralAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getFreeCollateralAsEthFromMinimumRatio(account: string, fxToken: string, minimumRatio: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getInterestDeltaR(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getInterestRate(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getLiquidationFee(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getMinimumCollateral(tokenAmount: BigNumberish, ratio: BigNumberish, unitPrice: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getMinimumRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        getNewMinimumRatio(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, collateralQuote: BigNumberish, isDeposit: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getTokenUnit(token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getTotalCollateralBalanceAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<BigNumber>;
        handleAddress(overrides?: CallOverrides): Promise<BigNumber>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        quickSort(array: BigNumberish[], left: BigNumberish, right: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        calculateInterest(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        canMint(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, tokenAmount: BigNumberish, fxQuote: BigNumberish, collateralQuote: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        doesMeetRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getCollateralForAmount(account: string, fxToken: string, amountEth: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getCollateralShares(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getCollateralTypesSortedByLiquidationRank(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getCurrentRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getDebtAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getDecimalsAmount(amount: BigNumberish, fromDecimals: BigNumberish, toDecimals: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getFreeCollateralAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getFreeCollateralAsEthFromMinimumRatio(account: string, fxToken: string, minimumRatio: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getInterestDeltaR(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getInterestRate(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLiquidationFee(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMinimumCollateral(tokenAmount: BigNumberish, ratio: BigNumberish, unitPrice: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMinimumRatio(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getNewMinimumRatio(account: string, fxToken: string, collateralToken: string, collateralAmount: BigNumberish, collateralQuote: BigNumberish, isDeposit: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTokenUnit(token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalCollateralBalanceAsEth(account: string, fxToken: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        handleAddress(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        initialize(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        quickSort(array: BigNumberish[], left: BigNumberish, right: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        renounceOwnership(overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setHandleContract(_handle: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(newOwner: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeTo(newImplementation: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        upgradeToAndCall(newImplementation: string, data: BytesLike, overrides?: PayableOverrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
    };
}
