import { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import { FunctionFragment, Result } from "@ethersproject/abi";
import { Listener, Provider } from "@ethersproject/providers";
import { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface VaultUtilsInterface extends utils.Interface {
    functions: {
        "BASIS_POINTS_DIVISOR()": FunctionFragment;
        "FUNDING_RATE_PRECISION()": FunctionFragment;
        "MAX_WITHDRAWAL_COOLDOWN_DURATION()": FunctionFragment;
        "MIN_LEVERAGE_CAP()": FunctionFragment;
        "getBuyUsdgFeeBasisPoints(address,uint256)": FunctionFragment;
        "getDelta(address,uint256,uint256,bool,uint256)": FunctionFragment;
        "getEntryFundingRate(address,address,bool)": FunctionFragment;
        "getFeeBasisPoints(address,uint256,uint256,uint256,bool)": FunctionFragment;
        "getFundingFee(address,address,address,bool,uint256,uint256)": FunctionFragment;
        "getGlobalShortDelta(address)": FunctionFragment;
        "getPositionDelta(address,address,address,bool)": FunctionFragment;
        "getPositionFee(address,address,address,bool,uint256)": FunctionFragment;
        "getPositionLeverage(address,address,address,bool)": FunctionFragment;
        "getRedemptionCollateral(address)": FunctionFragment;
        "getRedemptionCollateralUsd(address)": FunctionFragment;
        "getSellUsdgFeeBasisPoints(address,uint256)": FunctionFragment;
        "getSwapFeeBasisPoints(address,address,uint256)": FunctionFragment;
        "getTargetUsdgAmount(address)": FunctionFragment;
        "getUtilisation(address)": FunctionFragment;
        "gov()": FunctionFragment;
        "minLeverage()": FunctionFragment;
        "setGov(address)": FunctionFragment;
        "setMinLeverage(uint256)": FunctionFragment;
        "setWithdrawalCooldownDuration(uint256)": FunctionFragment;
        "updateCumulativeFundingRate(address,address)": FunctionFragment;
        "validateDecreasePosition(address,address,address,uint256,uint256,bool,address)": FunctionFragment;
        "validateIncreasePosition(address,address,address,uint256,bool)": FunctionFragment;
        "validateLiquidation(address,address,address,bool,bool)": FunctionFragment;
        "vault()": FunctionFragment;
        "withdrawalCooldownDuration()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "BASIS_POINTS_DIVISOR", values?: undefined): string;
    encodeFunctionData(functionFragment: "FUNDING_RATE_PRECISION", values?: undefined): string;
    encodeFunctionData(functionFragment: "MAX_WITHDRAWAL_COOLDOWN_DURATION", values?: undefined): string;
    encodeFunctionData(functionFragment: "MIN_LEVERAGE_CAP", values?: undefined): string;
    encodeFunctionData(functionFragment: "getBuyUsdgFeeBasisPoints", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getDelta", values: [string, BigNumberish, BigNumberish, boolean, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getEntryFundingRate", values: [string, string, boolean]): string;
    encodeFunctionData(functionFragment: "getFeeBasisPoints", values: [string, BigNumberish, BigNumberish, BigNumberish, boolean]): string;
    encodeFunctionData(functionFragment: "getFundingFee", values: [string, string, string, boolean, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getGlobalShortDelta", values: [string]): string;
    encodeFunctionData(functionFragment: "getPositionDelta", values: [string, string, string, boolean]): string;
    encodeFunctionData(functionFragment: "getPositionFee", values: [string, string, string, boolean, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getPositionLeverage", values: [string, string, string, boolean]): string;
    encodeFunctionData(functionFragment: "getRedemptionCollateral", values: [string]): string;
    encodeFunctionData(functionFragment: "getRedemptionCollateralUsd", values: [string]): string;
    encodeFunctionData(functionFragment: "getSellUsdgFeeBasisPoints", values: [string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getSwapFeeBasisPoints", values: [string, string, BigNumberish]): string;
    encodeFunctionData(functionFragment: "getTargetUsdgAmount", values: [string]): string;
    encodeFunctionData(functionFragment: "getUtilisation", values: [string]): string;
    encodeFunctionData(functionFragment: "gov", values?: undefined): string;
    encodeFunctionData(functionFragment: "minLeverage", values?: undefined): string;
    encodeFunctionData(functionFragment: "setGov", values: [string]): string;
    encodeFunctionData(functionFragment: "setMinLeverage", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "setWithdrawalCooldownDuration", values: [BigNumberish]): string;
    encodeFunctionData(functionFragment: "updateCumulativeFundingRate", values: [string, string]): string;
    encodeFunctionData(functionFragment: "validateDecreasePosition", values: [
        string,
        string,
        string,
        BigNumberish,
        BigNumberish,
        boolean,
        string
    ]): string;
    encodeFunctionData(functionFragment: "validateIncreasePosition", values: [string, string, string, BigNumberish, boolean]): string;
    encodeFunctionData(functionFragment: "validateLiquidation", values: [string, string, string, boolean, boolean]): string;
    encodeFunctionData(functionFragment: "vault", values?: undefined): string;
    encodeFunctionData(functionFragment: "withdrawalCooldownDuration", values?: undefined): string;
    decodeFunctionResult(functionFragment: "BASIS_POINTS_DIVISOR", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "FUNDING_RATE_PRECISION", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MAX_WITHDRAWAL_COOLDOWN_DURATION", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MIN_LEVERAGE_CAP", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getBuyUsdgFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDelta", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getEntryFundingRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFundingFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getGlobalShortDelta", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPositionDelta", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPositionFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPositionLeverage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRedemptionCollateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRedemptionCollateralUsd", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getSellUsdgFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getSwapFeeBasisPoints", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTargetUsdgAmount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUtilisation", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "gov", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "minLeverage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setGov", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMinLeverage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setWithdrawalCooldownDuration", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateCumulativeFundingRate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "validateDecreasePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "validateIncreasePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "validateLiquidation", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "vault", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawalCooldownDuration", data: BytesLike): Result;
    events: {};
}
export interface VaultUtils extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: VaultUtilsInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        BASIS_POINTS_DIVISOR(overrides?: CallOverrides): Promise<[BigNumber]>;
        FUNDING_RATE_PRECISION(overrides?: CallOverrides): Promise<[BigNumber]>;
        MAX_WITHDRAWAL_COOLDOWN_DURATION(overrides?: CallOverrides): Promise<[BigNumber]>;
        MIN_LEVERAGE_CAP(overrides?: CallOverrides): Promise<[BigNumber]>;
        getBuyUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getDelta(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getEntryFundingRate(_collateralToken: string, arg1: string, arg2: boolean, overrides?: CallOverrides): Promise<[BigNumber]>;
        getFeeBasisPoints(_token: string, _usdgDelta: BigNumberish, _feeBasisPoints: BigNumberish, _taxBasisPoints: BigNumberish, _increment: boolean, overrides?: CallOverrides): Promise<[BigNumber]>;
        getFundingFee(arg0: string, _collateralToken: string, arg2: string, arg3: boolean, _size: BigNumberish, _entryFundingRate: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getGlobalShortDelta(_token: string, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getPositionDelta(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getPositionFee(arg0: string, arg1: string, arg2: string, arg3: boolean, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getPositionLeverage(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[BigNumber]>;
        getRedemptionCollateral(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getRedemptionCollateralUsd(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getSellUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getSwapFeeBasisPoints(_tokenIn: string, _tokenOut: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<[BigNumber]>;
        getTargetUsdgAmount(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        getUtilisation(_token: string, overrides?: CallOverrides): Promise<[BigNumber]>;
        gov(overrides?: CallOverrides): Promise<[string]>;
        minLeverage(overrides?: CallOverrides): Promise<[BigNumber]>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setMinLeverage(_minLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        setWithdrawalCooldownDuration(_withdrawalCooldownDuration: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        updateCumulativeFundingRate(arg0: string, arg1: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<ContractTransaction>;
        validateDecreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, arg6: string, overrides?: CallOverrides): Promise<[void]>;
        validateIncreasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<[void]>;
        validateLiquidation(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _raise: boolean, overrides?: CallOverrides): Promise<[BigNumber, BigNumber]>;
        vault(overrides?: CallOverrides): Promise<[string]>;
        withdrawalCooldownDuration(overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    BASIS_POINTS_DIVISOR(overrides?: CallOverrides): Promise<BigNumber>;
    FUNDING_RATE_PRECISION(overrides?: CallOverrides): Promise<BigNumber>;
    MAX_WITHDRAWAL_COOLDOWN_DURATION(overrides?: CallOverrides): Promise<BigNumber>;
    MIN_LEVERAGE_CAP(overrides?: CallOverrides): Promise<BigNumber>;
    getBuyUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getDelta(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
    getEntryFundingRate(_collateralToken: string, arg1: string, arg2: boolean, overrides?: CallOverrides): Promise<BigNumber>;
    getFeeBasisPoints(_token: string, _usdgDelta: BigNumberish, _feeBasisPoints: BigNumberish, _taxBasisPoints: BigNumberish, _increment: boolean, overrides?: CallOverrides): Promise<BigNumber>;
    getFundingFee(arg0: string, _collateralToken: string, arg2: string, arg3: boolean, _size: BigNumberish, _entryFundingRate: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getGlobalShortDelta(_token: string, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
    getPositionDelta(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
    getPositionFee(arg0: string, arg1: string, arg2: string, arg3: boolean, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getPositionLeverage(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
    getRedemptionCollateral(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getRedemptionCollateralUsd(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getSellUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getSwapFeeBasisPoints(_tokenIn: string, _tokenOut: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
    getTargetUsdgAmount(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    getUtilisation(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
    gov(overrides?: CallOverrides): Promise<string>;
    minLeverage(overrides?: CallOverrides): Promise<BigNumber>;
    setGov(_gov: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setMinLeverage(_minLeverage: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    setWithdrawalCooldownDuration(_withdrawalCooldownDuration: BigNumberish, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    updateCumulativeFundingRate(arg0: string, arg1: string, overrides?: Overrides & {
        from?: string | Promise<string>;
    }): Promise<ContractTransaction>;
    validateDecreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, arg6: string, overrides?: CallOverrides): Promise<void>;
    validateIncreasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<void>;
    validateLiquidation(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _raise: boolean, overrides?: CallOverrides): Promise<[BigNumber, BigNumber]>;
    vault(overrides?: CallOverrides): Promise<string>;
    withdrawalCooldownDuration(overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        BASIS_POINTS_DIVISOR(overrides?: CallOverrides): Promise<BigNumber>;
        FUNDING_RATE_PRECISION(overrides?: CallOverrides): Promise<BigNumber>;
        MAX_WITHDRAWAL_COOLDOWN_DURATION(overrides?: CallOverrides): Promise<BigNumber>;
        MIN_LEVERAGE_CAP(overrides?: CallOverrides): Promise<BigNumber>;
        getBuyUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getDelta(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getEntryFundingRate(_collateralToken: string, arg1: string, arg2: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getFeeBasisPoints(_token: string, _usdgDelta: BigNumberish, _feeBasisPoints: BigNumberish, _taxBasisPoints: BigNumberish, _increment: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getFundingFee(arg0: string, _collateralToken: string, arg2: string, arg3: boolean, _size: BigNumberish, _entryFundingRate: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getGlobalShortDelta(_token: string, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getPositionDelta(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<[boolean, BigNumber]>;
        getPositionFee(arg0: string, arg1: string, arg2: string, arg3: boolean, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getPositionLeverage(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getRedemptionCollateral(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getRedemptionCollateralUsd(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getSellUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getSwapFeeBasisPoints(_tokenIn: string, _tokenOut: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getTargetUsdgAmount(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getUtilisation(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        gov(overrides?: CallOverrides): Promise<string>;
        minLeverage(overrides?: CallOverrides): Promise<BigNumber>;
        setGov(_gov: string, overrides?: CallOverrides): Promise<void>;
        setMinLeverage(_minLeverage: BigNumberish, overrides?: CallOverrides): Promise<void>;
        setWithdrawalCooldownDuration(_withdrawalCooldownDuration: BigNumberish, overrides?: CallOverrides): Promise<void>;
        updateCumulativeFundingRate(arg0: string, arg1: string, overrides?: CallOverrides): Promise<boolean>;
        validateDecreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, arg6: string, overrides?: CallOverrides): Promise<void>;
        validateIncreasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<void>;
        validateLiquidation(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _raise: boolean, overrides?: CallOverrides): Promise<[BigNumber, BigNumber]>;
        vault(overrides?: CallOverrides): Promise<string>;
        withdrawalCooldownDuration(overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {};
    estimateGas: {
        BASIS_POINTS_DIVISOR(overrides?: CallOverrides): Promise<BigNumber>;
        FUNDING_RATE_PRECISION(overrides?: CallOverrides): Promise<BigNumber>;
        MAX_WITHDRAWAL_COOLDOWN_DURATION(overrides?: CallOverrides): Promise<BigNumber>;
        MIN_LEVERAGE_CAP(overrides?: CallOverrides): Promise<BigNumber>;
        getBuyUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getDelta(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getEntryFundingRate(_collateralToken: string, arg1: string, arg2: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getFeeBasisPoints(_token: string, _usdgDelta: BigNumberish, _feeBasisPoints: BigNumberish, _taxBasisPoints: BigNumberish, _increment: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getFundingFee(arg0: string, _collateralToken: string, arg2: string, arg3: boolean, _size: BigNumberish, _entryFundingRate: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getGlobalShortDelta(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getPositionDelta(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getPositionFee(arg0: string, arg1: string, arg2: string, arg3: boolean, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getPositionLeverage(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        getRedemptionCollateral(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getRedemptionCollateralUsd(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getSellUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getSwapFeeBasisPoints(_tokenIn: string, _tokenOut: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;
        getTargetUsdgAmount(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        getUtilisation(_token: string, overrides?: CallOverrides): Promise<BigNumber>;
        gov(overrides?: CallOverrides): Promise<BigNumber>;
        minLeverage(overrides?: CallOverrides): Promise<BigNumber>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setMinLeverage(_minLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        setWithdrawalCooldownDuration(_withdrawalCooldownDuration: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        updateCumulativeFundingRate(arg0: string, arg1: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<BigNumber>;
        validateDecreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, arg6: string, overrides?: CallOverrides): Promise<BigNumber>;
        validateIncreasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        validateLiquidation(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _raise: boolean, overrides?: CallOverrides): Promise<BigNumber>;
        vault(overrides?: CallOverrides): Promise<BigNumber>;
        withdrawalCooldownDuration(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        BASIS_POINTS_DIVISOR(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        FUNDING_RATE_PRECISION(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        MAX_WITHDRAWAL_COOLDOWN_DURATION(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        MIN_LEVERAGE_CAP(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getBuyUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getDelta(_indexToken: string, _size: BigNumberish, _averagePrice: BigNumberish, _isLong: boolean, _lastIncreasedTime: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getEntryFundingRate(_collateralToken: string, arg1: string, arg2: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getFeeBasisPoints(_token: string, _usdgDelta: BigNumberish, _feeBasisPoints: BigNumberish, _taxBasisPoints: BigNumberish, _increment: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getFundingFee(arg0: string, _collateralToken: string, arg2: string, arg3: boolean, _size: BigNumberish, _entryFundingRate: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getGlobalShortDelta(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPositionDelta(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPositionFee(arg0: string, arg1: string, arg2: string, arg3: boolean, _sizeDelta: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPositionLeverage(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRedemptionCollateral(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRedemptionCollateralUsd(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getSellUsdgFeeBasisPoints(_token: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getSwapFeeBasisPoints(_tokenIn: string, _tokenOut: string, _usdgAmount: BigNumberish, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTargetUsdgAmount(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUtilisation(_token: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        gov(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        minLeverage(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        setGov(_gov: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setMinLeverage(_minLeverage: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        setWithdrawalCooldownDuration(_withdrawalCooldownDuration: BigNumberish, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        updateCumulativeFundingRate(arg0: string, arg1: string, overrides?: Overrides & {
            from?: string | Promise<string>;
        }): Promise<PopulatedTransaction>;
        validateDecreasePosition(_account: string, _collateralToken: string, _indexToken: string, _collateralDelta: BigNumberish, _sizeDelta: BigNumberish, _isLong: boolean, arg6: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        validateIncreasePosition(_account: string, _collateralToken: string, _indexToken: string, _sizeDelta: BigNumberish, _isLong: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        validateLiquidation(_account: string, _collateralToken: string, _indexToken: string, _isLong: boolean, _raise: boolean, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        vault(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdrawalCooldownDuration(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
