export declare const networks: readonly ["ethereum", "arbitrum", "polygon", "arbitrum-sepolia"];
export declare const singleCollateralVaultNetworks: readonly ["polygon", "arbitrum"];
export declare const mainNetworks: readonly ["arbitrum"];
export declare const referralsNetworks: readonly ["arbitrum-sepolia"];
export declare const tradeNetworks: readonly ["arbitrum", "arbitrum-sepolia"];
export declare const hlpNetworks: Network[];
export declare const bridgeNetworks: readonly ["ethereum", "arbitrum", "polygon"];
export declare const routerTransferProxyNetworks: readonly ["arbitrum", "arbitrum-sepolia"];
export type Network = typeof networks[number];
export type SingleCollateralVaultNetwork = typeof singleCollateralVaultNetworks[number];
export type ConvertNetwork = Network;
export type MainNetwork = typeof mainNetworks[number];
export type TokenTransferProxyNetwork = typeof routerTransferProxyNetworks[number];
export type ReferralsNetwork = typeof referralsNetworks[number];
export type TradeNetwork = typeof tradeNetworks[number];
export type HlpNetwork = typeof hlpNetworks[number];
export type BridgeNetwork = typeof bridgeNetworks[number];
export type NetworkMap<T> = {
    [key in Network]: T;
};
export type ConvertNetworkMap<T> = {
    [key in ConvertNetwork]: T;
};
export type BridgeNetworkMap<T> = {
    [key in BridgeNetwork]: T;
};
export type SingleCollateralVaultNetworkMap<T> = {
    [key in SingleCollateralVaultNetwork]: T;
};
export declare const parseMainNetwork: (network: Network) => MainNetwork;
export declare const isMainNetwork: (network: Network) => boolean;
