import { BigNumber } from "ethers";
export type RewardPool = {
    id: number;
    ratio: BigNumber;
    accruedAmount: BigNumber;
    deltaS: BigNumber;
    averagePoolBoost: number;
    userBoost: number | undefined;
};
export type RewardPoolMap = Record<string, RewardPool>;
export type RewardPoolDeposit = {
    userDeposited: BigNumber;
    totalDeposited: BigNumber;
};
export type RewardPoolData = {
    pools: RewardPoolMap;
    forexDistributionRate: BigNumber;
    account?: {
        claimableRewards: BigNumber;
        poolRewards: Record<string, BigNumber>;
        rewardPoolDeposits: Record<string, RewardPoolDeposit>;
    };
};
export type RewardPoolRaw = {
    name: string;
    weight: BigNumber;
    assetType: number;
    assetAddress: string;
    totalDeposits: BigNumber;
    totalRealDeposits: BigNumber;
    S: BigNumber;
};
