import { BigNumber } from "ethers";
export type Pair = {
    baseSymbol: string;
    quoteSymbol: string;
};
export type PairStringified = string;
export type WebsocketPrice = {
    pair: Pair;
    value: BigNumber;
    timestamp: number;
};
export type SignedQuote = {
    pair: Pair;
    signatureParams: SignedQuoteParams;
    signature: Uint8Array;
};
export type SignedQuoteParams = {
    value: BigNumber;
    signedTimestamp: BigNumber;
    chainId: number;
    validFromTimestamp: BigNumber;
    durationSeconds: BigNumber;
};
