import { HandleTokenManagerInstance } from "../components/token-manager/HandleTokenManager";
export const getTokensFromConfig = (addresses) => {
    return HandleTokenManagerInstance.getTokensByAddresses(addresses.map((address) => ({ address })));
};
export const getCollateralByAddress = (collaterals, address) => {
    const collateral = collaterals.find((collateral) => collateral.address.toLowerCase() === address.toLowerCase());
    if (!collateral) {
        throw new Error(`Could not find collateral: ${address}`);
    }
    return collateral;
};
export const getCollateralBySymbol = (collaterals, symbol) => {
    const collateral = collaterals.find((collateral) => collateral.symbol === symbol);
    if (!collateral) {
        throw new Error(`Could not find collateral: ${symbol}`);
    }
    return collateral;
};
