import { ethers, Signer } from "ethers";
import { Provider as MultiCallProvider } from "ethers-multicall";
import { ERC20, Handle, VaultLibrary, Comptroller, FxKeeperPool, GovernanceLock, RewardPool, BalancerVault } from "../contracts";
import { ProtocolContractAddressMap } from "../config";
import { Promisified } from "../types/general";
import { Provider } from "@ethersproject/providers";
import { Network } from "../types/network";
type ProtocolContracts = {
    handle: Handle;
    vaultLibrary: VaultLibrary;
    comptroller: Comptroller;
    fxKeeperPool: FxKeeperPool;
    governanceLock: GovernanceLock;
    governanceLockRetired: GovernanceLock;
    rewardPool: RewardPool;
};
export declare const createMultiCallContract: <T>(address: string, abi: any) => T;
export declare const createERC20MulticallContract: (address: string) => ERC20;
export declare const getMulticallProtocolContracts: (signer?: Signer, network?: Network) => {
    provider: MultiCallProvider;
    contracts: ProtocolContracts;
};
export declare const createMulticallProtocolContracts: (protocolAddresses: ProtocolContractAddressMap, chainId: number, signerOrProvider: Signer | Provider) => {
    provider: MultiCallProvider;
    contracts: ProtocolContracts;
};
export declare const getCdpContracts: (protocolAddresses: ProtocolContractAddressMap, signer: ethers.Signer) => {
    handle: Handle;
    vaultLibrary: VaultLibrary;
    comptroller: Comptroller;
    treasury: import("../contracts").Treasury;
};
export declare const getGovernanceLockContract: (signerOrProvider?: Signer | Provider, isRetired?: boolean) => GovernanceLock;
export declare const getRewardPoolContract: (signerOrProvider?: Signer | Provider) => RewardPool;
export declare const callMulticallObject: <T>(callObject: Promisified<T>, provider: MultiCallProvider) => Promise<T>;
export declare const callMulticallObjects: <T>(callObjects: Promisified<T>[], provider: MultiCallProvider) => Promise<T[]>;
export declare const fetchPromisifiedObject: <T>(object: Promisified<T>) => Promise<T>;
export declare const multicallResponsesToObjects: <T>(callObjects: Promisified<T>[], results: any[]) => T[];
export declare const getBalancerVaultContract: () => BalancerVault;
export {};
