import { TokenInfo } from "..";
import { FxToken } from "../types/fxTokens";
export declare const getFxTokensFromAddresses: (addresses: string[]) => TokenInfo[];
export declare const getFxTokenSymbolFromAddress: (address: string, config: Record<string, string>) => string;
export declare const getFxTokenByAddress: (fxTokens: FxToken[], address: string) => FxToken;
export declare const getFxTokenBySymbol: (fxTokens: FxToken[], symbol: string) => FxToken;
export declare const isFxTokenSymbol: (symbol: string) => boolean;
/**
 * Returns the underlying fiat currency symbol for an fxToken.
 * Throws if the symbol is not an fxToken.
 * @param symbol The fxToken symbol.
 * @example getUnderlyingFxSymbol("fxAUD") // "AUD"
 */
export declare const getUnderlyingFxSymbol: (symbol: string) => string;
/**
 * Returns the underlying fiat currency symbol for an fxToken
 * @param symbol The fxToken symbol.
 * @example stripFx("fxAUD") // "AUD"
 */
export declare const stripFx: (symbol: string) => string;
