import { Network } from "../types/network";
type Period = "hourly" | "daily" | "weekly" | "total";
type HistoricalHlpData = {
    timestamp: number;
    aum: number;
    hlpSupply: number;
    hlpPrice: number;
    cumulativeDistributedEthPerGlp: number;
    cumulativeDistributedUsdPerGlp: number;
    distributedUsdPerGlp: number;
    distributedEthPerGlp: number;
    glpSupplyChange: number;
    aumChange: number;
};
/**
 * @param from The minimum timestamp (in seconds) to fetch data
 * @param to The maximum timestamp (in seconds) to fetch data
 * @param network The network on which to fetch data
 * @returns historic hlp data
 */
export declare const getHistoricHlpData: (from: number, to: number, network: Network, period?: Period) => Promise<HistoricalHlpData[]>;
export {};
