import { ethers } from "ethers";
import { Promisified } from "../types/general";
import { TokenInfo } from "@uniswap/token-lists";
import { KashiPoolConfig } from "../config";
import { SingleCollateralVaultData } from "../types/vaults";
import { FxToken } from "../types/fxTokens";
export type KashiPair = {
    account: string;
    collateralAsset: TokenInfo;
    borrowAsset: FxToken;
    interestPerYear: ethers.BigNumber;
    availableToBorrow: ethers.BigNumber;
    currentBorrowAmount: ethers.BigNumber;
    totalCollateralShare: ethers.BigNumber;
    exchangeRate: ethers.BigNumber;
    accountSpecific: {
        borrowedAmount: ethers.BigNumber;
        collateralAmount: ethers.BigNumber;
    };
};
export type AccureInfo = {
    interestPerSecond: ethers.BigNumber;
    lastAccrued: ethers.BigNumber;
};
export type ElasticBase = {
    elastic: ethers.BigNumber;
    base: ethers.BigNumber;
};
type KashiMulticallRequestAndResponse = {
    accureInfo: AccureInfo;
    totalAsset: ElasticBase;
    totalBorrow: ElasticBase;
    totalCollateralShare: ethers.BigNumber;
    userBorrowPart: ethers.BigNumber;
    userCollateralShare: ethers.BigNumber;
    exchangeRate: ethers.BigNumber;
    collateralTotals: ElasticBase;
};
export declare const getKashiPoolMulticall: (account: string, pool: KashiPoolConfig, chainId: number) => Promisified<KashiMulticallRequestAndResponse>;
export declare const kashiMulticallResultToSingleCollateralVaultData: (account: string, config: KashiPoolConfig, data: KashiMulticallRequestAndResponse) => SingleCollateralVaultData;
export {};
