import { BigNumber } from "ethers";
import { MarketPrice } from "../components/trade/platforms/legacyInterface";
export declare const toUsEasternTime: (date: Date) => Date;
export declare const isTradeWeekend: (date?: Date) => boolean;
export declare const isHlpMarketClosed: (symbol: string) => boolean;
export declare const getUsdTokenAmount: (usdPrice: BigNumber, tokenAmount: BigNumber) => BigNumber;
export declare const getTokenAmount: (usdPrice: BigNumber, usdAmount: BigNumber, tokenDecimals: number) => BigNumber;
/**
 * Gets the correct price from a spread price for a position.
 * @param isLong Whether the position is long.
 * @param isIncreasing Whether the position is being increased.
 * @param price The market price for the position.
 * @param slippage The slippage, as a percentage, to apply to the price.
 */
export declare const getActionPrice: (isLong: boolean, isIncreasing: boolean, price: MarketPrice, slippage?: number) => BigNumber;
export declare const applySlippage: (value: BigNumber, slippage: number, isLoweringValue: boolean) => BigNumber;
