import { Contract, ContractInterface, ContractReceipt, ethers, Signer } from "ethers";
import { Network } from "../types/network";
import { WETH } from "../contracts";
import { SignerOrProvider } from "./general";
import { Provider } from "@ethersproject/providers";
import { TypedEvent } from "../contracts/common";
export declare const REJECTED_ACTION_CODE_TEXT = "ACTION_REJECTED";
export declare const REJECTED_ACTION_CODE = 4001;
export declare const didUserCancelTransaction: (error: unknown) => boolean;
export declare const getNetworkName: (network: ethers.providers.Network) => Network;
export declare const getWrappedNativeToken: (network: Network, signerOrProvider: SignerOrProvider) => WETH;
export declare const getProvider: (signerOrProvider: Signer | Provider) => Provider;
/**
 * Ensures that the signer has the same network as one of the input networks.
 * @return The signer's network.
 */
export declare const validateNetworkType: <T extends string>(signerOrProvider: Signer | Provider, validNetworks: readonly T[]) => Promise<T>;
export declare const getEventData: <T extends TypedEvent<any, any>>(eventName: string, contract: Contract | ContractInterface, receipt: ContractReceipt) => T | null;
