import websocket from "websocket";
const SOCKET_PING_INTERVAL = 5000;
export const setupPingInterval = (socket) => {
    const intervalRef = { id: null };
    intervalRef.id = setInterval(() => {
        const isConnected = socket.readyState === websocket.w3cwebsocket.OPEN;
        if (!isConnected && intervalRef.id) {
            clearTimeout(intervalRef.id);
            intervalRef.id = null;
        }
        else {
            socket.send("ping");
        }
    }, SOCKET_PING_INTERVAL);
};
